;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Project 1: ROM Manager
;;



                .include    "jaguar.inc"
                .text
		
ob_list			equ	$1f0000
ob_list1		equ	$1f8000
objs			equ 32

depack_addr		equ	$f000

		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Code entrypoint
;;

top_of_the_code:
				moveq	#0,d0
				move.l	d0,$1000

                jsr     InitVideo               			; Setup our video registers.				
				bsr		shut_down_gpu
				
				lea		$802000,a0
.find:			cmp.w	#'DI',(a0)+
				bne.s	.find
				cmp.w	#'GI',(a0)+
				bne.s	.find
				move.l	a0,$1008							; sample base
				add.l	#1+4+1199479,a0
				move.l	a0,intro_addr						; intro base
				add.l	4(a0),a0
				add.l	#5,a0
				move.l	a0,levl1_addr						; level 1 base
				
                lea     $2f00,a7         					; set up stack

				move.w	#%0000011011000111,VMODE			; 320x256!!

				bsr 	info_init
				bsr		hobs_bitmap
												
hobs_jump:		lea		$f00400,a0
				move.l	#127,d7
.killpalt:		move.l	#0,(a0)+
				dbra	d7,.killpalt

				bsr		InstallGPUCode
				bsr     MakeObjectList          			; Create bit magled list for OP

				jsr		musicplayer
				move.l	$1100,d0							; loader music is a sample - so set sample 
				jsr		musicplayer+$14
				move.l	$1100,d0							; volume to desired music level
				jsr		musicplayer+$18
				
				move.l	#reboot_x_top,reboot_ptr
				move.l	#reboot_x_top,reboot_ptr2
				move.l	#224+30+30,object_offset
				move.l	#-7,wb_direction
				move.l	#-1,no_tracking
				move.l	#-1,start_dist
				
				move.l	display_obj,a0
				move.l	#(12+32)+64,d0
				move.l	#(32+16)+125+224,d1
				bsr		setup_object_xy
				
				move.l	workbench_obj,a0
				move.l	#34,d0
				move.l	#32+16+224,d1
				bsr		setup_object_xy

				move.l  #G_OPENA,G_FLAGS        			; Enable GPU Ints from OP
                move.l  #G_RAM+$80,G_PC         			; Setup GPU PC
                move.l  #GPUGO,G_CTRL           			; Run the GPU
				
                move.l  #VB_INTERUPT,LEVEL0     			; Install 68K LEVEL0 handler

                bsr     wait_frame              			; Stop the OP from freaking

                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!
				
				bsr		fadepal_down
				
				moveq	#0,d0
				moveq	#0,d1
				moveq	#0,d2
				moveq	#0,d3
				moveq	#0,d4
				moveq	#0,d5
				moveq	#0,d6
				move.l	d0,a1
				move.l	d0,a2
				move.l	d0,a3
				move.l	d0,a4
				move.l	d0,a5
				move.l	d0,a6
				lea		$1f0000,a0
				move.l	#($1f0000-depack_addr)/52,d7
.zero:			movem.l	d0-d6/a1-a6,-(a0)
				subq.l	#1,d7
				bne.s	.zero
				
				lea		pleaspal,a0
				lea		new_pallette,a1
				move.l	#7,d7
.instpal:		move.l	(a0)+,(a1)+
				dbra	d7,.instpal

				lea		workbench_pal,a0
				lea		new_pallette+(32*14),a1
				move.l	#7,d7
.instpal2:		move.l	(a0)+,(a1)+
				dbra	d7,.instpal2
				
				move.l	$1000,d0
				lea		TXT_addr_tabl,a1
				add.w	d0,d0
				add.w	d0,d0
				move.l	(a1,d0.w),a1
				bsr		info
				
dubmood1_len			equ	98690
alerted_mod_len			equ 317216		
dubmood1_off			equ	0
alerted_mod_off			equ	dubmood1_off+dubmood1_len
ambush_mod_off			equ	alerted_mod_off+alerted_mod_len
		
;				move.l	#sample_e-sample,d0
;				move.l	d0,d1
;				moveq	#0,d2
;				moveq	#0,d3
;				move.l	#$1ac/2,d4
;				lea		sample,a0
;				lea		sample,a1
;				jsr		musicplayer+$c

				move.l	$1008,a0
				add.l	#ambush_mod_off,a0
				jsr     musicplayer+4
				
				move.l	#1,no_tracking
				lea		new_pallette,a1
				bsr		fadepal_up

				move.l	#1,start_dist
				
				move.l	$1000,d0
				lea		ROM_addr_tabl,a1
				add.w	d0,d0
				add.w 	d0,d0
				move.l	(a1,d0.w),a0

				cmp.l	#'ICE!',(a0)
				beq.s	ok
error:
				add.w	#$1111,$f00402+(32*15)
				bra.s	error
	
ok:				lea		depack_addr-$a8,a1
				bsr		unpacker

				
.holder:		jsr		readpad
				jsr		handle_input
				
				tst.w	dpad_c
				bne		.load_pause

				bsr 	fadepal_down

				moveq	#0,d0							; 0 volume 
				jsr		musicplayer+$14
				moveq	#0,d0							; 0 volume
				jsr		musicplayer+$18
				
				bsr		shut_down_gpu

				jmp		depack_addr

	
.load_pause:	lea		paused,a1
				bsr 	info
				bra		.holder

shut_down_gpu:	move.l	#VB_NULL,LEVEL0

                move.w  a_vde,d0                			; Must be ODD
                sub.w   #16,d0
                ori.w   #1,d0
                move.w  d0,VI

                move.w  #1,INT1                 			; Enable video interrupts
                and.w   #$f8ff,sr
				
				bsr		.huge_delay
				
				move.l	#1,kill_dsp
				move.l	#1,gpu_halt

				bsr		.huge_delay
				
				move.l	#VB_NULL2,LEVEL0
				
				rts
				
.huge_delay:	move.l	#$90000,d7
.tbird_sucks_cocks_in_hell:
				nop
				subq.l	#1,d7
				bne.s	.tbird_sucks_cocks_in_hell
				rts
				
;sample:
;			incbin "ASSETS/SND/dub8ks.raw"
;			even
;sample_e:
				
				.dphrase
stopob_list:	dc.l	$0,$4
VB_NULL:		add.w	#1,ticks
				move.l	d0,-(a7)
				move.l	#stopob_list,d0
				swap.w	d0
				move.l	d0,OLP
				move.l	(a7)+,d0
				move.l	#$0,G_CTRL
				move.l	#$0,G_FLAGS
				move.l	#$0,D_CTRL
				move.l	#$0,D_FLAGS
VB_NULL2:		move.w	#$101,INT1
				move.w	#0,INT2
				rte
				
ROM_addr_tabl:	
intro_addr:		dc.l	$802000+$12fb52			; INTRO (#0)
levl1_addr:		dc.l	$802000+$149e76			; LEVEL 1 (#1)

TXT_addr_tabl:
				dc.l	unpa_intro
				dc.l	unpa_l1
				
unpa_intro:		dc.l	0
				dc.b    "Unpacking Credits",-1
				.even
				
unpa_l1:		dc.l	0
				dc.b	"Unpacking Level 1",-1
				.even
				
paused:			dc.l	0
				dc.b    "Enter Easter Egg!",-1
				.even
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position and bitmap in d2
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
;; d2=bitmap address
;;
				
setup_object_xyg: 
.offsdone:		and.w	#%111111111111,d0					; mask x value only (for negatives)
				and.w	#%1111111111,d1						; and again (y)
				move.w  6(a0),d4                			; get y-pos
               and.w   #$c007,d4
               move.w  14(a0),d6               			; get x-pos
               and.w   #$f000,d6
                add.w   d1,d1
                lsl.w   #3,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)							; update in object data
                move.w  d6,14(a0)

;						  01234567890123456789012345678912
				lsl.l	#8,d2
				move.l	(a0),d0
				and.l	#%00000000000000000000011111111111,d0	; clear existing address
				or.l	d2,d0

				move.l	d0,(a0)								; update object GFX pointer
				
               rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
				
setup_object_xy:
				and.w	#%111111111111,d0
				and.w	#%1111111111,d1
				move.w  6(a0),d4                			; get y-pos
                and.w   #$c007,d4
                move.w  14(a0),d6               			; get x-pos
                and.w   #$f000,d6
                add.w   d1,d1
                lsl.w   #3,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)							; update in object data
                move.w  d6,14(a0)
				rts
								
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Wait for a VBL
;;

wait_frame:     move.w  d7,-(a7)
                move.w  ticks,d7
.wait:          cmp.w   ticks,d7
                beq.s   .wait
                move.w  (a7)+,d7
                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Pallette Routine: fade to black
;;

fadepal_down:   move.w  #32,d6
.dofader:
                bsr     wait_frame

				lea     $f00400,a0      ; hardware pallette
                move.w  #255,d7         ; 254 colours
.palloop:       move.w  (a0),d0     
                move.w  d0,d1
                move.w  d0,d2
                and.w   #%1111100000000000,d0
                and.w   #%0000011111000000,d1
                and.w   #%0000000000111110,d2
.d0:            tst.w   d0
                beq.s   .d1
                sub.w   #%0000100000000000,d0
.d1:            tst.w   d1
                beq.s   .d2
                sub.w   #%0000000001000000,d1
.d2:            tst.w   d2
                beq.s   .merge
                sub.w   #%0000000000000010,d2
.merge:         or.w    d1,d0
                or.w    d2,d0
				cmp.l	#$f00400,a0
				bne.s	.noback
				move.w	d0,BG
.noback:        move.w  d0,(a0)+
                dbf     d7,.palloop
				bsr		animate_wb
                dbf     d6,.dofader
				
				lea		$f00400,a0
				move.l	#127,d0
.forceblk:		clr.l	(a0)+
				dbra	d0,.forceblk
				
                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Pallette Routine: fade from black to required pallette
;;

fadepal_up:     move.w  #32,d6
                move.l  a1,a4
.dofader2:
                bsr     wait_frame
				lea     $f00400,a0      ; hardware pallette
                move.l  a4,a1
                move.w  #255,d7         ; 254 colours
.palloop2:      move.w  (a0),d0         ; word in pallette     
                move.w  (a1)+,d3        ; required word
                move.w  d0,d1
                move.w  d0,d2
                move.w  d3,d4
                move.w  d3,d5
                and.w   #%1111100000000000,d0
                and.w   #%0000011111000000,d1
                and.w   #%0000000000111110,d2
                and.w   #%1111100000000000,d3
                and.w   #%0000011111000000,d4
                and.w   #%0000000000111110,d5
.d0_1:          cmp.w   d0,d3
                beq.s   .d1_2
                add.w   #%0000100000000000,d0
.d1_2:          cmp.w   d1,d4
                beq.s   .d2_3
                add.w   #%0000000001000000,d1
.d2_3:          cmp.w   d2,d5
                beq.s   .merge_2
                add.w   #%0000000000000010,d2
.merge_2:       or.w    d1,d0
                or.w    d2,d0
				cmp.l	#$f00400,a0
				bne.s	.noback
				move.w	d0,BG
.noback:        move.w  d0,(a0)+
                dbf     d7,.palloop2
				bsr		animate_wb
                dbf     d6,.dofader2
				move.l	#7,wb_direction
                rts
				
	
wb_direction:	dc.l	-7
object_offset:	dc.l	224

animate_wb:		tst.l	no_tracking
				bpl.s	.do
				rts
.do:
				movem.l	d0-d7/a0-a6,-(a7)
				move.l	display_obj,a0
				move.l	#(12)+48,d0
				move.l	#(32+16)+70,d1
				add.l	object_offset,d1
				bsr		setup_object_xy

				move.l	workbench_obj,a0
				move.l	#40,d0
				move.l	#32+16,d1
				add.l	object_offset,d1
				bsr		setup_object_xy
				move.l	wb_direction,d0
				add.l	d0,object_offset
				movem.l	(a7)+,d0-d7/a0-a6
				rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Vertical Blank Interupt (At least it happens every frame somewhere......)
;;

VB_INTERUPT:    movem.l d0-d7/a0-a6,-(a7)

				tst.l	no_tracking
				bmi.s	.skip
				jsr		do_please_wait
.skip:
			
                jsr     copy_olist              			; use Blitter to update active list from shadow
				
			
				move.l	reboot_ptr2,a0

				add.l	#2,a0
				cmp.l	#reboot_x_end,a0
				bne.s	.nowrap
				lea		reboot_x,a0
.nowrap:		move.l	a0,reboot_ptr2
				move.l	a0,reboot_ptr
			
				jsr		musicplayer+$8
			
				sub.w	#1,ticks
			
.done_vbl:      move.w  #$101,INT1              			; Signal we're done
                move.w  #$0,INT2
                
                movem.l (a7)+,d0-d7/a0-a6
                rte	

pleasewait_bmps:	
				dc.l	pleaswit+56			; t
				dc.l	pleaswit+48			; i
				dc.l	pleaswit+24			; a
				dc.l	pleaswit+40			; w
				dc.l	pleaswit+16			; e
				dc.l	pleaswit+32			; s
				dc.l	pleaswit+24			; a
				dc.l	pleaswit+16			; e
				dc.l	pleaswit+8			; l
				dc.l	pleaswit			; p		

				.phrase
pleaswit:		incbin "ASSETS/GFX/JAG/loadwai4.jag"
				.phrase
pleaspal:		incbin "ASSETS/GFX/JAG/loadlogo.pal"
				.phrase
workbench_pal:	incbin "ASSETS/GFX/JAG/loadwai4.pal"
				.even
				
do_please_wait:	lea		please_objs,a6
				lea		x_ptrs,a5
				lea		y_ptrs,a4
				move.l	#9,d7
.update:		move.l	(a6)+,a0		; get obj address
				move.l	(a5),a1			; get pointer to x
				move.l	(a4),a2			; get pointer to y
				move.w	(a1)+,d0		; get x
				bpl.s	.gety
				lea		intro_x+2,a1
				move.w	(a1)+,d0
.gety:			move.w	(a2)+,d1
				bpl.s	.plot
				lea		intro_y+2,a2
				move.w	(a2)+,d1
.plot:			move.l	a1,(a5)+
				move.l	a2,(a4)+
				add.l	#74,d1
				add.l	object_offset,d1
				add.l	#12,d0
				movem.l	d7/a4/a5/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a4/a5/a6
				dbra	d7,.update
				rts

x_ptrs:
				dc.l	intro_x+32		; t
				dc.l	intro_x+40		; a
				dc.l	intro_x+48		; i
				dc.l	intro_x+56		; w
				dc.l	intro_x+72		; e
				dc.l	intro_x+80		; s
				dc.l	intro_x+88		; a
				dc.l	intro_x+96		; e
				dc.l	intro_x+104		; l
				dc.l	intro_x+112		; p

y_ptrs:
				dc.l	intro_y+0
				dc.l	intro_y+8
				dc.l	intro_y+16
				dc.l	intro_y+24
				dc.l	intro_y+40
				dc.l	intro_y+48
				dc.l	intro_y+56
				dc.l	intro_y+64
				dc.l	intro_y+72
				dc.l	intro_y+80
				
intro_x:		incbin "ASSETS/WAVES/intro_x2.bin"
				dc.l	-1
				
intro_y:		incbin "ASSETS/WAVES/intro_y2.bin"
				dc.l	-1
				
				.dphrase
reboot_ptr:		dc.l	reboot_x_top
reboot_ptr2:	dc.l	reboot_x_top
start_dist:		dc.l	-1
				
				.phrase
reboot_x_top:
				.rept	300
				dc.w	32
				.endr
				
				.phrase
reboot_x:
				incbin "ASSETS/WAVES/reboot_x.bin"
				incbin "ASSETS/WAVES/reboot_x.bin"

reboot_x_end:
				incbin "ASSETS/WAVES/reboot_x.bin"
				incbin "ASSETS/WAVES/reboot_x.bin"
				
				include "_INITVID.S"					; init video system

				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Clear ram routine
;;

clear_memory:   move.l a1,d0
                sub.l a0,d0
                asr.l #2,d0
.wipe:          clr.l (a0)+
                subq.l #1,d0
                bne.s .wipe
                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy ram routine
;;

copy_ram:       move.w (a0)+,(a2)+
                cmp.l a0,a1
                bne.s copy_ram
                rts

				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Create the initial object list.
;;

bitmapobject    equ 0            ; object types
scaledobject    equ 1
gpuobject       equ 2
braobject       equ 3             
stopobject      equ 4

y_less          equ 0            ; branch object types
y_more          equ 1
always          equ 2

; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN

MakeObjectList: lea     ob_list1,a0             			; start of OL
                jsr     build_header            			; build BRA header

				move.l	a0,workbench_obj						; store object address in table
				move.l	a0,live_workbench_obj
				move.l	#(depack_addr-$400)-20344,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #90,d1 	                 			; height
                move.l  #256/2,d2             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#256/2,d5
                jsr     CreateObject
				
				move.l	a0,display_obj						; store object address in table
				move.l	#display_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #8,d1 	                 			; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
                jsr     CreateObject

				move.l	display_obj,a1			; pointer to object
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001111000000000,10(a1)	; or in next index (Pal 15)
				
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#32+16,d2
				move.l	a0,a1
				add.l	#64,a1			
				jsr		CreateObject
			
				move.l	#gpuobject,d0
				jsr		CreateObject
				jsr		make8into32
				
				move.l	#9,d7
				lea 	please_objs,a6
				lea		pleasewait_bmps,a5
.make_letters:	move.l	a0,(a6)							; store object address in table
				move.l	(a5)+,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16	,d1 	                 		; height
                move.l  #128/2,d2             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#16/2,d5
				movem.l	d7/a5-a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a5-a6

				move.l	(a6)+,a1			; pointer to object
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001110000000000,10(a1)	; or in next index (Pal 15)
				


				dbra	d7,.make_letters
				
                moveq.l #stopobject,d0          			; STOP Object
                jsr     CreateObject

				move.l	live_workbench_obj,d0
                sub.l   #ob_list1,d0        
                add.l   #ob_list,d0         
				move.l	d0,live_workbench_obj
                rts
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy Object List Routine
;;

copy_olist:
				move.l  #0,d7                  ; Gordon/Atari mess
                move.l  #ob_list1,A2_BASE
                move.l  #ob_list,A1_BASE
                move.l  d7,A1_PIXEL
                move.l  d7,A2_PIXEL
                move.w  #1,d0
                swap    d0
                move.w  #(objs*32)+64,d0
                move.l  d0,B_COUNT              ;$00010001 = 8 Bytes
                move.l  #PIXEL32|XADDPHR,d6
                move.l  d6,A1_FLAGS
                move.l  d6,A2_FLAGS
                move.l  #SRCEN|LFU_S,d7
                move.l  d7,B_CMD
                move.l  #0,A1_CLIP
                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Build a header that'll STOP if VPOS not on screen.
;;

build_header:   move.l  a0,d0               ; address if bra not taken
                sub.l   #ob_list1,d0        ;
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ; next BRA object
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00008003,4(a0)    ; bra if yp<0
                or.l    d0,2(a0)            ; link to next BRA
                lea     8(a0),a0            ;
                bsr     stopob              ; write stop object (before top)
                lea     16(a0),a0           ; next object here

                move.l  a0,d0               ; calc address of 1st actual
                sub.l   #ob_list1,d0        ; object (after the next STOP)
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ;
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00004003,4(a0)    ; bra is yp>value
                or.l    d0,2(a0)            ; link to first object!

				move.w	CONFIG,d6
				andi.w	#VIDTYPE,d6
				beq		.pal
				move.l	#492,d0				; 492 lines = full NTSC frame
				bra		.ntsc
.pal:			move.l	#530,d0				; 580 lines = full PAL frame

.ntsc:          lsl.l   #3,d0               ;
                or.l    d0,4(a0)            ;
                lea     8(a0),a0            ; next object
                bsr     stopob              ; is a STOP
				lea     16(a0),a0           ; address for next REAL object

                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Simple Object List Routines for a simple life.
;;
;; call with *d0=object type
;;           *d1=height
;;           *d2=data width
;;           *d3=colour depth
;;           *d4=transparent
;;           *d5=image width
;;           *a0=address of object (phrase alligned)
;;           *a1=address for GFX   (phrase alligned)
;;
;; exit with object built
;;           link=object address+32
;;           scaled objects will *NOT* be 1:1 in x/y
;;           x/y positions will be -500,2 (off screen)
;;

CreateObject:   lsl.w   #2,d0                   ; object type
                move.l  jmp_tab(pc,d0),a6       ; get routine address
                jmp (a6)                        ; call it!

jmp_tab:        .dc.l bitmp                     ; jump table
                .dc.l scaled
                .dc.l gpuob
                .dc.l braob
                .dc.l stopob

bitmp:          clr.l   (a0)                    ; template
                clr.l   4(a0)                   ;
                clr.l   8(a0)                   ;
                move.l  #$00008000,12(a0)       ;
                move.l  a0,d0                   ; link address
                sub.l   #ob_list1,d0            ;
                add.l   #ob_list,d0             ;
                add.l   #32,d0                  ;
                and.b   #%11111000,d0           ;
                lsl.l   #5,d0                   ;
                or.l    d0,2(a0)                ;
                move.l  a1,d0                   ; gfx address
                lsl.l   #8,d0                   ;
                or.l    d0,(a0)                 ;
                move.l  d1,d0                   ; height
                swap    d0                      ;
                lsr.l   #2,d0                   ;
                or.l    d0,4(a0)                ;
                ror.w   #1,d4                   ; transparency
                or.w    d4,10(a0)               ;
                lsl.w   #8,d3                   ; depth (colour depth)
                lsl.w   #4,d3                   ;
                or.w    d3,14(a0)               ;
                lsr.w   #3,d2                   ; data width
                swap    d2                      ;
                lsl.l   #2,d2                   ;
                or.l    d2,12(a0)               ;
                lsr.w   #3,d5                   ; image width
                swap    d5                      ;
                lsr.l   #4,d5                   ;
                or.l    d5,10(a0)               ;
                move.w  #-500,d0                ; x-pos
                and.w   #$fff,d0
                or.w    d0,14(a0)
                or.w    #2*8,6(a0)              ; y-pos
                lea     32(a0),a0               ; BITMAP object!
                rts

scaled:         bsr     bitmp                   ; same as bitmap
                move.l  #$0,-16(a0)             ; clear it out
                move.l  #%00000000000000000100000001000000,-12(a0)
                or.l    #$1,-28(a0)             ; SCALED object!
                rts

gpuob:          move.l  #0,(a0)+
                move.l  #$3ffa,(a0)+            ; GPU object!
                rts

				
; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN
				
braob:          add     d2,d2                   ; mult y-pos
                bsr     branchobject            ; make the object
make8into32:    move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     24(a0),a1               ; a BRA+16 object
                bsr     branchobject            ;
                lea     16(a0),a0               ;
                rts

branchobject:   clr.l   (a0)
                move.l  #3,4(a0)
                add.w   d1,d1
                move.w  branchtypes(pc,d1.w),d1
                or.w    d1,6(a0)                ; branch TYPE!
                move.l  a1,d0
                sub.l   #ob_list1,d0
                add.l   #ob_list,d0
                and.l   #$fffffff8,d0
                lsl.l   #5,d0                   ; Link if branch **TAKEN!**
                move.l  d0,2(a0)                ; (< & > swapped!)
                lsl.w   #3,d2                   ; scanline to branch on
                or.w    d2,6(a0)                ; is VC/2
                lea     8(a0),a0                ; next object
                rts

branchtypes:    .dc.w    $4000,$8000,$0000       ; (< & > inverted for ease!)

stopob:         move.l  #0,(a0)+
                move.l  #4,(a0)+                ; STOP object!
                rts
				
hashing:		moveq #0,d0
			lea .table(pc),a0
			lea hexad+8(pc),a2
			bsr.s .first
			moveq #5,d3
.loop:		bsr.s .next
			dbra d3,.loop
.next:		ror.l #4,d1
.first:		move.b d1,d0
			and #$f,d0
			move.b (a0,d0),-(a2)
			rts


.table:		dc.b "0123456789ABCDEF"
hexad:		dc.l 0,0
			dc.l $ffffffff
			.even

font_x:		incbin "ASSETS/GFX/JAG/atarisys.fnt"
		.even

info_init:
		lea font_x(pc),a0			; Font offsets for plotter
		move.l a0,d0
		move.l d0,d1
		move.l d0,d2
		add.l #40*9,d1
		add.l #40*18,d2
		lea ascii,a1
		move.w #39,d3
.adder:
		move.l d0,(a1)
		move.l d1,160(a1)
		move.l d2,320(a1)
		addq.l #1,d0
		addq.l #1,d1
		addq.l #1,d2
		lea 4(a1),a1
		dbra d3,.adder
		rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Text plotting routine
;;
;; call with a1 pointing at text
;;       

info:	lea display_bmp,a0
		add.l (a1)+,a0
info2:	lea next_add(pc),a3
		move.l a0,(a3)
.loop:	moveq.l #0,d0
		move.b (a1)+,d0
		bpl.s .write
		cmp.b #-1,d0
		beq.s .wrap
.nextline:
		move.l (a3),a0
		add.l #40*9,a0
		move.l a0,(a3)
		bra.s .loop
.wrap:
		rts
.write:
;		cmp.b #'.',d0		; '.' and '-' are swapped in the font. cheap hack :P
;		bne.s .nodot
;		move.b #'-',d0
;		bra.s .ch_ok
;.nodot:
;		cmp.b #'-',d0
;		bne.s .ch_ok
;		move.b #'.',d0
.ch_ok:
		sub.b #' ',d0
		add d0,d0
		add d0,d0
		lea ascii,a2
		move.l (a2,d0),a2
		bsr.s .plotit
		bra .loop
.plotit:	
		move.b (a2),(a0)
		move.b	40(a2),40(a0)
		move.b	80(a2),80(a0)
		move.b	120(a2),120(a0)
		move.b	160(a2),160(a0)
		move.b	200(a2),200(a0)
		move.b	240(a2),240(a0)
		move.b	280(a2),280(a0)
		add.l 	#1,a0
		rts
		
	
InstallGPUCode:
                lea     gpu_jmp,a0              ; install GPU OP vector
                lea     gpu_jmp_e,a1
                lea     G_RAM+(3*16),a2
                bsr     copy_ram

                lea     gpu_null,a0             ; install idle GPU code
                lea     gpu_null_e,a1
                lea     G_RAM+$80,a2
                bsr     copy_ram
				
                lea     gpu_hblank,a0           ; install GPU hblank code
                lea     gpu_hblank_e,a1
                lea     G_RAM+$100,a2
                bsr     copy_ram
                rts

				.phrase

                .long
gpu_jmp:
                .gpu
                .org    G_RAM+(3*16)               	; INT 3 Object Processor

                movei   #G_RAM+$100,r19             	; install JMP vector
                jump    T,(r19)
                nop
                nop
				.68000
gpu_jmp_e:

gpu_null:
				.gpu
                .org    G_RAM+$80

                movei   #G_RAM+4088,r31            ;GPU stack
				movei	#gpu_halt,r17
.gpu_loop:		load	(r17),r18
				cmpq	#0,r18
				jr    	EQ,.gpu_loop
                nop
				nop
				movei	#kill_jrisc,r17
				jump	(r17)
				nop
				nop
				.phrase
gpu_halt:		dc.l	0
				
				.68000
gpu_null_e:

gpu_hblank:
				.gpu
				.org	G_RAM+$100

                movei   #G_FLAGS,r27            ; Enable other interupts
                load    (r27),r29
                bclr    #3,r29                  ; Clear IMASK
                bset    #12,r29                 ; Clear Pending
                load    (r31),r28               ; Addr of last instruction
                addq    #4,r31                  ; Correct Stack
                addq    #2,r28                  ; Next instruction

				movei	#.exit,r3
				movei	#start_dist,r0
				load	(r0),r1
				cmpq	#0,r1
				jump	MI,(r3)
				nop
				
				movei	#reboot_ptr,r0
				load	(r0),r1
				loadw	(r1),r3
				addq	#2,r1
				store	r1,(r0)
				addq	#8,r3
				
				movei	#live_workbench_obj,r1
				movei	#$f000,r2
				load	(r1),r1
				addq	#14,r1					; offset to X
				loadw	(r1),r30
				and		r2,r30
				or		r3,r30
				storew	r30,(r1)
				
.exit:			moveq   #0,r0                   ; Stop GPU
                movei   #OBF,r1                 ; re-enable object processor
				store	r29,(r27)
                jump    (r28)                   ; return to GPU code
                storew  r0,(r1)
                nop

kill_jrisc:
				moveq   #0,r0                   ; Stop GPU
				movei	#G_FLAGS,r1
				store	r0,(r1)
                movei   #G_CTRL,r1
                store   r0,(r1)

				nop
				nop
				nop
				
				.phrase
offset:			dc.l	0
				
                .68000
gpu_hblank_e:

hobs_bitmap:
				lea     ob_list1,a0             			; start of OL
                jsr     build_header            			; build BRA header

				move.l	a0,hobs_obj						; store object address in table
				move.l	#hobs_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #136,d1 	                 		; height
                move.l  #96/2,d2             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#96/2,d5
                jsr     CreateObject	

				move.l	#stopobject,d0
				jsr		CreateObject
 				
				move.l	hobs_obj,a0
				move.l	#700,d0
				move.l	#700,d1
				bsr		setup_object_xy
				
                move.l  #VB_INTERUPT,LEVEL0     			; Install 68K LEVEL0 handler

                bsr     wait_frame              			; Stop the OP from freaking

                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!

				lea		button_bmp,a0
				lea		$160000,a1
				jsr		unpacker

				bsr		fadepal_down
				
				move.l	hobs_obj,a0
				move.l	#176-(96/2),d0
				move.l	#148-(136/2),d1
				tst.w	ntsc_flag
				bmi.s	.palset
				sub.l	#16,d1
.palset:		bsr		setup_object_xy

				lea		hobs_pal,a1
				bsr		fadepal_up	
			
				lea		logo_pallettes,a0
				lea		$150000,a1
				move.l	#(256*5)/4,d7
.movepal:		move.l	(a0)+,(a1)+
				dbra	d7,.movepal
				
				lea		dbug_bmp,a0
				lea		$100000,a1
				jsr		unpacker
				lea		rg_bmp,a0
				lea		$110000,a1
				jsr		unpacker
				lea		present_bmp,a0
				lea		$120000,a1
				jsr		unpacker
				lea		jagboot_bmp,a0
				lea		$130000,a1
				jsr		unpacker
				lea		production_bmp,a0
				lea		$140000,a1
				jsr		unpacker


				bsr		fadepal_down

				move.l	hobs_obj,a0
				move.l	#900,d0
				move.l	#900,d1
				bsr		setup_object_xy
				
				lea		workbench_ice,a0
				move.l	#(depack_addr-$400)-20344,a1
				jsr		unpacker
				
				move.w	#0,$f00402+(32*15)				

; DBUG
				move.l	hobs_obj,a0
				move.l	#$100000,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #96,d1 	                 			; height
                move.l  #152,d2             				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent;
				move.l	#152,d5
                jsr     CreateObject					

				move.l	#84+16,d0
				move.l	#52+20,d1
				bsr		terrece_graphics_theif_willams

				lea		logo_pallettes,a1
				bsr		do_fade_up_down
; RG
				move.l	hobs_obj,a0
				move.l	#$110000,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #92,d1 	                 			; height
                move.l  #160,d2             				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent;
				move.l	#160,d5
                jsr     CreateObject					

				move.l	#80+16,d0
				move.l	#54+20,d1
				bsr		terrece_graphics_theif_willams

				lea		logo_pallettes+(512*1),a1
				bsr		do_fade_up_down
; PRESENT
				move.l	hobs_obj,a0
				move.l	#$120000,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #27,d1 	                 			; height
                move.l  #88,d2             				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent;
				move.l	#88,d5
                jsr     CreateObject					

				move.l	#116+16,d0
				move.l	#85+20,d1
				bsr		terrece_graphics_theif_willams

				lea		logo_pallettes+(512*2),a1
				bsr		do_fade_up_down
; jagboot
				move.l	hobs_obj,a0
				move.l	#$130000,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #60,d1 	                 			; height
                move.l  #320,d2             				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent;
				move.l	#320+20,d5
                jsr     CreateObject					

				move.l	#0+16,d0
				move.l	#70+20,d1
				bsr		terrece_graphics_theif_willams

				lea		logo_pallettes+(512*3),a1
				bsr		do_fade_up_down	

; Prodction
				move.l	hobs_obj,a0
				move.l	#$140000,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #28,d1 	                 			; height
                move.l  #104,d2             				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent;
				move.l	#104,d5
                jsr     CreateObject					

				move.l	#108+16,d0
				move.l	#81+20,d1
				bsr		terrece_graphics_theif_willams

				lea		logo_pallettes+(512*4),a1
				bsr		do_fade_up_down
; Press The Button
				move.l	hobs_obj,a0
				move.l	#$160000,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #228,d1 	                 			; height
                move.l  #320,d2             				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent;
				move.l	#320,d5
                jsr     CreateObject					

				move.l	#16,d0
				move.l	#20,d1
				bsr		terrece_graphics_theif_willams

				lea		logo_pallettes+(512*5),a1
				bsr		do_fade_up_down
								
				move.l	#$4e754e75,hobs_bitmap
				bsr		thou_shalt
								
				bsr		wait_frame

                move.l  #temp_stop_obj,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!

				bsr		wait_frame
				
				move.l	#160,$1100				; music vol
				move.l	#176,$1104				; sample vol
				move.l	#'0000',$1108			; hiscore
				move.l	#'0000',$110c
				move.l	#1,$1110				; difficulty (Normal)
				
				bra		hobs_jump

terrece_graphics_theif_willams:
				move.l	hobs_obj,a0
				tst.w	ntsc_flag
				bpl.s	.ntscset
				subq	#4,d0
				add.l	#20,d1
.ntscset:		bsr		setup_object_xy	
				rts

do_fade_up_down:
				bsr		fadepal_up
				
				move.l	#2*50,d7
.fuck_you_tbag:	bsr		wait_frame
				dbra	d7,.fuck_you_tbag
				 
				bsr		fadepal_down
				rts
				
rainbow			equ		$100000	
				
thou_shalt:
				lea 	rainbow,a0
				move.l	#(40*9*25)/4,d7
.xwipe:			clr.l	(a0)+
				dbra	d7,.xwipe

				bsr 	decrypt_text
				
				bsr		wait_frame

                move.l  #temp_stop_obj,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!
			
				lea		rainbow,a0
				lea		rainbow_txt,a1
				bsr		info2
				
				move.l	hobs_obj,a0
				lea		rainbow,a5
				lea		text_objs(pc),a6
				moveq	#0,d6
				move.w	#24,d7					; 25 objects
.maketext:		move.l	a0,(a6)						; store object address in table
				move.l	a5,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #8,d1 	                 			; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
				movem.l	d6/d7/a5/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d6/d7/a5/a6
				move.l	(a6)+,a1			; pointer to object
				add.w	.diff,d6
				eor.w	#1,.diff
				move.w	d6,d0
				and.l	#%1111,d0
				lsl.w	#8,d0				; shift up one byte
				lsl.w	#1,d0
				;		  7654321076543210 
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	d0,10(a1)		; or in next index 
				lea		8*40(a5),a5
				dbra	d7,.maketext
				
				move.l	#stopobject,d0
				jsr		CreateObject

				lea		text_objs(pc),a6
				move.l	#30,d6
				move.w	#24,d7	
.setuptxt:		move.l	(a6)+,a0
				moveq	#15,d0
				move.l	d6,d1
				movem.l	d6/d7/a5/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d6/d7/a5/a6
				add.l	#8,d6
				dbra	d7,.setuptxt

				
                bsr     wait_frame              			; Stop the OP from freaking
			
                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!
				
.argh:			move.w	#1,d7		
.gorftwat:		bsr		wait_frame
				dbra	d7,.gorftwat
				lea		$f00402+(32*15),a0
				moveq	#14,d7
.rotate:		move.w	-32(a0),(a0)
				lea		-32(a0),a0
				dbra	d7,.rotate

				move.l	colptr,a1
.getcol:		move.w	(a1)+,d0
				cmp.l	#colours_end,a1
				bne.s	.insert_col
				lea		colours,a1
				bra.s	.getcol
.insert_col:	move.w	d0,$f00402
				move.l  a1,colptr
				
				jsr		readpad
				jsr		handle_input
				
				tst.w	dpad_b
				beq		.argh

				rts
				
.diff:			dc.w	0
				
colptr:			dc.l	colours+30
colours:		incbin	"colours.j16"
colours_end:	dc.l	"WANK"

decrypt_text:	
				lea 	rainbow_txt,a0
				lea 	rainbow_end,a1
				lea 	crypt_key,a2
				move.l	a0,a3
crypt:			moveq	#0,d0
				move.b	(a0),d0
				moveq	#0,d1
				move.b	(a2)+,d1
				cmp.l	a2,a3
				bne.s	.key
				lea crypt_key,a2
.key:			ror.b	#3,d0
				eor.b	d1,d0
				move.b	d0,(a0)+
				cmp.l	a0,a1
				bne.s	crypt
				rts

crypt_key:		incbin 	"crypt.key"
rainbow_txt:	incbin  "crypt.txt"
rainbow_end:
				.even
text_objs:		
				.rept	25
				dc.l	0
				.endr
				
				.phrase

next_add:	dc.l	0
no_tracking:	dc.l	0

unpacker:
			include "_ice.s"
			include "_audio.s"
			include "_joypad.s"
			even
									
please_objs:	dc.l	0,0,0,0,0,0,0,0,0,0
		
                .dphrase
		
bss_top:		.dc.l 	0,0

ntsc_flag:		.dc.w	0

a_hdb:          .dc.w   0
a_hde:          .dc.w   0
a_vdb:          .dc.w   0
a_vde:          .dc.w   0
width:          .dc.w   0
height:         .dc.w   0
ticks:          .dc.l   0 
ascii:
				.rept	120
				dc.l	0
				.endr

				.phrase
				
display_obj:	.dc.l	0
workbench_obj:	.dc.l	0
live_workbench_obj:	.dc.l	0
new_pallette:	
				.rept 256
				.dc.w	0
				.endr
				
				.phrase
display_bmp:
				.rept	40*8
				.dc.b	0
				.endr

				.dphrase
temp_stop_obj:	dc.l	0,4
hobs_obj:		dc.l	0
				.dphrase
hobs_bmp:		incbin  "ASSETS/GFX/JAG/hobs.jag"
				.phrase
hobs_pal:		incbin 	"ASSETS/GFX/JAG/hobs.pal"
				.rept	256
				dc.w	0
				.endr
			
				.dphrase
dbug_bmp:		incbin "LOGOS/LOG-DBUG.ICE"
				.even
rg_bmp:			incbin "LOGOS/LOG-RG.ICE"
				.even
present_bmp:	incbin "LOGOS/LOG-PSNT.ICE"
				.even
jagboot_bmp:	incbin "LOGOS/LOG-JWBT.ICE"
				.even
production_bmp:	incbin "LOGOS/LOG-PROD.ICE"
				.even

logo_pallettes:	incbin "LOGOS/LOG-DBUG.PAL"
				incbin "LOGOS/LOG-RG.PAL"
				incbin "LOGOS/LOG-PSNT.PAL"
				incbin "LOGOS/LOG-JWBT.PAL"
				incbin "LOGOS/LOG-PROD.PAL"
				incbin "PRESS.PAL"
				.phrase
workbench_ice:	incbin "ASSETS/GFX/JAG/loadlogo.ice"
				.even	
						
button_bmp:		incbin "PRESS.ICE"
				.even
			
_trashram:		
				.end




