;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Project 1: Title Sequence
;;
 


                .include    "jaguar.inc"
			
                .text

ob_list			equ	$1f0000
ob_list1		equ	$1f8000
objs			equ 30
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Code entrypoint
;;

top_of_the_code:
				lea		$802000,a0
.find:			cmp.w	#'DI',(a0)+
				bne.s	.find
				cmp.w	#'GI',(a0)+
				bne.s	.find
				move.l	a0,$1008							; sample base

;				move.l	#160,$1100				; music vol
;				move.l	#176,$1104				; sample vol
;				move.l	#'0000',$1108			; hiscore
;				move.l	#'0000',$110c
;				move.l	#0,$1110				; difficulty				
				
                move.w  #$2700,sr               			; kill interupts

				move.w	#%0000011011000111,VMODE			; 320x256!!

                jsr     InitVideo               			; Setup our video registers.
				jsr		Init_music
			
				bsr		InstallGPUCode				
				bsr     MakeObjectList          			; Create bit magled list for OP
				
                move.l  #VB_INTERUPT,LEVEL0     			; Install 68K LEVEL0 handler
                move.w  a_vde,d0                			; Must be ODD
                sub.w   #16,d0
                ori.w   #1,d0
                move.w  d0,VI

                move.w  #1,INT1                 			; Enable video interrupts
                and.w   #$f8ff,sr

				move.l	#reboot_x_top,reboot_ptr
				move.l	#reboot_x_top,reboot_ptr2
				move.l	#-1,start_dist
				
				move.l  #G_OPENA,G_FLAGS        			; Enable GPU Ints from OP
                move.l  #G_RAM+$80,G_PC         			; Setup GPU PC
                move.l  #GPUGO,G_CTRL           			; Run the GPU
							
				bsr 	info_init
				
				lea		start_txt,a1
				bsr		info
				lea		credits_txt,a1
				bsr		info

				move.l	display_obj,a0
				move.l	#12,d0
				move.l	#218,d1
				bsr		setup_object_xy
				
				move.l	banner_obj,a0
				move.l	#0,d0
				move.l	#20,d1
				bsr		setup_object_xy

				move.l	planet_obj,a0
				move.l	#0,d0
				move.l	#60,d1
				bsr		setup_object_xy	
				
				move.l	jagware_obj,a0
				move.l	#40-8,d0
				move.l	#28,d1
				bsr		setup_object_xy	

				move.l	scroll_obj,a0
				move.l	#16,d0
				move.l	#90,d1
				bsr		setup_object_xy	
				move.l  scroll2_obj,a0
				move.l	#17,d0
				move.l	#91,d1
				bsr		setup_object_xy	

				move.l	#scroll_bmp,scroll_start
				
;						  rrrrrbbbbbggggg0
				move.w	#%0000011111000000,$f00402+(32*15)		; primary
				move.w	#%1111111111111110,$f00402+(32*13)		; shadow

				move.w	#0,$f00402+(32*14)

				move.w	#0,$f00402+(32*12)
				move.l	overlay_obj,a0
				move.l	#0,d0
				move.l	#16,d1
				bsr		setup_object_xy	
				
                bsr     wait_frame              			; Stop the OP from freaking

                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!
				
				move.l	#200,d6
crossfade_in:	move.l	d6,-(a7)
				bsr		wait_frame
				move.l	(a7)+,d6
				
				lea circles_list(pc),a0
process_circles:
				movem.l (a0)+,d7/a2
				cmp.l #-1,a2
				beq.s no_more_circles
				addq.l #1,d7
				move.l d7,-8(a0)
				tst.l d7
				blt.s no_visible_circle
				movem.l d6/a0,-(a7)
				bsr draw_circle
				movem.l (a7)+,d6/a0
				bra.s process_circles
				
no_visible_circle:				
no_more_circles:

				dbra	d6,crossfade_in
				
				bsr 	append_object_list
				move.l  #G_OPENA,G_FLAGS        			; Enable GPU Ints from OP
                move.l  #G_RAM+$80,G_PC         			; Setup GPU PC
                move.l  #GPUGO,G_CTRL           			; Run the GPU
				
				
loop:			bsr 	wait_frame
				jsr		readpad								; read jagpad
				jsr		handle_input
				tst.w	dpad_b
				bne		exit_intro
				tst.w	dpad_option
				bne		process_options
				bra		loop
				
process_options:
				bsr 	info_down
				lea		options_txt,a1
				bsr		info
				move.l	$1100,d0
				lea		mus_vol,a1
				bsr		.plot_vollev
				move.l	$1104,d0
				lea		sfx_vol,a1
				bsr		.plot_vollev
				bsr		.plot_diffs
				lea		options_arrow,a1
				bsr		info
				
				bsr		info_up
				
.optionloop:	bsr		wait_frame
				jsr		readpad
				jsr		handle_input
				
.test_up:		tst.w	dpad_up
				beq		.test_down
				tst.w	current_option
				beq		.test_down
				sub.w	#1,current_option
				sub.l	#40*9,options_arrow
				bra		.hold_2secs
.test_down:		tst.w	dpad_down
				beq		.test_left
				cmp.w	#2,current_option
				beq		.test_left
				add.w	#1,current_option
				add.l	#40*9,options_arrow
				bra		.hold_2secs
.test_left:		tst.w	dpad_left
				bne		.process_left
				tst.w	dpad_right
				bne		.process_right
				
				tst.w	dpad_option
				beq		.optionloop

				bsr		info_down
				lea		start_txt,a1
				bsr		info
				bsr		info_up
				
				bra		loop
				
				
.process_left:	move.w	current_option,d0
				asl.w	#2,d0
				lea		.local_left,a0
				move.l	(a0,d0.w),a0
				jmp		(a0)
.local_left:	dc.l	.diff_l,.mus_l,.sfx_l
.diff_l:		tst.l	$1110						; difficulty
				beq		.optionloop
				sub.l	#1,$1110
				bsr		.plot_diffs
				bra		.hold_2secs
				
.mus_l:			tst.l	$1100
				beq		.optionloop
				sub.l	#16,$1100
				move.l	$1100,d0
				lea		mus_vol,a1
				bsr		.plot_vollev
				move.l	$1100,d0
				jsr		musicplayer+$14
				bra		.hold_2secs
				
.sfx_l:			tst.l	$1104
				beq		.optionloop
				sub.l	#16,$1104
				move.l	$1104,d0
				lea		sfx_vol,a1
				bsr		.plot_vollev
				move.l	$1104,d0
				jsr		musicplayer+$18
				bra		.hold_2secs
				
.process_right:	move.w	current_option,d0
				asl.w	#2,d0
				lea		.local_right,a0
				move.l	(a0,d0.w),a0
				jmp		(a0)
.local_right:	dc.l	.diff_r,.mus_r,.sfx_r

.diff_r:		cmp.l	#2,$1110
				beq		.optionloop
				add.l	#1,$1110
				bsr		.plot_diffs
				bra		.hold_2secs
				
.mus_r:			cmp.l	#256-16,$1100
				beq		.optionloop
				add.l	#16,$1100
				move.l	$1100,d0
				lea		mus_vol,a1
				bsr		.plot_vollev
				move.l	$1100,d0
				jsr		musicplayer+$14
				bra		.hold_2secs
				
.sfx_r:			cmp.l	#256-16,$1104
				beq		.optionloop
				add.l	#16,$1104
				move.l	$1104,d0
				lea		sfx_vol,a1
				bsr		.plot_vollev
				move.l	$1104,d0
				jsr		musicplayer+$18
				bra		.hold_2secs
				
; d0=volume level (0-256)
; a1=address of text			
.plot_vollev:	move.l	#'    ',d7
				move.l	d7,(a1)+
				move.l	d7,(a1)+
				move.l	d7,(a1)+
				move.l	d7,(a1)+
				lea		-16(a1),a1
				asr.w	#4,d0
.dash:			tst.w	d0
				beq		.printer
				move.b	#'*',(a1)+
				subq	#1,d0
				bne.s	.dash
.printer:		lea		options_txt,a1
				bsr		info
				
				rts

.plot_diffs:	move.l	$1110,d0
				asl.w	#2,d0
				move.l	.local_diftxt(pc,d0.w),a0
				lea		diffi,a1
				move.l	(a0)+,(a1)+
				move.l	(a0),(a1)
				lea		options_txt,a1
				bsr		info
				rts
				
.local_diftxt:	dc.l	.hardt,.normt,.easyt
.hardt:			dc.b 	"HARD    "
.normt:			dc.b	"NORMAL  "
.easyt:			dc.b	"EASY    "
				
.hold_2secs:	lea		options_arrow_remove,a1
				bsr		info
				lea		options_arrow,a1
				bsr		info

				move.l	#10,d7
.waiterz:		move.l	d7,-(a7)
				bsr		wait_frame
				move.l	(a7)+,d7
				dbra	d7,.waiterz
				bra		.optionloop
				
current_option:	dc.w	0
				
info_down:		move.l	#218,d1
				move.l	#30,d2
.loop:			move.l	#12,d0
				move.l	display_obj,a0
				movem.l	d1-d2,-(a7)
				bsr		setup_object_xy
				bsr		wait_frame
				movem.l	(a7)+,d1-d2
				add.l	#1,d1
				dbra	d2,.loop
				move.l	d1,lowest_point
				rts
lowest_point:	dc.l	0
info_up:		move.l	lowest_point,d1
				move.l	#30,d2
.loop:			move.l	#12,d0
				move.l	display_obj,a0
				movem.l	d1-d2,-(a7)
				bsr		setup_object_xy
				bsr		wait_frame
				movem.l	(a7)+,d1-d2
				sub.l	#1,d1
				dbra	d2,.loop
				rts
				
				
circles_list:					;initial radius, address of midpoint
			.dc.l -1,(48*100)+6
;			.dc.l -1,(48*50)+12
;			.dc.l -1,(48*50)+36
;			.dc.l -1,(48*206)+12
;			.dc.l -1,(48*206)+36
			.dc.l -1,-1			;end of list (must be present!)


draw_circle:
				add.l #overlay_bmp+(40*28),a2
                move.w  D7,D1           ;y=r
                moveq   #0,D0           ;x=0
                move.w  D7,D2           ;d2=e=3-2*r
                add.w   D2,D2
                neg.w   D2
                addq.w  #3,D2

circle2:
*****************************************************************
;
; Plot routine with 8-way symmetry and clipping
; This means that, given a (x,y) pair of coordinates,
; we will draw the following pairs:
; (x,y), (-x,y), (x,-y), (-x,y), (y,x), (-y,x), (y,-x), (-y,-x)
; The clipping is done as following:
; - If (x,y) is off bounds, then so do (-x,y), (x,-y) and (-x,-y)
; The same is applied for the rest 4 pairs
;
; Note! (x,y) is top-left corner relative! We must convert
; to (160,100) relative after clipping!
;
; a0 has the screen address
; d0 has the x, while d0 has y
; It would be adviseable not to destroy these ;)
;

;plot:
                movea.w D7,A6           ;save d7

xyplot:         cmp.w   #180,D0         ;x>159?
                bge     yxplot          ;if yes, then we are out of bounds
                cmp.w   #114,D1         ;y>99?
                bge     yxplot          ;ditto

                move.w  D0,D3           ;d3=x
                lsr.w   #3,D3
                and.w   #~%1,D3         ;d3=(x/16)*2
                move.w  D1,D4           ;d4=y
				
				move.w	d1,d5
				lsl.w	#4,d5
				lsl.w	#5,d4
				add.w	d5,d4
				
;                mulu    #48,D4          ;d4=y*48
                move.w  D0,D5           ;d5=x
                andi.w  #15,D5          ;d5=x mod 16
                add.w   D5,D5
                move.w  plottable(PC,D5.w),D7 ;get pixel
                move.w  plottable2(PC,D5.w),D5 ;get inverted pixel

                move.w  D4,D6           ;y offset...
                add.w   D3,D6           ;+x offset
                and.w   D7,0(A2,D6.w)   ;plot (x,y)
                move.w  D3,D6           ;x offset...
                sub.w   D4,D6           ;-y offset
                sub.w   #48,D6          ;********
                and.w   D7,0(A2,D6.w)   ;plot (x,-y)
                move.w  D4,D6           ;y offset...
                sub.w   D3,D6           ;-x offset
                subq.w  #2,D6           ;********
                and.w   D5,0(A2,D6.w)   ;plot (-x,y)
                move.w  D4,D6           ;y offset...
                add.w   D3,D6           ;+x offset...
                add.w   #48+2,D6        ;**********
                neg.w   D6              ;-(y+x offset)
                and.w   D5,0(A2,D6.w)   ;plot (-x,-y)
                bra.s   yxplot

;
; A couple of notes here on the plot tables:
; Initially it was going to be a neat plot routine with a standard
; plot table (a walking 1 from bits 15 to 0). But then I found out
; that the Bresenham circle algorithm wasn't what I expected, so
; instead of a filled circle all I got was a Moire pattern!
; First thought was to kill the Moire by filling all bits. For this
; I had to create a 'left' and 'right' plot table (see how they are
; constructed below). Alas, that didn't cure the problem 100%, as
; some pixels are still not drawn (the planar system is to blame).
; So, instead of scrapping the idea I sacrifice some of the algorithm's
; accuracy by plotting one extra pixel on the right of the 'right'
; table, and on the left of the 'left' buffer. That's why we have
; $c000 instead of $8000 as an initial value on the 'left' table
; and $0003 instead of $0001 on the 'right' table. Hope I won't burn
; in hell for this (also hope most people won't notice due to the
; 50/60 fps the routines' running at!)
; Final note: commented values of 'i'  should be used when we
; want to DRAW a circle (all ANDs should be replaced with ORs in the
; rest of the plot routine, too). Values of i not commented are
; used when we want to ERASE a circle (and such is our case)
;
plottable:
;i               SET $C000
i               SET $3FFF
                .REPT 16
                DC.W i
;i               SET i>>1+$8000
i               SET i>>1
                .ENDR

plottable2:
;i               SET 3
i               SET $FFFC
                .REPT 16
                DC.W i
;i               SET i<<1+1
i               SET (i<<1)&$ffff
                .ENDR

yxplot:         cmp.w   #180,D1         ;y>159?
                bge.s   noyxplot        ;out of bounds
                cmp.w   #114,D0         ;x>100?
                bge.s   noyxplot        ;out of bounds

                move.w  D1,D3           ;d3=x
                lsr.w   #3,D3
                and.w   #~%1,D3         ;d3=(x/16)*8
                move.w  D0,D4           ;d4=y

				move.w	d0,d5
				lsl.w	#4,d5
				lsl.w	#5,d4
				add.w	d5,d4
				
				
;                mulu    #48,D4          ;d4=y*48

                move.w  D1,D5           ;d5=x
                andi.w  #15,D5          ;d5=x mod 16
                add.w   D5,D5
                move.w  plottable(PC,D5.w),D7 ;get pixel
                move.w  plottable2(PC,D5.w),D5 ;get inverted pixel

                move.w  D4,D6           ;y offset...
                add.w   D3,D6           ;+x offset
                and.w   D7,0(A2,D6.w)   ;plot (x,y)
                move.w  D3,D6           ;x offset...
                sub.w   D4,D6           ;-y offset
                sub.w   #48,D6          ;********
                and.w   D7,0(A2,D6.w)   ;plot (x,-y)
                move.w  D4,D6           ;y offset...
                sub.w   D3,D6           ;-x offset
                subq.w  #2,D6           ;********
                and.w   D5,0(A2,D6.w)   ;plot (-x,y)
                move.w  D4,D6           ;y offset...
                add.w   D3,D6           ;+x offset...
                add.w   #48+2,D6        ;**********
                neg.w   D6              ;-(y+x offset)
                and.w   D5,0(A2,D6.w)   ;plot (-x,-y)

                move.w  A6,D7           ;restore d7
noyxplot:

*****************************************************************


                addq.w  #1,D0           ;x=x+1
                tst.w   D2              ;e>=0?
                blt.s   circle3         ;nope

                subq.w  #1,D1           ;y=y-1
                move.w  D1,D3           ;d3=y
                lsl.w   #2,D3           ;d3=4*y
                sub.w   D3,D2           ;d2=e-4*y

circle3:        move.w  D0,D3           ;d3=x
                lsl.w   #2,D3           ;d3=4*x
                addq.w  #2,D3           ;d3=4*x+2
                add.w   D3,D2           ;d2=e+4*x+2

                cmp.w   D0,D1           ;x<=y?
                bge     circle2         ;no ,loop

				rts						;and we're done!
				
intro_loop:		dc.l	title_screen
				
do_all_intro:
				jsr 	musicplayer+$8
				move.l	intro_loop,a0
				jmp		(a0)

blank_ctr:		dc.l	0

swap_in_jagpad:
				move.l	banner_obj,a0						; store object address in table
				move.l	#overlay_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #1,d1 	                 			; height		(138)
                move.l  #8,d2	             				; bytes to next line (1664*2)
                move.l  #0,d3                   			; 1-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#8,d5								; (360*2)
                jsr     CreateObject

				move.l	add_jagpad_here,a0
				move.l	a0,-(a7)
				move.l	#jagpad_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #132,d1 	                 		; height		(138)
                move.l  #192*2,d2	             			; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#192*2,d5							; (360*2)
                jsr     CreateObject

				move.l	a0,-(a7)
				move.l	#jagpad_txt_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #8,d1 	                 			; height		(138)
                move.l  #40,d2	             				; bytes to next line (1664*2)
                move.l  #0,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#40,d5								; (360*2)
                jsr     CreateObject
				move.l	(a7),a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001101000000000,10(a1)	; or in next index (pal 16)
									
				move.l	a0,highlight_obj					; create null object
				move.l	#overlay_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #1,d1 	                 			; height		(138)
                move.l  #8,d2	             				; bytes to next line (1664*2)
                move.l  #0,d3                   			; 1-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#8,d5								; (360*2)
                jsr     CreateObject
	
				move.l	#stopobject,d0
				jsr		CreateObject

jagpad_x	equ	86
jagpad_y	equ	75
				
				move.l	(a7)+,a0
				move.l	#jagpad_x-69,d0
				move.l	#jagpad_y+133,d1
				bsr		setup_object_xy
				
				move.l	(a7)+,a0
				move.l	#jagpad_x,d0
				move.l	#jagpad_y,d1
				bsr		setup_object_xy
				
				rts

swap_out_jagpad:
				move.l	banner_obj,a0						; store object address in table
				move.l	#banner_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #138,d1 	                 		; height		(138)
                move.l  #1664*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#360*2,d5							; (360*2)
                jsr     CreateObject

				move.l	add_jagpad_here,a0
				move.l	#stopobject,d0
				jsr		CreateObject
				
				move.l	banner_obj,a0
				move.l	#0,d0
				move.l	#20,d1
				bsr		setup_object_xy
								
				rts
				
blank_out_middle:
				lea		overlay_bmp+(48*129),a0
				move.l	a0,a1
				add.l	blank_ctr,a0
				sub.l	blank_ctr,a1
				move.w	#47,d6
.wiper:			move.b	#$ff,(a0)+
				move.b	#$ff,(a1)+
				dbra	d6,.wiper
				add.l	#48,blank_ctr
				cmp.l	#48*72,blank_ctr
				bne.s	.out
				
				lea		.padflash_null,a1
				bsr		info	
				
				move.l	#jagpad_demo,intro_loop
				bsr		swap_in_jagpad
				move.l	#1,jagpad_onscreen
				bsr		do_press_fire
				rts
.out:			bsr		big_logo_scroller
				bsr		do_press_fire
				rts
				
.padflash_null:	dc.l	jagpad_txt_bmp
				dc.b	"                                       ",-1
				.even
			
				
restore_middle:
				lea		overlay_bmp+(48*129),a0
				move.l	a0,a1
				add.l	blank_ctr,a0
				sub.l	blank_ctr,a1
				move.w	#47,d6
.wiper:			move.b	#$0,(a0)+
				move.b	#$0,(a1)+
				dbra	d6,.wiper
				sub.l	#48,blank_ctr
				tst.l	blank_ctr
				bpl.s	.out
				move.l	#title_screen,intro_loop
.out:			bsr		big_logo_scroller
				bsr		do_press_fire
				rts
				
jagpad_counter:	dc.w	10*50
				
jagpad_demo:
				sub.w	#1,jagpad_counter
				bpl		.keep_this_screen
				move.l	#restore_middle,intro_loop
				bsr		swap_out_jagpad
				clr.l	jagpad_onscreen
.keep_this_screen:
				bsr		do_press_fire

				cmp.w	#35*50,jagpad_counter
				beq		.padflash_1
				cmp.w	#30*50,jagpad_counter
				beq		.padflash_2
				cmp.w	#25*50,jagpad_counter
				beq		.padflash_3
				cmp.w	#20*50,jagpad_counter
				beq		.padflash_4
				cmp.w	#15*50,jagpad_counter
				beq		.padflash_5
				cmp.w	#10*50,jagpad_counter
				beq		.padflash_6
				cmp.w	#5*50,jagpad_counter
				beq		.padflash_7
								
				rts
				
.padflash_1:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpad_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #25,d1 	                 		; height		(138)
                move.l  #32*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#32*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+29,d0
				move.l	#jagpad_y+12,d1
				bsr		setup_object_xy

				lea		.padflash1_txt,a1
				bra		info
				
.padflash_2:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpadb_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height		(138)
                move.l  #32*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#32*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+116,d0
				move.l	#jagpad_y+19,d1
				bsr		setup_object_xy

				lea		.padflash2_txt,a1
				bra		info
				
.padflash_3:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpada_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #13,d1 	                 		; height		(138)
                move.l  #32*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#32*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+117,d0
				move.l	#jagpad_y+10,d1
				bsr		setup_object_xy
				lea		.padflash3_txt,a1
				bra		info

.padflash_4:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpadc_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 		; height		(138)
                move.l  #32*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#32*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+108,d0
				move.l	#jagpad_y+31,d1
				bsr		setup_object_xy
				lea		.padflash4_txt,a1
				bra		info

.padflash_5:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpad3_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #6,d1 	                 		; height		(138)
                move.l  #16*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#16*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+106,d0
				move.l	#jagpad_y+68,d1
				bsr		setup_object_xy
				lea		.padflash5_txt,a1
				bra		info
				
.padflash_6:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpadp_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #13,d1 	                 		; height		(138)
                move.l  #16*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#16*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+69,d0
				move.l	#jagpad_y+30,d1
				bsr		setup_object_xy
				lea		.padflash6_txt,a1
				bra		info
				
.padflash_7:	move.l	highlight_obj,a0					; store object address in table
				move.l	#dpadsh_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #7,d1 	                 		; height		(138)
                move.l  #64*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#64*2,d5							; (360*2)
                jsr     CreateObject

				move.l	highlight_obj,a0
				move.l	#jagpad_x+59,d0
				move.l	#jagpad_y+113,d1
				bsr		setup_object_xy
				lea		.padflash7_txt,a1
				bra		info	
				
				;		"0123456789012345678901234567890123456789"
				
.padflash1_txt:	dc.l	jagpad_txt_bmp
				dc.b	"  Move the Fuji Fighter with the D-Pad ",-1
				.even
				
.padflash2_txt:	dc.l	jagpad_txt_bmp
				dc.b	"        Fire your blaster with B       ",-1
				.even
				
.padflash3_txt:	dc.l	jagpad_txt_bmp
				dc.b	"  Fire your lasers (if charged) with A ",-1
				.even
				
.padflash4_txt:	dc.l	jagpad_txt_bmp
				dc.b	"  Use Smart Bomb (if available) with C ",-1
				.even
				
.padflash5_txt:	dc.l	jagpad_txt_bmp
				dc.b	"  Deploy Shields (if available) with 3 ",-1
				.even
				
.padflash6_txt:	dc.l	jagpad_txt_bmp
				dc.b	"   Start Bad Moodies(tm) with [PAUSE]  ",-1
				.even
				
.padflash7_txt:	dc.l	jagpad_txt_bmp
				dc.b	"      Reboot Game with STAR + HASH     ",-1
				.even
				
				
				

title_screen:
				sub.w	#1,hz25
				bpl.s	.skip
				move.w	#5,hz25					; 5   *here*
				add.l	#40,scroll_start
				subq.w	#1,scroll_cnt
				bpl.s	.ok2
				move.l	#scroll_bmp,scroll_start
				move.w	#710,scroll_cnt
				
				move.l	#blank_out_middle,intro_loop
				move.l	#0,blank_ctr
				move.w	#36*50,jagpad_counter
				
.ok2:
				moveq	#16,d0
				move.l	#90,d1
				move.l	d0,-(a7)
				move.l	d1,-(a7)
				move.l	scroll_obj,a0
				move.l	scroll_start,d2
				move.l	d2,-(a7)
				bsr		setup_object_xyg
				move.l	(a7)+,d2
				move.l	(a7)+,d1
				move.l	(a7)+,d0
				addq.l	#1,d0
				addq.l	#1,d1
				move.l	scroll2_obj,a0
				bsr		setup_object_xyg
.skip:			

				bsr		big_logo_scroller
				bsr		do_press_fire

				rts
				
big_logo_scroller:
				moveq	#0,d0
				move.l	banner_obj,a0
				move.w	gfx_pos,d0
				move.l	#74,d1
				move.l	project1_addr,d2
				bsr		setup_object_xyg
						
				sub.w	#1,project1_cnt
				bpl.s	.ok
				move.w	#7,project1_cnt
				add.l	#16,project1_addr
				add.w	#8,gfx_pos
.ok:			sub.w	#1,gfx_pos
				sub.w	#1,gfx_cnt
				bpl		.done
				move.w	#0,gfx_pos
				move.w	#1024+330,gfx_cnt
				move.w	#8,project1_cnt
				move.l	#banner_bmp,project1_addr
.done:			rts				
				
hz25:			dc.w 	5
scroll_start:	dc.l	0
scroll_cnt:		dc.w	710
				
project1_addr:	dc.l	banner_bmp
project1_cnt:	dc.w 	7
jagpad_onscreen:	dc.l	0
				
exit_intro:		tst.l	jagpad_onscreen
				beq.s	.noremover

				move.l	add_jagpad_here,a0
				move.l	#stopobject,d0
				jsr		CreateObject
				
.noremover:
				lea		overlay_bmp+(48*128),a0
				move.l	a0,a1
				add.l	#1,a1
				move.l	#127,d7
crossfade_out:	movem.l	d7/a0-a1,-(a7)
				move.l	d7,d0
				cmp.l	$1100,d0
				ble.s	.setvol
				move.l	$1100,d0
.setvol:		jsr		musicplayer+$14
				bsr		wait_frame
;				bsr		do_all_intro
				movem.l	(a7)+,d7/a0-a1
				move.w	#47,d6
.eraser:		move.b	#$ff,(a0)+
				move.b	#$ff,-(a1)
				dbra	d6,.eraser
				dbra	d7,crossfade_out
				
				move.l	#1,kill_dsp
				move.l	#1,gpu_halt
				bsr		wait_frame
				
				moveq	#1,d0
				jmp 	$3002
				


gfx_pos:		dc.w	0
gfx_cnt:		dc.w	1024+330
				
do_press_fire:	lea		pressfire_objs,a6
				lea		x_ptrs,a5
				lea		y_ptrs,a4
				move.l	#8,d7
.update:		move.l	(a6)+,a0		; get obj address
				move.l	(a5),a1			; get pointer to x
				move.l	(a4),a2			; get pointer to y
				move.w	(a1)+,d0		; get x
				bpl.s	.gety
				lea		intro_x+2,a1
				move.w	(a1)+,d0
.gety:			move.w	(a2)+,d1
				bpl.s	.plot
				lea		intro_y+2,a2
				move.w	(a2)+,d1
.plot:			move.l	a1,(a5)+
				move.l	a2,(a4)+
				add.l	#215,d1
				add.l	#12,d0
				movem.l	d7/a4/a5/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a4/a5/a6
				dbra	d7,.update
				rts

x_ptrs:
				dc.l	intro_x+40
				dc.l	intro_x+48
				dc.l	intro_x+56
				dc.l	intro_x+64
				dc.l	intro_x+72
				dc.l	intro_x+80
				dc.l	intro_x+88
				dc.l	intro_x+96
				dc.l	intro_x+104

y_ptrs:
				dc.l	intro_y+32
				dc.l	intro_y+40
				dc.l	intro_y+48
				dc.l	intro_y+56
				dc.l	intro_y+104
				dc.l	intro_y+112
				dc.l	intro_y+120
				dc.l	intro_y+128
				dc.l	intro_y+136
				
intro_x:		incbin "intro_x2.bin"
				dc.l	-1
				
intro_y:		incbin "intro_y3.bin"
				dc.l	-1
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position and bitmap in d2
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
;; d2=bitmap address
;;
				
setup_object_xyg: 
			tst.w ntsc_flag
			bpl.s	.offsdone
			add.w	#20,d1

.offsdone:		and.w	#%111111111111,d0					; mask x value only (for negatives)
				and.w	#%1111111111,d1						; and again (y)
				move.w  6(a0),d4                			; get y-pos
               and.w   #$c007,d4
               move.w  14(a0),d6               			; get x-pos
               and.w   #$f000,d6
                add.w   d1,d1
                lsl.w   #3,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)							; update in object data
                move.w  d6,14(a0)

;						  01234567890123456789012345678912
				lsl.l	#8,d2
				move.l	(a0),d0
				and.l	#%00000000000000000000011111111111,d0	; clear existing address
				or.l	d2,d0

				move.l	d0,(a0)								; update object GFX pointer
				
               rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
				
setup_object_xy:
			tst.w ntsc_flag
			bpl.s	.offsdone
			add.w	#20,d1


.offsdone:
				and.w	#%111111111111,d0
				and.w	#%1111111111,d1
				move.w  6(a0),d4                			; get y-pos
                and.w   #$c007,d4
                move.w  14(a0),d6               			; get x-pos
                and.w   #$f000,d6
                add.w   d1,d1
                lsl.w   #3,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)							; update in object data
                move.w  d6,14(a0)
				rts
								
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Wait for a VBL
;;

wait_frame:     move.w  d7,-(a7)
                move.w  ticks,d7
.wait:
															; add.w	#1,$f00402+(32*14)
				cmp.w   ticks,d7
                beq.s   .wait
                move.w  (a7)+,d7
                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Vertical Blank Interupt (At least it happens every frame somewhere......)
;;

flippo:			dc.w 	2

VB_INTERUPT:    movem.l d0-d7/a0-a6,-(a7)

                jsr     copy_olist              			; use Blitter to update active list from shadow

				move.l	reboot_ptr2,a0
				add.l	#2,a0
				cmp.l	#reboot_x_end,a0
				bne.s	.nowrap
				lea		reboot_x,a0
.nowrap:		move.l	a0,reboot_ptr2
				move.l	a0,reboot_ptr

				sub.w	#1,ticks
		
.done_vbl:      move.w  #$101,INT1              			; Signal we're done
                move.w  #$0,INT2

				bsr		do_all_intro

				move.l	col_ptr,a0
				move.w	(a0)+,d0
				cmp.l	#colours_end,a0
				bne.s	.nowrapz
				lea		colours,a0
				move.w	(a0)+,d0
.nowrapz:		move.l	a0,col_ptr
				move.w	d0,$f00402+(32*14)				
                
                movem.l (a7)+,d0-d7/a0-a6
                rte	

col_ptr:		dc.l	colours
colours:		incbin 	"colours.j16"
colours_end:	dc.b	"WANK"
				
				.phrase
reboot_ptr:		dc.l	reboot_x_top
reboot_ptr2:	dc.l	reboot_x_top
start_dist:		dc.l	-1
				
				.phrase
reboot_x_top:

reboot_x:
				.rept	300
				dc.w	32
				.endr				
				incbin "reboot_x.bin"
				incbin "reboot_x.bin"

reboot_x_end:
				.rept	300
				dc.w	32
				.endr
				incbin "reboot_x.bin"
				incbin "reboot_x.bin"
								
				include "_INITVID.S"					; init video system

				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy ram routine
;;

copy_ram:       move.w (a0)+,(a2)+
                cmp.l a0,a1
                bne.s copy_ram
                rts

				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Create the initial object list.
;;

bitmapobject    equ 0            ; object types
scaledobject    equ 1
gpuobject       equ 2
braobject       equ 3             
stopobject      equ 4

y_less          equ 0            ; branch object types
y_more          equ 1
always          equ 2

; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN

MakeObjectList: lea     ob_list1,a0             			; start of OL
                jsr     build_header            			; build BRA header

				move.l	a0,planet_obj						; store object address in table
				move.l	#planet_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #186,d1 	                 		; height
                move.l  #680,d2	             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#680,d5
                jsr     CreateObject

				move.l	a0,banner_obj						; store object address in table
				move.l	#banner_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #138,d1 	                 		; height		(138)
                move.l  #1664*2,d2	             				; bytes to next line (1664*2)
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#360*2,d5							; (360*2)
                jsr     CreateObject

				move.l	a0,scroll_obj						; store object address in table
				move.l	#scroll_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #110,d1 	                 		; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
                jsr     CreateObject
				move.l	scroll_obj,a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001111000000000,10(a1)	; or in next index (pal 16)

				move.l	a0,scroll2_obj						; store object address in table
				move.l	#scroll_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #110,d1 	                 		; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
                jsr     CreateObject
				move.l	scroll2_obj,a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001101000000000,10(a1)	; or in next index (pal 16)
								
				move.l	a0,jagware_obj						; store object address in table
				move.l	a0,ljagware_obj
				move.l	#jagware_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #45,d1 	                 		; height
                move.l  #280*2,d2	             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#280*2,d5
                jsr     CreateObject
				
				move.l	a0,display_obj						; store object address in table
				move.l	#display_bmp0,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #26,d1 	                 		; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
                jsr     CreateObject
				move.l	display_obj,a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001110000000000,10(a1)	; or in next index (pal 16)

				move.l	#8,d7
				lea 	pressfire_objs,a6
				lea		pressfire_bmps,a5
.make_letters:	move.l	a0,(a6)+							; store object address in table
				move.l	(a5)+,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16	,d1 	                 		; height
                move.l  #96*2,d2             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; transparent
				move.l	#32,d5
				movem.l	d7/a5-a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a5-a6
				dbra	d7,.make_letters

				move.l	a0,overlay_obj						; store object address in table
				move.l	#overlay_bmp,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #256,d1 	                 		; height
                move.l  #48,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#48,d5
                jsr     CreateObject
				move.l	overlay_obj,a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001100000000000,10(a1)	; or in next index (pal 12)

				move.l	a0,resume_from_here
				
                moveq.l #stopobject,d0          			; STOP Object
                jsr     CreateObject

				move.l	ljagware_obj,d0
                sub.l   #ob_list1,d0        
                add.l   #ob_list,d0         
				move.l	d0,ljagware_obj
				
				rts
				
resume_from_here:	dc.l	0
add_jagpad_here:	dc.l	0
				
append_object_list:
				move.l	resume_from_here,a0
				
				move.l	#braobject,d0
				move.l	#y_more,d1
				move.l	#100,d2
				move.l	a0,a1
				add.l	#64,a1			
				jsr		CreateObject
				
				move.l	#gpuobject,d0
				jsr		CreateObject
				jsr		make8into32
				
				move.l	a0,add_jagpad_here
				
                moveq.l #stopobject,d0          			; STOP Object
                jsr     CreateObject

				rts
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy Object List Routine
;;

copy_olist:
				move.l	#ob_list,A1_BASE
				move.l	#$0,A1_PIXEL
				move.l	#PIXEL16|XADDPHR|PITCH1,A1_FLAGS
				move.l	#ob_list1,A2_BASE
				move.l	#$0,A2_PIXEL
				move.l	#PIXEL16|XADDPHR|PITCH1,A2_FLAGS
				move.w	#1,d0
				swap	d0
				move.w	#$2000/2,d0
				move.l	d0,B_COUNT
				move.l	#LFU_REPLACE|SRCEN,B_CMD
				rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Build a header that'll STOP if VPOS not on screen.
;;

build_header:   move.l  a0,d0               ; address if bra not taken
                sub.l   #ob_list1,d0        ;
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ; next BRA object
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00008003,4(a0)    ; bra if yp<0
                or.l    d0,2(a0)            ; link to next BRA
                lea     8(a0),a0            ;
                bsr     stopob              ; write stop object (before top)
                lea     16(a0),a0           ; next object here

                move.l  a0,d0               ; calc address of 1st actual
                sub.l   #ob_list1,d0        ; object (after the next STOP)
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ;
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00004003,4(a0)    ; bra is yp>value
                or.l    d0,2(a0)            ; link to first object!

				move.w	CONFIG,d6
				andi.w	#VIDTYPE,d6
				beq		.pal
				move.l	#492,d0				; 492 lines = full NTSC frame
				bra		.ntsc
.pal:			move.l	#492+40,d0				; 580 lines = full PAL frame
.ntsc:          lsl.l   #3,d0               ;
                or.l    d0,4(a0)            ;
                lea     8(a0),a0            ; next object
                bsr     stopob              ; is a STOP
				lea     16(a0),a0           ; address for next REAL object

                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Simple Object List Routines for a simple life.
;;
;; call with *d0=object type
;;           *d1=height
;;           *d2=data width
;;           *d3=colour depth
;;           *d4=transparent
;;           *d5=image width
;;           *a0=address of object (phrase alligned)
;;           *a1=address for GFX   (phrase alligned)
;;
;; exit with object built
;;           link=object address+32
;;           scaled objects will *NOT* be 1:1 in x/y
;;           x/y positions will be -500,2 (off screen)
;;

CreateObject:   lsl.w   #2,d0                   ; object type
                move.l  jmp_tab(pc,d0),a6       ; get routine address
                jmp (a6)                        ; call it!

jmp_tab:        .dc.l bitmp                     ; jump table
                .dc.l scaled
                .dc.l gpuob
                .dc.l braob
                .dc.l stopob

bitmp:          clr.l   (a0)                    ; template
                clr.l   4(a0)                   ;
                clr.l   8(a0)                   ;
                move.l  #$00008000,12(a0)       ;
                move.l  a0,d0                   ; link address
                sub.l   #ob_list1,d0            ;
                add.l   #ob_list,d0             ;
                add.l   #32,d0                  ;
                and.b   #%11111000,d0           ;
                lsl.l   #5,d0                   ;
                or.l    d0,2(a0)                ;
                move.l  a1,d0                   ; gfx address
                lsl.l   #8,d0                   ;
                or.l    d0,(a0)                 ;
                move.l  d1,d0                   ; height
                swap    d0                      ;
                lsr.l   #2,d0                   ;
                or.l    d0,4(a0)                ;
                ror.w   #1,d4                   ; transparency
                or.w    d4,10(a0)               ;
                lsl.w   #8,d3                   ; depth (colour depth)
                lsl.w   #4,d3                   ;
                or.w    d3,14(a0)               ;
                lsr.w   #3,d2                   ; data width
                swap    d2                      ;
                lsl.l   #2,d2                   ;
                or.l    d2,12(a0)               ;
                lsr.w   #3,d5                   ; image width
                swap    d5                      ;
                lsr.l   #4,d5                   ;
                or.l    d5,10(a0)               ;
                move.w  #-500,d0                ; x-pos
                and.w   #$fff,d0
                or.w    d0,14(a0)
                or.w    #2*8,6(a0)              ; y-pos
                lea     32(a0),a0               ; BITMAP object!
                rts

scaled:         bsr     bitmp                   ; same as bitmap
                move.l  #$0,-16(a0)             ; clear it out
                move.l  #%00000000000000000100000001000000,-12(a0)
                or.l    #$1,-28(a0)             ; SCALED object!
                rts

gpuob:          move.l  #0,(a0)+
                move.l  #$3ffa,(a0)+            ; GPU object!
                rts

				
; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN
				
braob:          add     d2,d2                   ; mult y-pos
                bsr     branchobject            ; make the object
make8into32:    move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     24(a0),a1               ; a BRA+16 object
                bsr     branchobject            ;
                lea     16(a0),a0               ;
                rts

branchobject:   clr.l   (a0)
                move.l  #3,4(a0)
                add.w   d1,d1
                move.w  branchtypes(pc,d1.w),d1
                or.w    d1,6(a0)                ; branch TYPE!
                move.l  a1,d0
                sub.l   #ob_list1,d0
                add.l   #ob_list,d0
                and.l   #$fffffff8,d0
                lsl.l   #5,d0                   ; Link if branch **TAKEN!**
                move.l  d0,2(a0)                ; (< & > swapped!)
                lsl.w   #3,d2                   ; scanline to branch on
                or.w    d2,6(a0)                ; is VC/2
                lea     8(a0),a0                ; next object
                rts

branchtypes:    .dc.w    $4000,$8000,$0000       ; (< & > inverted for ease!)

stopob:         move.l  #0,(a0)+
                move.l  #4,(a0)+                ; STOP object!
                rts

dubmood1_len			equ	98690
alerted_mod_len			equ 317216
ambush_mod_len			equ 121192
enginest_mod_len		equ 100366
				
Init_music:     jsr     musicplayer
				move.l	$1100,d0
                jsr     musicplayer+$14              ; mid range volume
                move.l	$1104,d0
                jsr     musicplayer+$18
				move.l	$1008,a0
				add.l	#dubmood1_len+alerted_mod_len+ambush_mod_len,a0
				jsr     musicplayer+4
				rts

				
hashing:		moveq #0,d0
			lea .table(pc),a0
			lea hexad+8(pc),a2
			bsr.s .first
			moveq #5,d3
.loop:		bsr.s .next
			dbra d3,.loop
.next:		ror.l #4,d1
.first:		move.b d1,d0
			and #$f,d0
			move.b (a0,d0),-(a2)
			rts


.table:		dc.b "0123456789ABCDEF"
hexad:		dc.l 0,0
			dc.l $ffffffff
			.even

font_x:
			incbin "atarisys.fnt"
			.even

info_init:
		lea font_x(pc),a0			; Font offsets for plotter
		move.l a0,d0
		move.l d0,d1
		move.l d0,d2
		add.l #40*9,d1
		add.l #40*18,d2
		lea ascii,a1
		move.w #39,d3
.adder:
		move.l d0,(a1)
		move.l d1,160(a1)
		move.l d2,320(a1)
		addq.l #1,d0
		addq.l #1,d1
		addq.l #1,d2
		lea 4(a1),a1
		dbra d3,.adder
		rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Text plotting routine
;;
;; call with a1 pointing at text
;;       

info:	
;		lea display_bmp0,a0
		move.l (a1)+,a0
		lea next_add,a3
		move.l a0,(a3)
.loop:	moveq.l #0,d0
		move.b (a1)+,d0
		bpl.s .write
		cmp.b #-1,d0
		beq.s .wrap
.nextline:
		move.l (a3),a0
		add.l #40*9,a0
		move.l a0,(a3)
		bra.s .loop
.wrap:
		rts
.write:
;		cmp.b #'.',d0		; '.' and '-' are swapped in the font. cheap hack :P
;		bne.s .nodot
;		move.b #'-',d0
;		bra.s .ch_ok
;.nodot:
;		cmp.b #'-',d0
;		bne.s .ch_ok
;		move.b #'.',d0
.ch_ok:
		sub.b #' ',d0
		add d0,d0
		add d0,d0
		lea ascii,a2
		move.l (a2,d0),a2
		bsr.s .plotit
		bra .loop
.plotit:	
		move.b (a2),(a0)
		move.b	40(a2),40(a0)
		move.b	80(a2),80(a0)
		move.b	120(a2),120(a0)
		move.b	160(a2),160(a0)
		move.b	200(a2),200(a0)
		move.b	240(a2),240(a0)
		move.b	280(a2),280(a0)
		add.l 	#1,a0
		rts

		include "_JOYPAD.S"
		include "_AUDIO.S"
		.phrase
		
InstallGPUCode:
                lea     gpu_jmp,a0              ; install GPU OP vector
                lea     gpu_jmp_e,a1
                lea     G_RAM+(3*16),a2
                bsr     copy_ram

                lea     gpu_null,a0             ; install idle GPU code
                lea     gpu_null_e,a1
                lea     G_RAM+$80,a2
                bsr     copy_ram
				
                lea     gpu_hblank,a0           ; install GPU hblank code
                lea     gpu_hblank_e,a1
                lea     G_RAM+$100,a2
                bsr     copy_ram
                rts
				


                .long
gpu_jmp:
                .gpu
                .org    G_RAM+(3*16)               	; INT 3 Object Processor

                movei   #G_RAM+$100,r0             	; install JMP vector
                jump    T,(r0)
                nop
                nop
				.68000
gpu_jmp_e:

gpu_null:
				.gpu
                .org    G_RAM+$80

                movei   #G_RAM+4088,r31            ;GPU stack
				movei	#gpu_halt,r17
.gpu_loop:		load	(r17),r18
				cmpq	#0,r18
				jr    	EQ,.gpu_loop
                nop
				nop
				
				moveq   #0,r0                   ; Stop GPU
                movei   #G_CTRL,r1
                store   r0,(r1)
                nop
                nop
				
				.68000
gpu_null_e:

gpu_hblank:
				.gpu
				.org	G_RAM+$100

                movei   #G_FLAGS,r27            ; Enable other interupts
                load    (r27),r29
                bclr    #3,r29                  ; Clear IMASK
                bset    #12,r29                 ; Clear Pending
                load    (r31),r28               ; Addr of last instruction
                addq    #4,r31                  ; Correct Stack
                addq    #2,r28                  ; Next instruction
			
				movei	#reboot_ptr,r0
				load	(r0),r1
				loadw	(r1),r3
				addq	#2,r1
				store	r1,(r0)
;				addq	#8,r3
				
				movei	#ljagware_obj,r1
				movei	#$f000,r2
				load	(r1),r1
				addq	#14,r1					; offset to X
				loadw	(r1),r30
				and		r2,r30
				or		r3,r30
				storew	r30,(r1)
				
.exit:			moveq   #0,r0                   ; Stop GPU
                movei   #OBF,r1                 ; re-enable object processor
                store   r29,(r27)               ; with flags updated.
                storew  r0,(r1)
                jump    (r28)                   ; return to GPU code
                nop

				.phrase
offset:			dc.l	0
gpu_halt:		dc.l	0				
                .68000
gpu_hblank_e:
		
;module:
;	incbin "alertedq.mod"
		.phrase

		
next_add:	dc.l	0

vlines		equ		(40)

start_txt:	
			dc.l	display_bmp0
			dc.b "       PROJECT ONE [PREVIEW LEVEL]   ",-2
			dc.b "        (c) 2009 Reboot & Jagware    ",-2
			dc.b "       Press [OPTION] for settings   ",-1
			.even
			
options_txt:
			dc.l	display_bmp0
			;;   "01010101010101010101"
			dc.b "    DIFFICULTY:     "
diffi:		dc.b "HARD               ",-2
			dc.b "    MUSIC VOLUME:   "
mus_vol:	dc.b "---------------- ",-2
			dc.b "    EFFECTS VOLUME: "
sfx_vol:	dc.b "---------------- ",-1
			.even
			
options_arrow:
			dc.l	display_bmp0
			dc.b " ->",-1
			.even
options_arrow_remove:
			dc.l	display_bmp0
			dc.b "   ",-2
			dc.b "   ",-2
			dc.b "   ",-1
			.even
			
credits_txt:
			dc.l scroll_bmp+(vlines*180)
			DC.B "     Project One was developed by:",-2
			DC.B -2
			dc.b " Lead programmer:",-2
			DC.B "    Cyrano Jones/D-Bug (aka Mr Morden)",-2
			DC.B -2
			DC.B " Toolsets and additional code:",-2
			DC.B "             GGN/D-Bug (aka Promethea)",-2
			DC.B -2
			DC.B " Artwork, animation and map design:",-2
			DC.B "          SH3/Reservoir Gods (aka kZa)",-2
			DC.B -2
			DC.B " Music:",-2
			dc.b "                          Loader - 505",-2
			DC.B "                          Titles - 505",-2
			Dc.B "                         Level 1 - 505",-2 
			DC.B "                 Bad Moodies - Dubmood",-2
			DC.B -2
			DC.B " Voice Artists:",-2
			DC.B "             Vocals - Mrs Cyrano Jones",-2
			DC.B "               Laser FX - Jack The Dog",-2
			DC.B -2
			DC.B " Playtesters:",-2
			DC.B "                         Remo Williams",-2
			DC.B "                              ChrisTOS",-2
			DC.B "                                Sauron",-2
			DC.B -2
			DC.B " Reboot would like to thank...",-2
			DC.B -2
			DC.B " Remo Williams    (Loan of SkunkBoard)",-2
			DC.B " Axe of Delight              (PackICE)",-2
			DC.B " Sinister Developments     (DSP Audio)",-2
			DC.B " Tursi and kskunk         (SkunkBoard)",-2
			DC.B " Niels, Carwin, James, Adam  (VJaguar)",-2
			DC.B " The DOSBox Team              (DOSBox)",-2
			DC.B " Robin Burrows              (MappyW32)",-2
			DC.B " Reservoir Gods             (Godpaint)",-2
			DC.B " Anthony and Russell Hayward   (Steem)",-2
			DC.B " Don Ho                    (Notepad++)",-2
			DC.B -2
			DC.B " The entire Jagware team for their",-2
			DC.B " support and encouragement during the",-2
			dc.b " development of this game.",-2
			DC.B -2
			DC.b " You can hear more great music from",-2
			dc.b " Dubmood and other scene musicians",-2
			dc.b " at http://www.dataairlines.net",-2
			dc.b -2
			DC.B " This entire game is to be released",-2
			DC.B " freely, and is not to be sold for",-2
			dc.b " any monetary gain (Personal or",-2
			dc.b " otherwise) without the explicit",-2
			dc.b " written consent of Reboot.",-2
			DC.B -2
			DC.B " Please visit us at:",-2
			DC.B "             http://freejag.atari.org",-2
			DC.B "              http://reboot.atari.org",-2
			DC.B "               http://www.jagware.org",-2
			DC.B -2
			DC.B "   (C)2009 Reboot (Part of Jagware)",-1
			
					
                .dphrase
		
bss_top:		.dc.l 	0,0

ntsc_flag:		.dc.w	0

a_hdb:          .dc.w   0
a_hde:          .dc.w   0
a_vdb:          .dc.w   0
a_vde:          .dc.w   0
width:          .dc.w   0
height:         .dc.w   0
ticks:          .dc.l   0 

				.phrase

options_obj:	dc.l	0
display_obj:	dc.l	0
banner_obj:		dc.l	0
planet_obj:		dc.l	0
scroll_obj:		dc.l	0
scroll2_obj:	dc.l	0
overlay_obj:	dc.l	0
jagware_obj:	dc.l	0
ljagware_obj:	dc.l	0
highlight_obj:	dc.l	0
pressfire_objs:	dc.l	0,0,0,0,0,0,0,0,0
pressfire_bmps:	
				dc.l	presfi_bmp+64			; e
				dc.l	presfi_bmp+32			; r
				dc.l	presfi_bmp+160			; i
				dc.l	presfi_bmp+128			; f
				dc.l	presfi_bmp+96			; s
				dc.l	presfi_bmp+96			; s
				dc.l	presfi_bmp+64			; e
				dc.l	presfi_bmp+32			; r
				dc.l	presfi_bmp				; p				
				.phrase
display_bmp0:
				.rept	40*26
				.dc.b	0
				.endr
				.phrase
				
				.phrase
scroll_bmp:
				.rept	40*1200
				.dc.b	0
				.endr
				
jagpad_txt_bmp:
				.rept	40*9
				.dc.b	0
				.endr

				.phrase
banner_bmp:		incbin 	"16BIT/PROJECT1.J16"			; proj1c.jag
				.phrase
planet_bmp:		incbin "planet16.jag"
				.phrase
jagware_bmp:	incbin "JAGBOOTF.J16"				; jagboot.jag
				.phrase
presfi_bmp:		incbin "presfif.j16"
				.phrase
jagpad_bmp:		incbin 	"16BIT/jagpadf.j16"
				.phrase
dpad_bmp:		incbin 	"16BIT/DPAD.J16"
				.phrase
dpadb_bmp:		incbin 	"16BIT/B.J16"
				.phrase
dpada_bmp:		incbin 	"16BIT/A.J16"
				.phrase
dpadc_bmp:		incbin	"16BIT/C.J16"
				.phrase
dpad3_bmp:		incbin 	"16BIT/3.J16"
				.phrase
dpadp_bmp:		incbin 	"16BIT/PAUSE.J16"
				.phrase
dpadsh_bmp:		incbin 	"16BIT/STARHASH.J16"
				.phrase

				
overlay_bmp:
				.rept	48*256
				dc.b $ff
				.endr

_trashram:		
ascii:			
				.end




