;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;; "bAd M0oD!e5!" - A Jaguar Mini Game
;;
;; (Or PAUSE MODE for Project One - whatever you feel like calling it at the time)
;;
;; (c) reboot 2009
;; 

badmood_init:	move.l	a0,snake_playfield_obj				; store object address in table
				move.l	#snake_playfield_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #64,d1		                  		; height
                move.l  #64,d2             					; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#64,d5
                bsr     CreateObject

				move.l	a0,cycles_playfield_obj				; store object address in table
				move.l	#cycles_playfield_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #64,d1		                  		; height
                move.l  #64,d2             					; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#64,d5
                bsr     CreateObject

				move.l	a0,invaders_playfield_obj			; store object address in table
				move.l	#invaders_playfield_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #64,d1		                  		; height
                move.l  #64,d2             					; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#64,d5
                bsr     CreateObject
					
				move.w	#32,cycle_x
				move.w	#4,cycle_y
				clr.l	bonus_up
					
				move.l	#-1,snake_init						; tell snake to reset
				move.l	#-1,cycles_init						; tell cycles to reset
				move.l	#-1,invaders_init					; tell invaders to reset
				
				rts
				
moodies_loop:	lea		game1_x,a2							; setup Snake X/Y on rotation
				bsr		generate_d01
				move.l	snake_playfield_obj,a0
				add.l	#84,d0
				add.l	#32,d1
				bsr		setup_object_xy
			
				lea		game2_x,a2							; setup Cycles X/Y on rotation
				bsr		generate_d01
				move.l	cycles_playfield_obj,a0
				add.l	#84,d0
				add.l	#32,d1
				bsr		setup_object_xy
			
				lea		game3_x,a2							; setup Invader X/Y on rotation
				bsr		generate_d01
				move.l	invaders_playfield_obj,a0
				add.l	#84,d0
				add.l	#32,d1
				bsr		setup_object_xy

				bsr		snake_game							; snake thread
				bsr		cycles_game							; cycles thread
				bsr		invaders_game						; invaders thread
				
				add.w	#$1001,$f00400+(254*2)				; flash the food/bullet colour
				
				rts											; repeat to infinity

;;
;; Return X/Y in D0.W / D1.W for the rotation position
;;
				
generate_d01:	move.l	(a2),a0								; pointer to X-position in wave
				move.w	(a0),d0								; get next value
				add.w	wave_direction,a0
				cmp.l	#pause_end,a0						; end of wave?
				bne.s	.ok1
				lea		pause_wave,a0						; reset pointer
				move.w	(a0)+,d0	
				bra		.store
.ok1:			cmp.l	#pause_wave,a0
				bne.s	.store
				lea		pause_end+2,a0
				move.w	-(a0),d0

.store:			move.l	a0,(a2)								; store new pointer
				move.w	148(a0),d1							; y-value is 1/4 ahead in wave (circle)
				
				rts
				
;;
;; Space Invader_ Thread
;;				

invaders_game:	tst.l	invaders_init						; need to reset?
				beq		play_invaders						; branch if not
				
				lea		invaders_playfield_bmp,a0			; address of Invaders bitmap
				bsr		reset_bitmap						; clear it 
				
				move.w	#30,inv_ship_x						; player initial X-pos
				
				move.w	#4,inv_ali_x						; invader initial X-pos
				move.w	#4,inv_ali_y						; invader initial Y-pos
				move.w	#2,inv_ali_dir						; invader initial direction
				
				clr.l	invaders_init						; init done
				
				rts			
				
play_invaders:	moveq	#0,d7								; clear
				bsr		plot_inv_ship						; "draw" the ship (erase it)
				
				sub.w	#1,inv_ali_spd						; time to move invader?
				bpl.s	.no_move_yet
				move.w	#2,inv_ali_spd						; reset invader speed
				
				moveq	#0,d7								; clear
				bsr		plot_inv_ali						; "draw" the invader (erase it)
				
.left:			move.w	inv_ali_dir,d0						; Invader direction
				add.w	d0,inv_ali_x						; add to X
				cmp.w	#4,inv_ali_x						; left edge reached?
				bne.s	.right
				add.w	#2,inv_ali_y						; drop down a line
				neg.w	inv_ali_dir							; swap direction
				
.right:			cmp.w	#56,inv_ali_x						; right edge reached?
				bne.s	.bottom
				add.w	#2,inv_ali_y						; drop down a line
				neg.w	inv_ali_dir							; swap direction
				
.bottom:		cmp.w	#56,inv_ali_y						; bottom reached?
				bne.s	.still_going
				move.l	#-1,invaders_init					; reset game!
				rts
				
.still_going:	moveq	#-1,d7								; set
				bsr		plot_inv_ali						; draw the invader at new position
				
.no_move_yet:	tst.w	dpad_left							; pad left pressed?
				beq		.chk_right
				cmp.w	#4,inv_ship_x						; at edge?
				beq		.chk_right
				sub.w	#2,inv_ship_x						; move left

.chk_right:		tst.w	dpad_right							; pad right pressed?
				beq		.chk_fire
				cmp.w	#54,inv_ship_x						; at edge?
				beq		.chk_fire
				add.w	#2,inv_ship_x						; move right

.chk_fire:		tst.w	dpad_b								; pad fire pressed?
				beq		.plot_new_ship
				move.w	#50*30,pause_ticker
				tst.w	inv_bullet_live						; already firing?
				bpl		.plot_new_ship
				
				move.w	#1,inv_bullet_live					; new bullet live
				move.w	#54,inv_bullet_y					; at y-54
				move.w	inv_ship_x,d0						; get player x
				add.w	#2,d0								; add 2 (center)
				move.w	d0,inv_bullet_x						; at new X

.plot_new_ship:	moveq	#-1,d7								; set
				bsr		plot_inv_ship						; draw the invader

				tst.w	inv_bullet_live						; bullet active?
				bmi		.exit_invaders
				
				moveq	#0,d7								; clear
				move.w	inv_bullet_x,d0						; bullet x
				move.w	inv_bullet_y,d1						; bullet y
				bsr		plot_inv_bullet						; erase bullet

				cmp.w	#4,inv_bullet_y						; top of screen?
				bne.s	.no_remove_bult
				
				move.w	#-1,inv_bullet_live					; bullet inactive
				rts

.no_remove_bult:
				moveq	#-2,d7								; flash
				move.w	inv_bullet_x,d0						; get x
				sub.w	#2,inv_bullet_y						; adjust y (up)
				move.w	inv_bullet_y,d1						; store y
				bsr		plot_inv_bullet						; draw bullet
				tst.w	d0									; did it hit the invader?
				beq.s	.exit_invaders

.hit_invader:	move.l	#-1,invaders_init					; yes, reset game
				move.b	#$fd,hit_something					; add food in snake!

				move.l	#-2,cycles_init						; clear cycles maze
				neg.w	wave_direction						; change directions!

				move.l	$1008,a0
				add.l	#feedme_off,a0
				lea		$0,a1
				move.l	#feedme_len,d0	; sample length
				moveq	#0,d1			; looplength (unlooped)
				moveq	#40,d2			; priority (high)
				move.l	$1104,d3			; volume
				move.l	#$1ac,d4			; freq
				move.l	snake_length,d5
				subq	#2,d5
				asl.w	#3,d5
				add.w	d5,d4
				jsr		musicplayer+$c	
				
.exit_invaders:	rts											; all done
				
plot_inv_ali:	lea		invaders_playfield_bmp,a6			; address of bitmap
				add.w	inv_ali_x,a6						; add x
				move.w	inv_ali_y,d0						; get y
				asl.w	#6,d0								; *64
				add.w	d0,a6								; add y
				move.b	d7,(a6)								; plot invader shape
				move.b	d7,1(a6)
				move.b	d7,2(a6)
				move.b	d7,3(a6)
				move.b	d7,64(a6)
				move.b	d7,65(a6)
				move.b	d7,66(a6)
				move.b	d7,67(a6)
				rts
				
plot_inv_bullet:
				lea		invaders_playfield_bmp,a6			; address of bitmap
				add.w	d0,a6								; add x
				asl.w	#6,d1								; *64
				add.w	d1,a6								; add y
				move.b	(a6),d0								; get data at new position
				move.b	d7,(a6)								; plot bullet shape
				move.b	d7,1(a6)
				move.b	d7,64(a6)
				move.b	d7,65(a6)
				rts
				
plot_inv_ship:	lea		invaders_playfield_bmp,a6			; address of bitmap
				add.l	#64*57,a6							; add y
				add.w	inv_ship_x,a6						; add x
				move.b	d7,(a6)								; plot player shape
				move.b	d7,1(a6)
				move.b	d7,2(a6)
				move.b	d7,3(a6)
				move.b	d7,4(a6)
				move.b	d7,5(a6)
				move.b	d7,-62(a6)
				move.b	d7,-61(a6)
				move.b	d7,64(a6)
				move.b	d7,65(a6)
				move.b	d7,66(a6)
				move.b	d7,67(a6)
				move.b	d7,68(a6)
				move.b	d7,69(a6)
				rts

;;
;; Cycles Thread
;;
				
cycles_game:	tst.l	cycles_init							; need to reset?
				bpl		.play_cycle_game					; branch if not

				cmp.l	#1,bonus_up							; if bonus is up, do nothing
				beq.s	.do_nothing
				
				lea		cycles_playfield_bmp,a0				; address of cycles bitmap
				bsr		reset_bitmap						; clear it

				cmp.l	#-2,cycles_init						; reset bikes only?
				beq.s	.dont_reset_bike
				
				move.w	#32,cycle_x							; initial player x
				move.w	#4,cycle_y							; initial player y
				move.l	#1,.cycle_dir						; down

.dont_reset_bike:
				cmp.l	#-3,cycles_init						; add bonus object?
				bne.s	.do_nothing
	
				move.l	#1,bonus_up							; flag as bonus up
				bsr		.add_bonus							; plot a bonus

.do_nothing:	clr.l	cycles_init							; init done
				rts
								
.play_cycle_game:
				sub.l	#1,cycles_speed						; time to move?
				bmi.s	.play_cycles
				rts											; not yet, all done

.cycle_moves:	dc.w	0,-2
				dc.w	0,2
				dc.w	-2,0
				dc.w	2,0
.cycle_dir:		dc.l	1
				
.play_cycles:	move.l	#2,cycles_speed						; reset speed

.t_up:			tst.w	dpad_up
				beq.s	.t_down
				move.l	#0,.cycle_dir
				bra		.pad_done
.t_down:		tst.w	dpad_down
				beq.s	.t_left
				move.l	#1,.cycle_dir
				bra		.pad_done
.t_left:		tst.w	dpad_left
				beq.s	.t_right
				move.l	#2,.cycle_dir
				bra		.pad_done
.t_right:		tst.w	dpad_right
				beq.s	.pad_done
				move.l	#3,.cycle_dir
.pad_done:		move.l	.cycle_dir,d0
				asl.w	#2,d0
				lea		.cycle_moves(pc),a0
				move.w	2(a0,d0.w),d1
				move.w	(a0,d0.w),d0
				add.w	d0,cycle_x
				add.w	d1,cycle_y
				
				move.w	cycle_x,d0							; get x
				move.w	cycle_y,d1							; get y
				asl.w	#6,d1								; *64
				
				moveq	#0,d2
				lea		cycles_playfield_bmp,a0				; cycles bitmap address
				add.w	d0,a0								; add x
				add.w	d1,a0								; add y
				move.b 	(a0),d2								; get whats there

				tst.b	d2
				beq.s	.no_cols							; if clear, continue
				clr.l	bonus_up

				cmp.b	#$fe,d2
				beq.s	.pickup_bonus

.reset_cycles:
				move.l	#-1,cycles_init						; hit something, reset game
				rts

;						laser, shield, smart, blaster, life, blaster, side
				
.bonus_table:	dc.l	2,6,14,20,0,18,20,18
				
.pickup_bonus:	move.l	bonus_hit_flag,-(a7)
				move.l	bonus_hit_flag+4,-(a7)
				
				move.l	ticks,d1
				add.w	$f00004,d1
				and.l	#%111,d1
				asl.l	#2,d1
				lea		.bonus_table(pc),a0
				move.l	(a0,d1.w),bonus_hit_flag+4
				
				bsr		bonus_processing
				
				move.l	(a7)+,bonus_hit_flag+4
				move.l	(a7)+,bonus_hit_flag
				
				bra		.reset_cycles
				
.no_cols:		moveq	#-1,d6								; set
				move.b	d6,(a0)								; plot the cycle
				move.b	d6,1(a0)
				move.b	d6,64(a0)
				move.b	d6,65(a0)
				rts

.add_bonus:		move.w	ticks,d0							; generate random number
				move.w	$f00006,d1
				add.w	$f00004,d1
				
				and.l	#%110110,d0							; force 0-55 (even)
				and.l	#%110110,d1
				addq	#2,d0
				addq	#2,d1
							
				asl.w	#6,d1								; y*64

				lea		cycles_playfield_bmp+(64*2),a6	; top left gorner of game screen
				add.w	d0,a6								; add x
				add.w	d1,a6								; add y
				
				tst.b	(a6)								; anything there?
				bne		.add_bonus							; if if so, get another x/y
				
				move.b	#$fe,d0								; flash
				move.b	d0,(a6)								; plot food
				move.b	d0,1(a6)
				move.b	d0,64(a6)
				move.b	d0,65(a6)
				
				rts

				
;;
;; Snake Thread
;;				
				
snake_game:		tst.l	snake_init							; need to reset?
				beq		.play_snake							; branch if not
				
				lea		snake_playfield_bmp,a0				; address of snake bitmap
				bsr		reset_bitmap						; clear it
				
				clr.b	hit_something+1
				move.l	#2,snake_length						; reset snake length

				lea		snake_buffer,a0						; snake datapointer
				move.l	a0,snake_pointer					; reset pointer
				
				move.w	#32,(a0)+				; x			; setup first 3 snake body parts
				move.w	#32,(a0)+				; y
				move.w	#32,(a0)+				; x
				move.w	#34,(a0)+				; y
				move.w	#32,(a0)+				; x
				move.w	#36,(a0)+				; y
				
				move.l	#255,d7								; clear the reset of the buffer
.buffer:		clr.l	(a0)+
				dbra	d7,.buffer

				move.l	#1,snake_dir						; direction=DOWN
				move.l	#2,snake_speed						; speed
				
				clr.l	snake_init							; init done

				rts

.play_snake:	sub.l	#1,snake_speed						; time to move?
				bmi.s	.play_game							
				rts											; not yet, all done
				
.play_game:
				cmp.l	#22,snake_length
				bne.s	.not_three
				cmp.l	#3,numsamp_play
				beq.s	.not_three
				move.l	#3,numsamp_play
				move.l	#three_off,a0
				move.l	#three_len,d0
				bra		.donumsamp
.not_three:		cmp.l	#23,snake_length
				bne.s	.not_two
				cmp.l	#2,numsamp_play
				beq.s	.not_two
				move.l	#2,numsamp_play
				move.l	#two_off,a0
				move.l	#two_len,d0
				bra		.donumsamp
.not_two:		cmp.l	#24,snake_length
				bne.s	.no_num_samps
				cmp.l	#1,numsamp_play
				beq.s	.no_num_samps
				move.l	#1,numsamp_play
				move.l	#one_off,a0
				move.l	#one_len,d0
.donumsamp:		add.l	$1008,a0
				lea		$0,a1
				moveq	#0,d1			; looplength (unlooped)
				moveq	#40,d2			; priority (high)
				move.l	$1104,d3		; volume
				move.l	#$1ac,d4			; freq
				jsr		musicplayer+$c
.no_num_samps:				
				move.l	#2,snake_speed						; reset speed

				cmp.b	#$fe,hit_something+1				; did we hit food?
				bne		.no_grow_snake
				
				move.l	snake_length,d7						; add new position to snake chain
				lea		snake_buffer,a0
				asl.w	#2,d7
				add.w	d7,a0
				move.l	-4(a0),(a0)
				
				add.l	#1,snake_length						; increase length				

				cmp.l	#25,snake_length
				bne.s	.no_grow_snake
				clr.l	bonus_up
				move.l	#-3,cycles_init						; time for a bonus
				rts
				
.no_grow_snake:	cmp.b	#$fd,hit_something					; invader shot?
				bne.s	.no_add_food
				
				bsr		add_food
				clr.b	hit_something
				rts
				
.no_add_food:	cmp.b	#$ff,hit_something+1				; did we hit wall?
				bne		.not_dead
				
				move.l	#-1,snake_init						; reset game
				
				rts
				
.not_dead:		bsr		update_snake						; redraw the snake

.chk_up:		tst.w	dpad_up								; pad up?
				beq		.chk_down
				clr.l	snake_dir							; up!
				move.w	#50*30,pause_ticker
				rts
				
.chk_down:		tst.w	dpad_down							; pad down?
				beq.s	.chk_left
				move.l	#1,snake_dir						; down!
				move.w	#50*30,pause_ticker
				rts
				
.chk_left:		tst.w	dpad_left							; pad left?
				beq.s	.chk_right
				move.l	#2,snake_dir						; left!
				move.w	#50*30,pause_ticker
				rts
				
.chk_right:		tst.w	dpad_right							; pad right?
				beq.s	.chk_done
				move.l	#3,snake_dir						; right!
				move.w	#50*30,pause_ticker
				
.chk_done:		rts
				
update_snake:	bsr		.erase_tail							; erase last part
				bsr		.shuffle_snake						; shuffle table
	
				move.l	snake_dir,d0						; get direction
				asl.w	#2,d0								; *4
				lea		.snake_jump(pc),a0					; lookup table
				move.l	(a0,d0.w),a0
				jmp		(a0)
.snake_jump:	dc.l	.moveup
				dc.l	.movedown
				dc.l	.moveleft
				dc.l	.moveright

.moveup:		sub.w	#2,last_snake+2						; last head position
				bsr		.draw_head							; new head
				rts

.movedown:		add.w	#2,last_snake+2						; as above
				bsr		.draw_head
				rts
				
.moveleft:		sub.w	#2,last_snake						; as above
				bsr		.draw_head
				rts
				
.moveright:		add.w	#2,last_snake						; as above
				bsr		.draw_head
				rts
				
.erase_tail:	lea		snake_buffer,a0						; x/y buffer list
				move.l	a0,a1
				move.w	(a0)+,d0							; x
				move.w	(a0)+,d1							; y
				asl.l	#6,d1								; *64
				lea		snake_playfield_bmp,a6				; playfield bitmap
				add.w	d1,a6								; add x
				add.w	d0,a6								; add y
				clr.b	(a6)								; erase tail
				clr.b	1(a6)
				clr.b	64(a6)
				clr.b	65(a6)
				rts
				
.shuffle_snake:	lea		snake_buffer+4,a0					; 2nd entry
				lea		snake_buffer,a1						; 1st entry
				move.l	snake_length,d7						; length of snake
				subq	#2,d7								; -1 (for dbra) -1 for head
.shuffle:		move.w	(a0)+,d0							; get x/y
				move.w	(a0)+,d1
				move.w	d0,(a1)+							; store it again
				move.w	d1,(a1)+
				bsr		.draw_body							; draw the body @x/y
				dbra	d7,.shuffle							; loop for all
				
				move.l	a1,snake_head						; pointer to head
				move.l	-4(a0),last_snake					; x/y of current head
				
				rts

.draw_body:		lea		snake_playfield_bmp,a6				; address of bitmap
				asl.w	#6,d1								; y*64
				add.w	d0,a6								; add x
				add.w	d1,a6								; add y
				
				moveq	#-1,d0								; plot body
				move.b	d0,(a6)
				move.b	d0,(a6)
				move.b	d0,1(a6)
				move.b	d0,64(a6)
				move.b	d0,65(a6)
				rts				
				
.draw_head:		lea		snake_playfield_bmp,a6				; address of bitmap
				move.w	last_snake,d0						; last head position x
				move.w	last_snake+2,d1						; last head position y
				move.l	snake_head,a1						; store this one
				move.w	d0,(a1)+
				move.w	d1,(a1)
				asl.w	#6,d1								; y*64
				add.w	d0,a6								; add x
				add.w	d1,a6								; add y
				move.b	(a6),hit_something+1				; get contents of pixel
				moveq	#-1,d0
				move.b	d0,(a6)								; plot head
				move.b	d0,1(a6)
				move.b	d0,64(a6)
				move.b	d0,65(a6)
				rts

add_food:		move.w	ticks,d0							; generate random number
				move.w	$f00006,d1
				add.w	$f00004,d1

				divu	#29,d0								; div 29
				swap	d0									; get remainder
				add.w	d0,d0								; *2
								
				divu	#29,d1								; div 29
				swap	d1									; get remainder
				add.w	d1,d1								; *2
				
				asl.w	#6,d1								; y*64
				
				lea		snake_playfield_bmp+(64*2)+2,a6		; top left gorner of game screen
				add.w	d0,a6								; add x
				add.w	d1,a6								; add y
				
				tst.b	(a6)								; anything there?
				bne		add_food							; if if so, get another x/y
				
				move.b	#$fe,d0								; flash
				move.b	d0,(a6)								; plot food
				move.b	d0,1(a6)
				move.b	d0,64(a6)
				move.b	d0,65(a6)
				
				rts

;;
;; Reset the bitmap to a box
;;
				
reset_bitmap:
				move.l	#$ffffffff,d0
				move.l	#$ffff0000,d1
				move.l	#$0000ffff,d2
				moveq	#0,d3
				move.l	d3,a1
				move.l	d3,a2
				move.l	d3,a3
				move.l	d3,a4
				move.l	d3,a5
				move.l	d3,a6
				
				lea		64*64(a0),a0
				
				.rept 	32
				move.l	d0,-(a0)
				.endr

				.rept 60
				move.l	d2,-(a0)
				movem.l	d3/a1-a6,-(a0)
				movem.l	d3/a1-a6,-(a0)
				move.l	d1,-(a0)
				.endr
				
				.rept	32
				move.l	d0,-(a0)
				.endr
				
				rts





