;;;;;;;;;;;;;;
;;;;;;;;;;;;;; ENEMY TYPE DATA
;;;;;;;;;;;;;;

thread_64x32	equ	0
thread_32x32	equ 1
thread_16x16	equ	2
thread_bonus	equ 3
thread_32x32_2	equ 4
thread_16x16_2	equ	5

enemy_lookup:	dc.l	E_00		; *Tron Constructor				 	; 0
				dc.l	E_01		; *Spin Fighter						; 1
				dc.l	E_02		; *Vertical Attack Ship				; 2
				dc.l	E_03		; *16x16 fighter					; 3
				dc.l	BOSSHAT		; End Boss Hat						; 4
				dc.l	BN00		; *gun powerup						; 5
				dc.l	BN01		; *laser powerup					; 6
				dc.l	E_05		; *Vertical Attack Ship (alt wave)	; 7
				dc.l	E_06		; *16x16 fighter (alt wave)			; 8
				dc.l	E_07		; *45 Turret (Left)					; 9
				dc.l	E_08		; *45 Turret (Right)				; 10
				dc.l	BN02		; *smartbomb_powerup				; 11
				dc.l	BN03		; *shield_powerup					; 12
				dc.l	MIDBOSS01	; Mid Boss							; 13
				dc.l	MIDBOSS02	; Mid Boss Protectors (16x16)		; 14
				dc.l	BN04		; *sideshot							; 15
				dc.l	BN05		; *extra life						; 16
				dc.l	E_09		; *16x16 triangle					; 17
				dc.l	E_0A		; *16x16 spin						; 18
				dc.l	E_0B		; *square turret					; 19
				dc.l	E_09B		; *16x16 triangle (alt wave)		; 20
				dc.l	E_0AB		; *16x16 spin (alt wave)			; 21
				dc.l	E_0BB		; *square turret	(alt wave)		; 22
				dc.l	E_02B		; Vertical Attack Ship (alt wave)	; 23		
				dc.l	EBLOB		; End of Level Boss Blob (bonuswave); 24
				dc.l	E_0AC		; *16x16 spin (2nd dupe -tougher)	; 25
				dc.l	E_0AD		; *16x16 spin(dupe) (2nd dupe)		; 26
				dc.l	ENDBOSS_DIE	; endboss explosion					; 27
				
;;
;; 64x32 E0 (Tron type Constructor)  *xy checked*
;;
				
E_00:			dc.l	enemy00_bmp			;00 pointer to first frame
				dc.l	thread_64x32		;04 THREAD 0 (64x32)
				dc.l	64/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	11					;20 last frame of firing animation frames
				dc.l	23					;24 frame number of destroyed frame
				dc.l	28					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (was 3)
				dc.l	23					;52 x offset to generate bullet at
				dc.l	20					;56 y offset to generate bullet at
				dc.l	32					;60 x-offset to collision center
				dc.l	18					;64 y-offset to collision center
				dc.l	26					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	4					;80 hits till dead (2)
				dc.l	(64/2)*32			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy00_pal			;96 pointer to pallette
				dc.l	$f00400+(32*15)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0030"				;120 score for killing it (BCD)
				dc.l	0					;124 first frame of animation

;;
;; 64x32 E1 (SpinFighter Constructor)  *xy checked*
;;
				
E_01:			dc.l	enemy01_bmp			;00 pointer to first frame
				dc.l	thread_64x32		;04 THREAD 0 (64x32)
				dc.l	64/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	14					;20 last frame of firing animation frames
				dc.l	30					;24 frame number of destroyed frame
				dc.l	36					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	9					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (2)
				dc.l	18					;52 x offset to generate bullet at
				dc.l	22					;56 y offset to generate bullet at
				dc.l	32					;60 x-offset to collision center
				dc.l	20					;64 y-offset to collision center
				dc.l	30					;68 pixels either side of CC=hit (x)
				dc.l	18					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	6					;80 hits till dead (3)
				dc.l	(64/2)*32			;84 bytes per frame
				dc.l	1					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy01_pal			;96 pointer to pallette
				dc.l	$f00400+(32*15)		;100 final 16 colours
				dc.l	14					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	1					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0045"				;120 score for killing it
				dc.l	0					;124 first frame of animation

;;
;; 32x32 E2 (Vertical Attack Ship)  *xy checked*
;;
				
E_02:			dc.l	enemy02_bmp			;00 pointer to first frame
				dc.l	thread_32x32		;04 THREAD 0 (64x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	24					;24 frame number of destroyed frame
				dc.l	31					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (was 4)
				dc.l	12					;52 x offset to generate bullet at
				dc.l	29					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	18					;64 y-offset to collision center
				dc.l	20					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	2					;88 animation speed (5)
				dc.l	4					;92 damage to player on contact
				dc.l	enemy02_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0010"				;120 score for killing it
				dc.l	0					;124 first frame of animation

;;
;; 16x16 E3 *xy checked*
;;
				
E_03:			dc.l	enemy03_bmp			;00 pointer to first frame
				dc.l	thread_16x16		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	20					;24 frame number of destroyed frame
				dc.l	24					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	4					;48 bullet type
				dc.l	-4					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	10					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	1					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	3					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy03_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	10					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	3					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0005"				;120 score for killing it
				dc.l	0					;124 first frame of animation

;;
;; End Boss Hat
;;
				
BOSSHAT:		dc.l	bosshat_bmp			;00 pointer to first frame
				dc.l	thread_64x32		;04 THREAD 0 (64x32)
				dc.l	64/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	0					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	1					;24 frame number of destroyed frame
				dc.l	7					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type (was 3)
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	32					;60 x-offset to collision center
				dc.l	18					;64 y-offset to collision center
				dc.l	26					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	150					;80 hits till dead (2)
				dc.l	(64/2)*32			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	100					;92 damage to player on contact
				dc.l	bosshat_pal			;96 pointer to pallette
				dc.l	$f00400+(32*15)		;100 final 16 colours
				dc.l	2					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"5000"				;120 score for killing it (BCD)
				dc.l	0					;124 first frame of animation

				
;;
;; BONUS TYPE 0 (16x16) - GUN UPGRADE

BN00:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	23					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	20					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	20					;124 first frame of animation

				;;
;; BONUS TYPE 0 (16x16) - LASER

BN01:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	5					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	2					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	2					;124 first frame of animation
								
;;
;; 32x32 E2 (Vertical Attack Ship)  *xy checked*  (DUPED FOR 2nd THREAD)
;;
				
E_05:			dc.l	enemy02_bmp			;00 pointer to first frame
				dc.l	thread_32x32_2		;04 THREAD 5 (32x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	24					;24 frame number of destroyed frame
				dc.l	31					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (was 4)
				dc.l	12					;52 x offset to generate bullet at
				dc.l	29					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	18					;64 y-offset to collision center
				dc.l	20					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy02_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0010"				;120 score for killing it
				dc.l	0					;124 first frame of animation

; xy checked
				
E_06:			dc.l	enemy03_bmp			;00 pointer to first frame
				dc.l	thread_16x16_2		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	20					;24 frame number of destroyed frame
				dc.l	24					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	4					;48 bullet type
				dc.l	-4					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	10					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	1					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	3					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy03_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	10					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	3					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0005"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; 32x32 (45 turret LEFT) *xy checked*
;;
				
E_07:			dc.l	enemy07_bmp			;00 pointer to first frame
				dc.l	thread_32x32		;04 THREAD 0 (64x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	4					;16 frames in main animation loop
				dc.l	7					;20 last frame of firing animation frames
				dc.l	12					;24 frame number of destroyed frame
				dc.l	18					;28 last frame of frames in destroyed animation
				dc.l	3					;32 main sequence frame to shoot on
				dc.l	4					;36 first frame of firing animation
				dc.l	4					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	10					;48 bullet type
				dc.l	12					;52 x offset to generate bullet at
				dc.l	29					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	24					;64 y-offset to collision center
				dc.l	14					;68 pixels either side of CC=hit (x)
				dc.l	19					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy07_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	6					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	-1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0050"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; 32x32 (45 turret right) *xy checked*
;;
				
E_08:			dc.l	enemy08_bmp			;00 pointer to first frame
				dc.l	thread_32x32_2		;04 THREAD 0 (64x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	4					;16 frames in main animation loop
				dc.l	7					;20 last frame of firing animation frames
				dc.l	12					;24 frame number of destroyed frame
				dc.l	18					;28 last frame of frames in destroyed animation
				dc.l	3					;32 main sequence frame to shoot on
				dc.l	4					;36 first frame of firing animation
				dc.l	4					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	11					;48 bullet type
				dc.l	-10					;52 x offset to generate bullet at
				dc.l	28					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	24					;64 y-offset to collision center
				dc.l	14					;68 pixels either side of CC=hit (x)
				dc.l	19					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy08_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	6					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	-1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0050"		  		;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; BONUS TYPE 2 (16x16) - smartbomb UPGRADE

BN02:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	17					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	14					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	14					;124 first frame of animation

				;;
;; BONUS TYPE 0 (16x16) - shield

BN03:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	13					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	6					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	6					;124 first frame of animation
											
;;
;; 64x32 Midboss Core Object
;;
				
MIDBOSS01:		dc.l	midboss01_bmp		;00 pointer to first frame
				dc.l	thread_64x32		;04 THREAD 0 (64x32)
				dc.l	64/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	3					;16 frames in main animation loop
				dc.l	5					;20 last frame of firing animation frames
				dc.l	6					;24 frame number of destroyed frame
				dc.l	14					;28 last frame of frames in destroyed animation
				dc.l	1					;32 main sequence frame to shoot on
				dc.l	2					;36 first frame of firing animation
				dc.l	2					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (homing)
				dc.l	15					;52 x offset to generate bullet at
				dc.l	5					;56 y offset to generate bullet at
				dc.l	28					;60 x-offset to collision center
				dc.l	16					;64 y-offset to collision center
				dc.l	15					;68 pixels either side of CC=hit (x)
				dc.l	10					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	25					;80 hits till dead
				dc.l	(64/2)*32			;84 bytes per frame
				dc.l	10					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	midboss01_pal		;96 pointer to pallette
				dc.l	$f00400+(32*15)		;100 final 16 colours
				dc.l	6					;104 hit frame (flash)
				dc.l	4					;108 damage to player from bullet
				dc.l	10					;112 animation speed after looping
				dc.l	-1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0500"				;120 score for killing it (BCD)
				dc.l	0					;124 first frame of animation
												
;;
;; 16x16 Midboss Protector Ships
;;
				
MIDBOSS02:		dc.l	midboss02_bmp		;00 pointer to first frame
				dc.l	thread_16x16		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	15					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	30					;24 frame number of destroyed frame
				dc.l	39					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	6					;68 pixels either side of CC=hit (x)
				dc.l	6					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	65535				;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	3					;92 damage to player on contact
				dc.l	midboss02_pal		;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	15					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0050"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; BONUS TYPE 4 (16x16) - sideshot UPGRADE

BN04:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	19					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	18					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	19					;124 first frame of animation

				;;
;; BONUS TYPE 5 (16x16) - life

BN05:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	1					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	0					;124 first frame of animation
									
;;
;; 16x16 trinagle *xy checked*
;;
				
E_09:			dc.l	enemy09_bmp			;00 pointer to first frame
				dc.l	thread_16x16		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	5					;16 frames in main animation loop
				dc.l	7					;20 last frame of firing animation frames
				dc.l	16					;24 frame number of destroyed frame
				dc.l	20					;28 last frame of frames in destroyed animation
				dc.l	4					;32 main sequence frame to shoot on
				dc.l	5					;36 first frame of firing animation
				dc.l	5					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	4					;48 bullet type
				dc.l	-8					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	6					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	1					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	3					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy09_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	8					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	3					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0005"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; 16x16 spin *xy checked*
;;
				
E_0A:			dc.l	enemy0A_bmp			;00 pointer to first frame
				dc.l	thread_16x16		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	11					;16 frames in main animation loop
				dc.l	13					;20 last frame of firing animation frames
				dc.l	26					;24 frame number of destroyed frame
				dc.l	37					;28 last frame of frames in destroyed animation
				dc.l	10					;32 main sequence frame to shoot on
				dc.l	11					;36 first frame of firing animation
				dc.l	11					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type
				dc.l	-8					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	10					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	1					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy0A_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	8					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0005"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; 32x32 (square turret)
;;
				
E_0B:			dc.l	enemy0B_bmp			;00 pointer to first frame
				dc.l	thread_32x32		;04 THREAD 0 (64x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	20					;24 frame number of destroyed frame
				dc.l	24					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	7					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type
				dc.l	4					;52 x offset to generate bullet at
				dc.l	12					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	16					;64 y-offset to collision center
				dc.l	14					;68 pixels either side of CC=hit (x)
				dc.l	14					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy0B_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	100					;112 animation speed after looping
				dc.l	-1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0050"				;120 score for killing it
				dc.l	0					;124 first frame of animation

;;
;; 16x16 trinagle *xy checked*
;;
				
E_09B:			dc.l	enemy09_bmp			;00 pointer to first frame
				dc.l	thread_16x16_2		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	5					;16 frames in main animation loop
				dc.l	7					;20 last frame of firing animation frames
				dc.l	16					;24 frame number of destroyed frame
				dc.l	20					;28 last frame of frames in destroyed animation
				dc.l	4					;32 main sequence frame to shoot on
				dc.l	5					;36 first frame of firing animation
				dc.l	5					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	4					;48 bullet type
				dc.l	-8					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	6					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	1					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	3					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy09_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	8					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	3					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0005"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; 16x16 spin *xy checked*
;;
				
E_0AB:			dc.l	enemy0A_bmp			;00 pointer to first frame
				dc.l	thread_16x16_2		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	11					;16 frames in main animation loop
				dc.l	13					;20 last frame of firing animation frames
				dc.l	26					;24 frame number of destroyed frame
				dc.l	37					;28 last frame of frames in destroyed animation
				dc.l	10					;32 main sequence frame to shoot on
				dc.l	11					;36 first frame of firing animation
				dc.l	11					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type
				dc.l	-8					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	10					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	1					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy0A_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	8					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0005"				;120 score for killing it
				dc.l	0					;124 first frame of animation
				
;;
;; 32x32 (square turret)
;;
				
E_0BB:			dc.l	enemy0B_bmp			;00 pointer to first frame
				dc.l	thread_32x32_2		;04 THREAD 0 (64x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	20					;24 frame number of destroyed frame
				dc.l	24					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	7					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type
				dc.l	4					;52 x offset to generate bullet at
				dc.l	12					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	16					;64 y-offset to collision center
				dc.l	14					;68 pixels either side of CC=hit (x)
				dc.l	14					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy0B_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	100					;112 animation speed after looping
				dc.l	-1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0050"				;120 score for killing it
				dc.l	0					;124 first frame of animation
								
;;
;; 32x32 E2 (Vertical Attack Ship)  ***VERIFIED CORRECT***
;;
				
E_02B:			dc.l	enemy02_bmp			;00 pointer to first frame
				dc.l	thread_32x32_2		;04 THREAD 0 (64x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	7					;16 frames in main animation loop
				dc.l	9					;20 last frame of firing animation frames
				dc.l	24					;24 frame number of destroyed frame
				dc.l	31					;28 last frame of frames in destroyed animation
				dc.l	6					;32 main sequence frame to shoot on
				dc.l	7					;36 first frame of firing animation
				dc.l	7					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (was 4)
				dc.l	12					;52 x offset to generate bullet at
				dc.l	29					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	18					;64 y-offset to collision center
				dc.l	20					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy02_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0010"				;120 score for killing it
				dc.l	0					;124 first frame of animation
	
;;
;; BONUS TYPE 0 (16x16) - GUN UPGRADE

EBLOB:			dc.l	bonus_bmp			;00 pointer to first frame
				dc.l	thread_bonus		;04 THREAD 3 (BONUS 16x16)
				dc.l	32					;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	24					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	9					;24 frame number of destroyed frame
				dc.l	9					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	24					;44 frame to return to on amination complete
				dc.l	999					;48 bullet type
				dc.l	999					;52 x offset to generate bullet at
				dc.l	999					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	8					;64 y-offset to collision center
				dc.l	7					;68 pixels either side of CC=hit (x)
				dc.l	7					;72 pixels either side of CC=hit (y)
				dc.l	999					;76 firing vulnerability
				dc.l	999					;80 hits till dead
				dc.l	(32)*16				;84 bytes per frame
				dc.l	4					;88 animation speed
				dc.l	999					;92 damage to player on contact
				dc.l	999					;96 pointer to pallette
				dc.l	999					;100 final 16 colours
				dc.l	999					;104 hit frame (flash)
				dc.l	999					;108 damage to player from bullet
				dc.l	4					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.l	0					;120 score for killing it
				dc.l	24					;124 first frame of animation

;;
;; 16x16 spin *xy checked*
;;
				
E_0AC:			dc.l	enemy0A_bmp			;00 pointer to first frame
				dc.l	thread_16x16		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	11					;16 frames in main animation loop
				dc.l	13					;20 last frame of firing animation frames
				dc.l	26					;24 frame number of destroyed frame
				dc.l	37					;28 last frame of frames in destroyed animation
				dc.l	10					;32 main sequence frame to shoot on
				dc.l	11					;36 first frame of firing animation
				dc.l	11					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	10					;48 bullet type
				dc.l	-8					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	10					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	40					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy0A_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	8					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0025"				;120 score for killing it
				dc.l	0					;124 first frame of animation

;;
;; 16x16 spin *xy checked*
;;
				
E_0AD:			dc.l	enemy0A_bmp			;00 pointer to first frame
				dc.l	thread_16x16_2		;04 THREAD 0 (16x16)
				dc.l	16/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	11					;16 frames in main animation loop
				dc.l	13					;20 last frame of firing animation frames
				dc.l	26					;24 frame number of destroyed frame
				dc.l	37					;28 last frame of frames in destroyed animation
				dc.l	10					;32 main sequence frame to shoot on
				dc.l	11					;36 first frame of firing animation
				dc.l	11					;40 frame number to generate bullet on
				dc.l	0					;44 frame to return to on amination complete
				dc.l	11					;48 bullet type
				dc.l	-8					;52 x offset to generate bullet at
				dc.l	6					;56 y offset to generate bullet at
				dc.l	8					;60 x-offset to collision center
				dc.l	10					;64 y-offset to collision center
				dc.l	10					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	40					;80 hits till dead
				dc.l	(16/2)*16			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy0A_pal			;96 pointer to pallette
				dc.l	$f00400+(32*13)		;100 final 16 colours
				dc.l	8					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	0					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0025"				;120 score for killing it
				dc.l	0					;124 first frame of animation
	
;;
;; 32x32 E2 (Vertical Attack Ship)  *xy checked*  (DUPED FOR 2nd THREAD)
;;
				
ENDBOSS_DIE:	dc.l	enemy02_bmp			;00 pointer to first frame
				dc.l	thread_32x32_2		;04 THREAD 5 (32x32)
				dc.l	32/2				;08 ( offset to next line in frame)
				dc.l	0					;12 Animation Phase flag
				dc.l	31					;16 frames in main animation loop
				dc.l	999					;20 last frame of firing animation frames
				dc.l	999					;24 frame number of destroyed frame
				dc.l	999					;28 last frame of frames in destroyed animation
				dc.l	999					;32 main sequence frame to shoot on
				dc.l	999					;36 first frame of firing animation
				dc.l	999					;40 frame number to generate bullet on
				dc.l	24					;44 frame to return to on amination complete
				dc.l	12					;48 bullet type (was 4)
				dc.l	12					;52 x offset to generate bullet at
				dc.l	29					;56 y offset to generate bullet at
				dc.l	16					;60 x-offset to collision center
				dc.l	18					;64 y-offset to collision center
				dc.l	20					;68 pixels either side of CC=hit (x)
				dc.l	16					;72 pixels either side of CC=hit (y)
				dc.l	0					;76 firing vulnerability
				dc.l	3					;80 hits till dead
				dc.l	(32/2)*32			;84 bytes per frame
				dc.l	2					;88 animation speed
				dc.l	4					;92 damage to player on contact
				dc.l	enemy02_pal			;96 pointer to pallette
				dc.l	$f00400+(32*14)		;100 final 16 colours
				dc.l	12					;104 hit frame (flash)
				dc.l	2					;108 damage to player from bullet
				dc.l	2					;112 animation speed after looping
				dc.l	1					;116 0=Stop when deathanim -1=move when deathanim
				dc.b	"0010"				;120 score for killing it
				dc.l	24					;124 first frame of animation
	
				
				
	