;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;;
;; Add a new bullet
;;

; r18	; OL AND mask
; r19	; address of object
; r20	; long of object holding bitmap
; r22	; const: #99
; r23	; JUMP: homing_bullet
; r24
; r25
	
; r4
; r5
; r6
; r7
; r8
; r12
; r13
; r16
	
add_bullet_GPU:	movei	#stop_gpu,r3
				movei	#homing_bullet,r23
				movei	#99,r22
				movei	#%00000000000000000000011111111111,r18	; OL mask

GPU_bullet:		movei	#new_bullet_type,r14			; pointer to bullet type
				movei	#bullet_lookup,r15				; pointer to bullet lookup
				movei	#new_bullet_owner,r27			
				load	(r14),r14						; put bullet type in R14
				shlq	#2,r14
				
				load	(r15+r14),r14					; make R14 pointer to bullet type data
				
				movei	#new_bullet_type+4,r26
				load	(r14),r21						; bitmap of bullet
				
				load	(r26),r10						; get new x
				addq	#4,r26
				load	(r26),r11						; get new Y

				shlq	#8,r21
				
				load	(r14+2),r30						; bullets in pattern
				load	(r14+3),r1						; pointer to pattern data
				
				cmp		r22,r30							; 99 bullets = homing
				jr		NE,normal_bullet
				nop
				jump	(r23)
				nop
normal_bullet:
				movei	#bullets,r14				; Pointer into bullet table

				movei	#max_bullets,r9
				load	(r27),r27
				movei	#find_free,r2

find_free:		load	(r14+(bullet_use/4)),r26	; get bullet in use flag
				cmpq	#0,r26
				jr		EQ,found_bullet
				nop
				addq	#32,r14						; next bullet
				subq	#1,r9
				jump	NE,(r2)						; loop all bullets in table
				nop
				jump	T,(r3)						; then exit

found_bullet:	move	r10,r17						; dupe X  (r11=y)
				load	(r14+(bullet_obj/4)),r19	; address of object
				addq	#13,r17
				store	r27,(r14+(bullet_use/4))	; mark as in use
				load	(r19),r20					; get long with bitmap
				and		r18,r20
				store	r17,(r14+(bullet_x/4))		; store new x
				or		r21,r20
				store	r11,(r14+(bullet_y/4))		; store new y
				store	r20,(r19)
				
				move	r30,r28						; WEAPON POWER
				shlq	#3,r28
				add		r1,r28						; table entry for bullet power
				load	(r28),r26

				store	r26,(r14+(bullet_xadd/4))	; store new x-add
				addq	#4,r28
				load	(r28),r26
				store	r26,(r14+(bullet_yadd/4))	; store new y-add
				
				addq	#32,r14						; next bullet
				
				subq	#1,r30						; bullets in POWER
				jump	PL,(r2)						; loop all bullets in table
				nop
				jump	T,(r3)						; JUMP exit
				nop

; r4
; r5
; r6
; r7
; r8
; r10 - x (new bullet)
; r11 - y (new bullet)
; r12
; r13
; r16				
			
homing_bullet:
				movei	#ship_x,r4
				movei	#ship_y,r5
				loadw	(r4),r4				; ship x
				loadw	(r5),r5				; ship y
				
				moveta	r4,r4
				moveta	r5,r5

				sub		r10,r4
				sub		r11,r5
				abs		r4					; diff to x
				abs		r5					; diff to y
				
				move	r4,r6
				move	r5,r7

				sharq	#6,r6
				sharq	#5,r7

				movefa	r4,r4
				movefa	r5,r5
				
				cmp		r4,r10
				jr		CS,.posx_dif
				nop
.negx_dif:		neg		r6
.posx_dif:		cmp		r5,r11
				jr		CC,.posy_dif
				nop
.negy_dif:		neg		r7
.posy_dif:		movei	#homing_pattern,r1
				move	r1,r14
				move	r6,r5
				add		r7,r5
				cmpq	#0,r5
				jump	EQ,(r3)
				nop
				cmpq	#-1,r7
				jr		NE,.not_scrl_speed
				nop
				subq	#1,r7
.not_scrl_speed:
				store	r6,(r14)
				store	r7,(r14+1)
				moveq	#0,r30
				movei	#normal_bullet,r14
				jump	(r14)
				nop
				
				