;; GPU Bullet Y-Sorting (For OL Mashing)
;;


GPU_bullet_sort:
			movei	#y060_100,r21		; pointer to sort buffer #1
			movei	#y101_140,r22
			movei	#y141_180,r23
			movei	#y181_220,r24
			movei	#y221_256,r25

			movei	#bullets,r0			; pointer to bullet data
			movei	#max_bullets,r31	; bullet counter
			
			movei	#60,r1				; cull points
			movei	#100,r2
			movei	#140,r3
			movei	#180,r4
			movei	#220,r5
			movei	#256+4,r6
			movei	#.next_bullet,r7

			movei	#.sort,r30

			movei	#_GPUSETUP_REGS,r15
			jump	(r15)
			nop
			
.sort:		move	r0,r15					; current object
			load	(r15+(bullet_y/4)),r10	; y-value
			load	(r15+(bullet_obj/4)),r28	; actual shadow object address
			
			jump	(r20)
			nop
			
.next_bullet:
			addq	#32,r0
			subq	#1,r31
			jump	ne,(r30)			; .sort
			nop
			nop
			movei	#.return,r0
			movei	#_GPU_fixuptables,r1
			jump	(r1)
			nop
.return:
			movei	#branch60,r0		; pointer to previous object
			load	(r0),r0				; shadow branch <100
.range060:	load	(r21),r1			; get first address
			cmpq	#0,r1
			jr		MI,.range100_start	; end of table?
			nop
			movei	#.r60ret,r19		; update link pointers
			jump	(r18)
.r60ret:	nop
			move	r1,r0				; update "previous object"
			addqt	#4,r21				; next in table (executed after JR)
			jr		.range060
			nop
			
.range100_start:
			movei	#ship_obj,r1
			load	(r1),r1
			movei	#.term1,r19
			jump	(r18)
.term1:
			movei	#branch100,r0		; pointer to previous object
			load	(r0),r0
.range100:
			load	(r22),r1			; get first address
			cmpq	#0,r1
			jr		MI,.range140_start
			nop
			movei	#.r100ret,r19
			jump	(r18)
.r100ret:	nop
			move	r1,r0				; update "previous object"
			addqt	#4,r22				; next in table
			jr		.range100
			nop
			
.range140_start:
			movei	#ship_obj,r1
			load	(r1),r1
			movei	#.term2,r19
			jump	(r18)
.term2:
			movei	#branch140,r0		; pointer to previous object
			load	(r0),r0
.range140:
			load	(r23),r1			; get first address
			cmpq	#0,r1
			jr		MI,.range180_start
			nop
			movei	#.r140ret,r19
			jump	(r18)
.r140ret:	nop
			move	r1,r0				; update "previous object"
			addqt	#4,r23				; next in table
			jr		.range140
			nop
			
.range180_start:
			movei	#ship_obj,r1
			load	(r1),r1
			movei	#.term3,r19
			jump	(r18)
.term3:

			movei	#branch180,r0		; pointer to previous object
			load	(r0),r0
.range180:
			load	(r24),r1			; get first address
			cmpq	#0,r1
			jr		MI,.range220_start
			nop
			movei	#.r180ret,r19
			jump	(r18)
.r180ret:	nop
			move	r1,r0				; update "previous object"
			addqt	#4,r24				; next in table
			jr		.range180
			nop
			
.range220_start:
			movei	#ship_obj,r1
			load	(r1),r1
			movei	#.term4,r19
			jump	(r18)
.term4:

			movei	#branch220,r0		; pointer to previous object
			load	(r0),r0
.range220:
			load	(r25),r1			; get first address
			cmpq	#0,r1
			jr		MI,.range_done
			nop
			movei	#.r220ret,r19
			jump	(r18)
.r220ret:	nop
			move	r1,r0				; update "previous object"
			addqt	#4,r25				; next in table
			jr		.range220
			nop
			
.range_done:
			movei	#ship_obj,r1
			load	(r1),r1
			movei	#.allret,r19
			jump	(r18)
.allret:	nop

			movei	#stop_gpu,r0
			jump	(r0)				; stop the GPU
			nop		
			nop

_GPUobject_update:
			movei	#%11111000000000000000000011111111,r29	; mask
			movei	#$fffffff8,r28
			movei	#ob_list1,r27
			movei	#ob_list,r26
			
			move	r1,r12			; copy destination
			sub		r27,r12			; subtract shadow OL base
			add		r26,r12			; add active OL base
			and		r28,r12			; kill low bits
			shlq	#5,r12			; shift to correct position

			move	r0,r13			; address of current object (shadow)
			moveq	#0,r16
			moveq	#0,r17
			addq	#2,r13
			loadw	(r13),r16
			addq	#2,r13
			loadw	(r13),r17
			shlq	#16,r16
			or		r16,r17			; longword with LINK
			
			and		r29,r17			; punch out old LINK
			or		r12,r17			; store new LINK
			
			storew	r17,(r13)
			subq	#2,r13
			shrq	#16,r17
			storew	r17,(r13)
			
			jump	(r19)
			nop
			nop

xb060:		movei	#b060,r14
			jump	(r14)
			nop

			
_GPU_CHECK_LOOP:
			cmp		r10,r1				; "above" screen?
			jump	cc,(r7)
			cmp		r10,r2
			jr		cc,xb060				; its in zone 1
			cmp		r10,r3
			jr		cc,.b100
			cmp		r10,r4
			jr		cc,.b140
			cmp		r10,r5
			jump	cc,(r8)				; .b180
			cmp		r10,r6
			jump	cc,(r9)				; .b220
			nop
			jump	(r7)				; next bullet
			nop
			
.b100:		movei	#b100,r14
			jump	(r14)
			nop
.b140:		movei	#b140,r14
			jump	(r14)
			nop
			
b060:		move	r2,r14	
			store	r28,(r21)
			addq	#4,r14
			addqt	#4,r21
			cmp		r10,r14
			jump	CS,(r7)
			nop
b100:		move	r3,r14
			store	r28,(r22)
			addq	#4,r14
			addqt	#4,r22
			cmp		r10,r14
			jump	CS,(r7)
			nop
b140:		move	r4,r14
			store 	r28,(r23)
			addq	#4,r14
			addqt	#4,r23
			cmp		r10,r14
			jump	CS,(r7)
			nop
b180:		move	r5,r14
			store	r28,(r24)
			addq	#4,r14
			addqt	#4,r24
			cmp		r10,r14
			jump	CS,(r7)
			nop
b220:		store	r28,(r25)
			addqt	#4,r25
			jump	(r7)
			nop
			
_GPUSETUP_REGS:
			moveta	r21,r21
			moveta	r22,r22
			moveta	r23,r23
			moveta	r24,r24
			moveta	r25,r25
			movei	#b180,r8
			movei	#b220,r9
			movei	#-1,r11
			movei	#_GPU_CHECK_LOOP,r20
			JUMP	(r30)
			nop
			
			
_GPU_fixuptables:
			store	r11,(r21)			; terminate the tables
			store	r11,(r22)
			store	r11,(r23)
			store	r11,(r24)
			store	r11,(r25)
			movei	#_GPUobject_update,r18

;; Now we must fix up all the LINK addresses and BRANCH objects


			movefa	r21,r21				; restore pointers to start of tables
			movefa	r22,r22
			movefa	r23,r23
			movefa	r24,r24
			movefa	r25,r25
			jump	(r0)
			nop

