;; New update bullets
;;
;; Main Bank										Alt Bank
;;
;; R0	Offset to panel from screen top
;; R1	JUMP:	.set_offscreen
;; R2
;; R3
;; R4   CONST:  256
;; R5
;; R6
;; R7
;; R8
;; R9	LOOP:	#max_bullets
;; R10	OL Mask #$c007
;; R11	OL Mask #$f000
;; R12	OL Mask #%111111111111
;; R13	OL Mask #%1111111111
;; R14	INDEX: Pointer to current bullet
;; R15	INDEX: Pointer to current object base
;; R16  CONST: Left Margin
;; R17	CONST: Map x-pos
;; R18	CONST: #700 (offscreen)
;; R19  CONST: #632 (Right edge clip)
;; R20	CONST: 0
;; R21	Current Bullet X
;; R22	Current Bullet Y
;; R23	Current Bullet X-add
;; R24	Current Bullet Y-add
;; R25	TRASH
;; R26	TRASH
;; R27	JUMP: .update
;; R28	JUMP: .not_active
;; R29 	JUMP: .not_right
;; R30 	JUMP: .not_left
;; R31	JUMP: .still_oky

; Consts:		moveq	#0,r20					; CONST: 0
				moveq	#0,r16
				moveq	#0,r19
				movei	#51,r0					; panel offset
				movei	#$ffffc007,r10			; used to mask data in OL
				movei	#$fffff000,r11			; used to mask data in OL
				movei	#%111111111111,r12		; used to mask data in OL
				movei	#%1111111111,r13		; used to mask data in OL
				movei	#left_marg,r21			; left margin offset (PAL/NTSC)
				movei	#256,r4
				movei	#map_x_pos,r22
				movei	#700,r18
				movei	#632,r19
				loadw	(r21),r16				; CONST: Left Marg
				loadw	(r22),r17				; CONST: Map X-pos
; JUMP addresses:
				movei	#.still_oky,r31
				movei	#.not_left,r30
				movei	#.not_right,r29
				movei	#.not_active,r28
				movei	#.update,r27
				movei	#.set_offscreen,r1
; LOOPs:
				movei	#max_bullets,r9
				movei	#bullets,r14
				
.update:		load	(r14+(bullet_use/4)),r25	; bullet in use?
				cmpq	#0,r25
				JUMP	EQ,(r28)					; if 0, ** JUMP .not_active **
				load	(r14+(bullet_xadd/4)),r23	; bullet x-additive
				load	(r14+(bullet_x/4)),r21		; bullet x
				add		r23,r21						; add it
				store	r21,(r14+(bullet_x/4))		; store new x
				cmpq	#0,r21
				JUMP	PL,(r30)					; ** JUMP .not_left **
				nop
				JUMP	(r1)						; ** JUMP .set_offscreen **
				
.not_left:		move	r21,r25						; copy x
				sub		r19,r25						; subtrack right edge (clip)
				JUMP	MI,(r29)					; ** JUMP .not_right **
				nop
				JUMP	(r1)						; ** JUMP .set_offscreen **
				
.not_right:		sub		r17,r21						; make x relative to screen
				load	(r14+(bullet_y/4)),r22		; get bullet Y
				load	(r14+(bullet_yadd/4)),r24	; get bullet Y-add
				sub		r24,r22
				move	r22,r26						; make copy of y

				sub		r4,r26
				JUMP	PL,(r1)						; **SET OFFSCREEN**
				move	r22,r26
				
				sub		r0,r26						; subtract height of banner (for cliptest)
				JUMP	PL,(r31)					; ** JUMP PL,.still_oky
				nop
				
.set_offscreen:	store	r20,(r14+(bullet_use/4))	; mark bullet as out of use
				move	r18,r22						; Y now offscreen
	
.still_oky:		store	r22,(r14+(bullet_y/4))		; store new Y
				add		r16,r21						; Add left marg: R21 (Bx) / R22 (By)
				and 	r13,r22						; mask y
				and 	r12,r21						; mask x
				load	(r14+(bullet_obj/4)),r15	; pointer to Object Data
				load	(r15+1),r25					; LONGWORD containing Y (in .w)
				add		r22,r22						; Y=Y*2
				and		r10,r25						; mask out old Y
				load	(r15+3),r26					; LONGWORD containing X (in .w)
				shlq	#3,r22						; shift current X to correct position
				and		r11,r26						; mask out old X
				or		r22,r25						; insert new Y
				or		r21,r26						; insert new X
				store	r25,(r15+1)					; store new Y
				store	r26,(r15+3)					; store new X

.not_active:	addq	#32,r14						; next bullet
				subq	#1,r9						; all done?
				JUMP	NE,(r27)					; ** JUMP .update **
				nop
				

