;;
;; GPU Collision Detection
;;

; R0	C:	max_bullets						
; R1	Current bullet X
; R2	Current bullet Y
; R3	Ship Comparison point X
; R4	Ship Comparison point Y
; R5	C: #$ffff
; R6	THREAD1 in use flag						ALTR6:  Thread3 in use flag
; R7	THREAD2 in use flag						ALTR7:  Thread4 in use flag
; R8	inner loop counter (thread check)		ALTR8:  Thread5 in use flag
; R9	inner loop jump point (thread jump)		ALTR9:  Thread 5 enemy type
; R10	Comparison Dupe X						ALTR10: Pointer to wave5 enemytype
; R11	Comparison Dupe Y						ALTR11:	J: .chk_thread5
; R12	Thread 1 enemy type						ALTR12: Thread 3 enemy type
; R13	Thread 2 enemy type						ALTR13: Thread 4 enemy type
; R14	I:	bullet table index pointer			ALTr14: backup while looping
; R15	I:	bullet comparison index
; R16	comparison2								ALTr16: pointer to current enemytype (loop)
; R17	comparison2								
; R18	Trash									ALTr18: trash
; R19	J: inner loop jump						ALTr19: backup of r20
; R20	pointer to wave1 enemytype				ALTr20: pointer to wave3 enemytype
; R21	innter loop nexy object point (thread jump)
; R22	pointer to wave2 enemytype				ALTr22: pointer to wave4 enemytype
; R23	 - current enemy center-x offset		ALTr23: Thread6 in use flag
; R24	 - current enemy center-y offset		ALTr24:	Thread 6 enemy type
; R25	 - current enemy CC hitrange (x)		ALTr25: Pointer to wave6 enemytype
; R26 	 - current enemy CC hitrange (y)		ALTr26: J: .chk_thread6
; R27	J:	.chk_thread2						ALTr27: J: .chk_thread3
; R28	J:	.player_bullet						ALTr28: J: .chk_thread4
; R29	J:	.nextbullet							ALTr29 Temp
; R30	J:	.chkloop							ALTr30: JUMP sub return add
; R31	J:	Stop_GPU

			.phrase
difficulty_shifter:		.dc.l	2

GPU_Collision_Detection:
			movei 	#stop_gpu,r31
			movei	#thread5+thread_active,r6
			load	(r6),r6
			moveta	r6,r8
			movei	#thread5+thread_etype,r21
			load	(r21),r21
			moveta	r21,r9

			movei	#thread6+thread_active,r6
			load	(r6),r6
			moveta	r6,r23
			movei	#thread6+thread_etype,r21
			load	(r21),r21
			moveta	r21,r24

			movei	#thread3+thread_active,r27
			movei	#thread4+thread_active,r20
			movei	#thread3+thread_etype,r29
			movei	#thread4+thread_etype,r21
			movei	#thread1+thread_active,r6
			load	(r27),r27
			load	(r20),r20
			movei	#thread2+thread_active,r7
			movei	#.chk_thread6,r23
			load	(r29),r29
			moveta	r23,r26
			load	(r21),r21
			movei	#thread1+thread_etype,r12
			movei	#.chk_thread5,r23
			movei	#thread2+thread_etype,r13
			moveta	r23,r11
			movei	#.chkloop,r30
			movei	#.chk_thread3,r23
			moveta	r20,r7
			moveta	r21,r13
			movei	#.chk_thread4,r20
			moveta	r27,r6
			moveta	r29,r12
			moveta	r20,r28
			movei	#.chk_thread2,r27
			movei	#thread4+thread_etype,r21
			movei	#enemy_lookup,r13
			movei	#.nextbullet,r29

			movefa	r9,r20					; t5 type
			shlq	#2,r20
			add		r13,r20
			load	(r20),r20
			moveta	r20,r10

			movefa	r24,r20					; t6 type
			shlq	#2,r20
			add		r13,r20
			load	(r20),r20
			moveta	r20,r25
			
			load	(r21),r20					; type4 in r20
			moveta	r23,r27
			move	r13,r23
			shlq	#2,r20
			add		r20,r23
			load	(R23),R20
			moveta	r20,r13						; t4 e_type
			movei	#thread3+thread_etype,r21

			
			load	(r21),r20					; type in r20
			move	r13,r23
			shlq	#2,r20
			add		r20,r23
			load	(r23),r20
			moveta	r20,r20
			
			movei	#thread1+thread_etype,r21
			movei	#thread2+thread_etype,r23
			load	(r21),r20
			load	(r23),r22
			shlq	#2,r20
			move	r13,r23
			shlq	#2,r22
			add		r20,r13
			add		r22,r23
			load	(r13),r20					; R20 = pointer to wave1 enemytype
			load	(r23),r22					; R22 = pointer to wave2 enemytype
			moveta	r20,r19
			
			load	(r6),r6
			load	(r7),r7
			load	(r12),r12
			load	(r13),r13
			movei	#.player_bullet,r28
			movei	#bullets,r14
			movei	#ship_x,r15		
			movei	#max_bullets+1,r0				; +1 special case, always in use but offscreen
			movei	#$ffff,r5						; ^^  has no associated Object in OL
			load	(r15),r3						; ^^ is just used to check against player
			move	r3,r4
			shrq	#16,r3							; R3 = Ship X
			and		r5,r4							; R4 = Ship Y
			addq	#12,r3		;addq	#16,r3							
			addq	#18,r4		;addq	#16,r4		; center of ship
			
.chkloop:	load	(r14+(bullet_use/4)),r25		; get bullet type
			moveta	r14,r14							; backup R14 index pointer
			cmpq	#0,r25
			JUMP	EQ,(r29)						; if 0: get next bullet
			nop
			cmpq	#1,r25
			JUMP	EQ,(r28)						; if 1: player bullet (check v enemies)
			nop
			
;; check if an enemy bullet hit the player
;;
			
.enemy_bullet:										; ELSE: enemy bullet (check v player)
			load	(r14+(bullet_x/4)),r1
			load	(r14+(bullet_y/4)),r2
			move	r3,r10							; comparitors
			move	r4,r11
			addq	#2,r1
			addq	#2,r2							; center of bullet

			sub		r1,r10
			sub		r2,r11							; difference between points
			abs		r10
			abs		r11								; forced positive

;			jump	(r29)			; uncomment to disable bullet / player hits
			
			subq	#11,r10		;subq	#15,r10		; within 10 pixels of x-center?
			JUMP	PL,(r29)						; nope, next bullet	
			subq	#6,r11		;subq	#15,r11		; within 10 pixels of y-center?
			JUMP	PL,(r29)						; nope, next bullet
			nop
			
			movei	#life_energy,r10
			movei	#difficulty_shifter,r1
		
			moveq	#20,r11							; damage for HARD level
			load	(r1),r1							; difficulty modifier
			load	(r10),r18						; life energy
			shlq	#3,r1		; diff *8
			sub		r1,r11		; sub (diff*4) from 20
			sub		r11,r18		; sub result from shield
			store	r18,(r10)

			movei	#player_hit_flag,r10
			moveq	#1,r11
			store	r11,(r10)						; flag as hit :)

			cmpq	#0,r18
			JUMP	PL,(r29)						; if not dead, JUMP
			nop
			nop
			
			JUMP	(r29)							; NEXT BULLET
			nop
	
;; check if a player bullet hit the enemy
;;
	
.player_bullet:
			load	(r14+(bullet_x/4)),r1
			load	(r14+(bullet_y/4)),r2

.chk_thread1:
			cmpq	#1,r6							; check thread 1 active?
			JUMP	NE,(r27)						; jump NE, .chk_thread2
			moveq	#max_enemies1,r8
			movefa	r19,r20
			move	r20,r14							; index pointer for enemy type
			movei	#t1loop,r9
			load	(r14+(etype_xcent/4)),r23
			load	(r14+(etype_ycent/4)),r24
			load	(r14+(etype_xkill/4)),r25
			load	(r14+(etype_ykill/4)),r26
			movei	#t1_next,r21
			movei	#e_thread1,r14					; now pointes to wave data

			movei	#.chk_thread2,r16
			moveta	r16,r30
			jump	(r9)
			nop
			
			
.chk_thread2:
			move	r22,r20
			movefa	r27,r8
			cmpq	#1,r7							; check thread 2 active?
			JUMP	NE,(r8)							; junp NE, .chk_thread3
			moveq	#max_enemies2,r8
			move	r22,r14							; index pointer for enemy type
			movei	#t1loop,r9
			load	(r14+(etype_xcent/4)),r23
			load	(r14+(etype_ycent/4)),r24
			load	(r14+(etype_xkill/4)),r25
			load	(r14+(etype_ykill/4)),r26
			movei	#t1_next,r21
			movei	#e_thread2,r14					; now pointes to wave data

			movei	#.chk_thread3,r16
			moveta	r16,r30
			jump	(r9)
			nop
			
;;; THREAD3
.chk_thread3:
			movefa	r20,r20
			movefa	r28,r9				; .chk_thread4
			movefa	r6,r8
			cmpq	#1,r8							; check thread 3 active?
			JUMP	NE,(r9)							; junp NE, .chk_thread4
			moveq	#max_enemies3,r8

			movefa	r20,r14							; index pointer for enemy type
			movei	#t1loop,r9
			load	(r14+(etype_xcent/4)),r23
			load	(r14+(etype_ycent/4)),r24
			load	(r14+(etype_xkill/4)),r25
			load	(r14+(etype_ykill/4)),r26
			movei	#t1_next,r21
			movei	#e_thread3,r14					; now pointes to wave data

			movei	#.chk_thread4,r16
			moveta	r16,r30
			jump	(r9)
			nop
			
;;; THREAD4

.chk_thread4:		
			movefa	r11,r9				; .chk_thread5
			movefa	r7,r8
			cmpq	#1,r8							; check thread 4 active?
			JUMP	NE,(r9)						; junp NE, .chk_thread5
			moveq	#max_enemies4,r8

			movefa	r13,r14							; index pointer for enemy type
			movei	#.t4loop,r9
			load	(r14+(etype_xcent/4)),r23
			load	(r14+(etype_ycent/4)),r24
			load	(r14+(etype_xkill/4)),r25
			load	(r14+(etype_ykill/4)),r26
			movei	#.t4_next,r21
			movei	#e_thread4,r14					; now pointes to wave data
.t4loop:	load	(r14+(enemy_use/4)),r18
			load	(r14+(enemy_x/4)),r10			; current object X
			load	(r14+(enemy_y/4)),r11			; current object Y

			cmpq	#1,r18							; enemy in use?
			JUMP	NE,(r21)						; next enemy if not in use
			nop
			
			add		r23,r10							; get to center
			add		r24,r11							; get to center
			move	r3,r16							; player ship x
			move	r4,r17							; player ship y

			movei	#.t4_next,r19
			sub		r10,r16
			sub		r11,r17
			abs		r16
			abs		r17
			subq	#15,r16		; within 10 pixels of x-center?
			JUMP	PL,(r19)						; nope, bullet check next	
			subq	#15,r17		; within 10 pixels of y-center?
			JUMP	PL,(r19)						; nope, bullet check next
			nop
; if here, then player hit enemy :-)

			load	(r14+(enemy_curframe/4)),r19
			movei	#bonus_hit_flag,r16
			moveq	#1,r17
			store	r17,(r16)						; player hit bonus obj
			addq	#4,r16
			store	r19,(r16)						; on frame x
			movei	#EOF_WAVE,r16
			store	r16,(r14+(enemy_waveptr/4))		; and flag as done
			
.t4_next:	addq	#32,r14
			addq	#32,r14
			subq	#1,r8
			JUMP	NE,(r9)							; loop around all enemies in wave
			nop

; THREAD 5

.chk_thread5:
			movefa	r10,r20

			movefa	r26,r9				; .chk_thread5
			movefa	r8,r8
			cmpq	#1,r8							; check thread 3 active?
			JUMP	NE,(r9)						; junp NE, .next_bullet
			moveq	#max_enemies5,r8

			movefa	r10,r14							; index pointer for enemy type
			movei	#t1loop,r9
			load	(r14+(etype_xcent/4)),r23
			load	(r14+(etype_ycent/4)),r24
			load	(r14+(etype_xkill/4)),r25
			load	(r14+(etype_ykill/4)),r26
			movei	#t1_next,r21
			movei	#e_thread5,r14					; now pointes to wave data

			movei	#.chk_thread6,r16
			moveta	r16,r30
			jump	(r9)
			nop

; THREAD 6

.chk_thread6:
			movefa	r25,r20

			movefa	r23,r8
			cmpq	#1,r8							; check thread 3 active?
			JUMP	NE,(r29)						; junp NE, .next_bullet
			moveq	#max_enemies6,r8

			movefa	r25,r14							; index pointer for enemy type
			movei	#t1loop,r9
			load	(r14+(etype_xcent/4)),r23
			load	(r14+(etype_ycent/4)),r24
			load	(r14+(etype_xkill/4)),r25
			load	(r14+(etype_ykill/4)),r26
			movei	#t1_next,r21
			movei	#e_thread6,r14					; now pointes to wave data

			movei	#.nextbullet,r16
			moveta	r16,r30
			jump	(r9)
			nop

			
.nextbullet:	
			movefa	r14,r14							; restore index from backup
			addq	#32,r14
			subq	#1,r0
			JUMP	NE,(r30)						; .chkloop
			nop

			JUMP	(r31)
			nop
			
;;; generic_collision_routine_per_thread


t1loop:		load	(r14+(enemy_action/4)),r16
			load	(r14+(enemy_use/4)),r18
			load	(r14+(enemy_x/4)),r10			; current object X
			load	(r14+(enemy_y/4)),r11			; current object Y

			cmpq	#9,r16
			JUMP	EQ,(R21)
			
			cmpq	#1,r18							; enemy in use?
			JUMP	NE,(r21)						; next enemy if not in use
			nop

			add		r23,r10							; get to center
			add		r24,r11							; get to center
						
			move	r3,r16							; player ship x
			move	r4,r17							; player ship y

			movei	#.b_chk,r19
			sub		r10,r16
			sub		r11,r17
			abs		r16
			abs		r17

			sub		r25,r16							; collision width
			Jump	PL,(R19)						; nope, bullet check next	
			sub		r26,r17							; collision width
			Jump	PL,(r19)						; nope, bullet check next
			nop
; if here, then player hit enemy :-)

			movei	#life_energy,r19
			moveta	r14,r29
			load	(r19),r18
			move	r20,r14
			load	(r14+(etype_playdmg/4)),r11
			movei	#difficulty_shifter,r16
			load	(r16),r16
			sha		r16,r11							; difficulty multiplier
			sub		r11,r18
			store	r18,(r19)
			movefa	r29,r14
			
			movei	#player_hit_flag,r16
			moveq	#1,r17
			store	r17,(r16)						; flag as dead :)
	

.b_chk:		move	r1,r16							; bullet x
			move	r2,r17							; bullet y

			movei	#t1_next,r19
			sub		r10,r16
			sub		r11,r17
			
			
			abs		r16
			abs		r17
			sub		r25,r16							; enemy killzone (x) ?
			JUMP	PL,(r19)
			sub		r26,r17
			JUMP	PL,(r19)
			nop
; if here, then bullet hit enemy :-) (finally!)
			moveta	r14,r31						; store it (temp)
			movefa	r14,r14						; R14=bullet pointer
			movei	#700,r17
			store	r17,(r14+(bullet_y/4))		; mark bullet as offscreen
			store	r17,(r14+(bullet_x/4))		; so next GPU update will remove it
			movefa	r31,r14						; R14=enemy pointer
		
			load	(r14+(enemy_tildead/4)),r17
			subq	#1,r17						
			jr		MI,.its_dead_now
			store	r17,(r14+(enemy_tildead/4))
			moveq	#7,r17
			store	r17,(r14+(enemy_action2/4))	; mark as "hit"
			movei	#t1_next,r17
			jump	(r17)
			nop
			
.its_dead_now:
			moveta	r15,r18				; backup index
			move	r20,r15

			movei	#scorebuf,r17
			load	(r15+(etype_score/4)),r23	; get score
			load	(r17),r19					; buffer address
			store	r23,(r19)					; store score for this enemy
			addq	#4,r19						; inc buffer pointer
			store	r19,(r17)					; store pointer
						

			movefa	r18,r15				; restore index
			
			moveq	#2,r17
			store	r17,(r14+(enemy_action/4))	; mark enemy as destroyed!
			movei	#explode_sfx_trigger,r23
			store	r17,(r23)
			nop
			
t1_next:	addq	#32,r14
			addq	#32,r14
			subq	#1,r8
			JUMP	NE,(r9)							; loop around all enemies in wave
			nop
			movefa	r30,r14
			jump 	(r14)
			nop



			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
			
