;;
;; GPU Starfield code (Paralax layer)
;;

; r0 = starbuffer (where we save backdrop)
; r14 = starpoints (x/y/speed list)
; r2 = const: pixel OR mask

; r4 = const ($ffff used to mask out high word in a long)
; r5 = const (underlay bmp base address)
; r6 = temp (current star addr)
; r7 = temp
; r8 = temp
; r9 = const (511*480)

; r10 = JUMP .plotloop

; r20 = max stars
; r31 = JUMP stop GPU

max_stars		equ		75

GPU_save_and_plot:
				movei	#stop_gpu,r31			; stop
				movei	#starbuffer,r0			; where we save backdrop
				movei	#starpointer,r14		; star x/y/vel .l table
				movei	#underlay_bmp,r5		; base of bitmap (480x512)
				movei	#240*255,r9				; end of bitmap

				movei	#$00080A0F,r2			; pixel set mask
				movei	#$0000000f,r16
				moveq	#25,r27

				movei	#.plotloop,r10
				
				movei	#max_stars,r20
.plotloop:		load	(r14),r30				; get stars x
				load	(r14+1),r29				; get stars y
				load	(r14+2),r8				; get stars velocity
				
				move	r5,r6					; reset bitmap
				add		r29,r6					; add y
				add		r30,r6					; add x
				
				store	r6,(r0)					; store address
				load	(r6),r7					; get pixel info
				addqt	#4,r0
				store	r7,(r0)					; store pixel info
				addqt	#4,r0
				
				subq	#1,r27
				jr		NE,.NOFADER
				nop
				sharq	#8,r2
				moveq	#25,r27
.NOFADER:
				
				move	r2,r28
				and		r16,r28
				or		r28,r7					; mask in star pixel
				
				store	r7,(r6)					; write to bitmap
				add		r9,r6
				store	r7,(r6)
				
				add		r8,r29					; add velocity
				move	r29,r7
				sub		r9,r7
				jr		MI,.nowrap
				nop
				move	r7,r29
	
.nowrap:		store	r29,(r14+1)				; write new Y-pos
				
				addq	#12,r14					; next star
				
				subq	#1,r20
				jump 	NE,(r10)
				nop
				jump	(r31)

GPU_restore_backdrop:
				movei	#240*255,r9				
				movei	#stop_gpu,r31
				movei	#max_stars,r30
				movei	#starbuffer+((max_stars-1)*8),r14
.restloop:		load	(r14),r1
				load	(r14+1),r2
				store	r2,(r1)
				add		r9,r1
				store	r2,(r1)
				subq	#8,r14
				subq	#1,r30
				jr		NE,.restloop
				nop
				jump	(r31)
				nop
				nop
				
				
			