;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;;
;; Process tilescroller
;;
;;
;; R0	- current object address
;; R1	- pointer to tile gfx
;; R2	- pointer to map data
;; R3	- pointer to map objects
;; R4	- const: offset to next rowstart from rowend
;; R5	- const: Mask
;; R6	- const: Mask
;; R7
;; R8	- CONST (map_y_pos)
;; R9	- CONST (map_x_pos)
;; R10	- current y position (map) / in loop = x-position for next tile
;; R11	- x offset
;; R12	- y offset (0-31)	/	tile bitmap address?
;; R13	- x offset
;; r7	- OBJECT UPDATE:		phrase from object (y)
;; R15
;; R16	- OBJECT UPDATE:		phrase from object (x)
;; R17	- height of map
;; R18	- left edge of screen
;; R19	- CONST: Jump address
;; R20	- H Loop counter
;; R21	- OBJECT UPDATE:	x	/ CONST
;; R22	- OBJECT UPDATE:	y
;; R23	- CONST: Jump address
;; R24	- CONST: Mask
;; R25	- CONST (trash)
;; R26	- left margin
;; R27	- OBJECT UPDATE:	pointer to data in object phrase
;; R28	- OBJECT UPDATE:	Bitmap address in phrase
;; R29	- CONST
;; R30	- CONST
;; R31

GPU_tilemap_update:
				movei	#mapob_ptrs,r3			; pointer to map objects
				movei	#tile_pointers,r1		; pointer to tile gfx

				movei	#current_map,r2
				load	(r2),r2
;				movei	#map_data,r2			; pointer to map data


				movei	#left_marg,r26			; CONST
				movei	#map_y_pos,r8			; CONST
				movei	#map_x_pos,r9			; CONST
				loadw	(r26),r26
				moveq	#0,r11
				moveq	#0,r12
				loadw	(r8),r10				; get current y display position
				move	r10,r12					; duplicate it
				movei	#63,r11
				moveq	#31,r30	
				and		r30,r12					; offset (0-31)
				sub		r12,r11					; VERTICAL OFFSET in R11
				movei	#mapwidth*2,r29
				sharq	#5,r10
				mult	r29,r10
				add		r10,r2					; offset into map data
				moveq	#maptile_y,r17			; height of visible map
				loadw	(r9),r13				; get current x-offset
				move	r13,r12
				moveq	#0,r18
				and		r30,r12					; (force 0-31) for shift
				sub		r12,r18					; CONST ** LEFT EDGE **
				sharq	#5,r13					; div32 (pixels into tiles)
				shlq	#1,r13					; mult 2 (table offset)
				add		r13,r2					; offset into mapdata
				movei	#%111111111111,r29
				movei	#%1111111111,r30
				movei	#%11111111111,r15
				movei	#.vert,r23
				movei	#.horiz,r19
				movei	#$c007,r5
				movei	#$f000,r6
				movei	#(mapwidth-maptile_x)*2,r4
				movei	#tile_pointers,r14
.vert:			move	r18,r10					; reset left edge
				movei	#maptile_x,r20			; H loop counter
				
				load	(r3),r0		; get obj address
				move	r11,r22
				addq	#6,r0		; offset to Y
				add		r22,r22		; y=y*2
				loadw	(r0),r7	; get current word
				shlq	#3,r22		; shifted
				and		r5,r7		; mask out old Y
				or		r22,r7
				
.horiz:			loadw	(r2),r24				; get tile bitmap address
				addq	#2,r2

				move	r14,r21
				shlq	#2,r24
				add		r24,r21
				
				load	(r21),r24
				shlq	#8,r24
				
				load	(r3),r0					; get object address

				addq	#4,r3
				move	r10,r21					; X
				move	r0,r27					; R27=object base
				add		r26,r21					; add left margin offset to x
				addq	#6,r27
				and		r29,r21					; mask x (fix negatives)
				storew	r7,(r27)				; store pre-calc'd Y for line
				addq	#8,r27
				loadw	(r27),r16				; Get X-Position from object
				load	(r0),r12				
				and		r6,r16					; mask old X-Position out
				and		r15,r12
				or		r21,r16
				or		r24,r12
				storew	r16,(r27)
				store	r12,(r0)				; store bitmap address
				addq	#32,r10
				subq	#1,r20
;				cmpq	#0,r20
				jump	ne,(r19)				; HORIZ
				nop
				move	r4,r10					; reset x-pointer
				addq	#32,r11
				add		r10,r2					; offset to next row
				subq	#1,r17
;				cmpq	#0,r17
				jump	ne,(r23)				; VERT
				nop