;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Init / Create all datatables for game level
;;
				
				
initialise_gameobjects:
				move.l	topmask_obj,a0						; set the masking panel up at 0,0
				move.l	#-6,d0								; PAL (10)
				moveq	#32,d1
				bsr		setup_object_xy

				move.l	display_obj,a0
				move.l	#144,d0
				move.l	#35,d1
				bsr		setup_object_xy

.uoffscreen:	move.l	underlay_obj,a0
				move.l	#-60,d0
				move.l	#0,d1
				bsr		setup_object_xy
				
				lea		bullets,a6
				move.l	#max_bullets-1,d7
.offscreen:		move.l	bullet_obj(a6),a0
				move.l	#700,d0								; set bullets to offscreen
				move.l	#700,d1
				clr.l	bullet_use(a6)				
				move.l	d0,bullet_x(a6)
				move.l	d1,bullet_y(a6)
				movem.l	d7/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a6
				lea		32(a6),a6
				dbra 	d7,.offscreen

				lea		e_thread1,a6
				move.l	#max_enemies1-1,d7
.offscreen2:	move.l	enemy_obj(a6),a0
				move.l	#700,d0								; set enemies to offscreen
				move.l	#700,d1
				move.l	d0,enemy_x(a6)
				move.l	d1,enemy_y(a6)
				move.l	#-1,enemy_use(a6)
				movem.l	d7/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a6
				lea		64(a6),a6
				dbra 	d7,.offscreen2

				lea		e_thread2,a6
				move.l	#max_enemies2-1,d7
.offscreen3:	move.l	enemy_obj(a6),a0
				move.l	#800,d0								; set enemies to offscreen
				move.l	#800,d1
				move.l	d0,enemy_x(a6)
				move.l	d1,enemy_y(a6)
				move.l	#-1,enemy_use(a6)
				movem.l	d7/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a6
				lea		64(a6),a6
				dbra 	d7,.offscreen3
				
				lea		e_thread3,a6
				move.l	#max_enemies3-1,d7
.offscreen4:	move.l	enemy_obj(a6),a0
				move.l	#900,d0								; set enemies to offscreen
				move.l	#900,d1
				move.l	d0,enemy_x(a6)
				move.l	d1,enemy_y(a6)
				move.l	#-1,enemy_use(a6)
				movem.l	d7/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a6
				lea		64(a6),a6
				dbra 	d7,.offscreen4
				
				lea		e_thread4,a6
				move.l	enemy_obj(a6),a0
				move.l	#900,d0								; set enemies to offscreen
				move.l	#900,d1
				move.l	d0,enemy_x(a6)
				move.l	d1,enemy_y(a6)
				move.l	#-1,enemy_use(a6)
				bsr		setup_object_xy

				lea		e_thread5,a6
				move.l	#max_enemies5-1,d7
.offscreen5:	move.l	enemy_obj(a6),a0
				move.l	#900,d0								; set enemies to offscreen
				move.l	#900,d1
				move.l	d0,enemy_x(a6)
				move.l	d1,enemy_y(a6)
				move.l	#-1,enemy_use(a6)
				movem.l	d7/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a6
				lea		64(a6),a6
				dbra 	d7,.offscreen5

				lea		e_thread6,a6
				move.l	#max_enemies6-1,d7
.offscreen6:	move.l	enemy_obj(a6),a0
				move.l	#900,d0								; set enemies to offscreen
				move.l	#900,d1
				move.l	d0,enemy_x(a6)
				move.l	d1,enemy_y(a6)
				move.l	#-1,enemy_use(a6)
				movem.l	d7/a6,-(a7)
				bsr		setup_object_xy
				movem.l	(a7)+,d7/a6
				lea		64(a6),a6
				dbra 	d7,.offscreen6
				
				lea		bullet_special,a0
				move.l	#bullet_crudOLD,(a0)+				; fake OL pointer
				move.l	#1,(a0)+							; bullet ALWAYS in use
				move.l	#9000,(a0)+							; bullet well offscreen
				move.l	#9000,(a0)+							; and again
				move.l	#0,(a0)+
				move.l	#0,(a0)+

				move.l	lifebar_obj,a0
				move.l	#10,d0								; PAL
				moveq	#32,d1
				add.l	#24,d1
				add.l	#49,d0
				move.w	d0,ebar_x
				move.w	d1,ebar_y
				bsr		setup_object_xy
				
				clr.w	have_sideshot
				
				move.l	sideobj,a0
				move.l	#700,d0
				move.l	d0,d1
				bsr		setup_object_xy

				move.l	#22+16,d0
				move.l	#32,d1
				tst.w	have_laser
				bne.s	.setlasr
				move.l	#700,d0
				move.l	d0,d1
.setlasr:		move.l	lasrobj,a0
				bsr		setup_object_xy

				move.l	#22,d0
				move.l	#48,d1
				tst.w	have_sbomb
				bne.s	.setbomb
				move.l	#700,d0
				move.l	d0,d1
.setbomb:		move.l	bombobj,a0
				bsr		setup_object_xy

				move.l	#22+16,d0
				move.l	#48,d1
				tst.w	have_shield
				bne.s	.setshld
				move.l	#700,d0
				move.l	d0,d1
.setshld:		move.l	shldobj,a0
				bsr		setup_object_xy

				move.l	#150,life_energy
	
				lea		thread1,a0
				lea		thread2,a1
				lea		thread3,a2
				lea		thread4,a3
				lea		thread5,a4
				lea		thread6,a5
				move.l	#-1,thread_active(a0)
				move.l	#-1,thread_active(a1)
				move.l	#-1,thread_active(a2)
				move.l	#-1,thread_active(a3)
				move.l	#-1,thread_active(a4)
				move.l	#-1,thread_active(a5)

				move.l	#-1,thread_init(a0)
				move.l	#-1,thread_init(a1)
				move.l	#-1,thread_init(a2)
				move.l	#-1,thread_init(a3)
				move.l	#-1,thread_init(a4)
				move.l	#-1,thread_init(a5)
				
				move.l	#1,px_now
				move.l	#1,py_now
				move.l	#256,py_cnt
				move.l	#-60,px_start
				move.l	#underlay_bmp+(240*256),py_start
				
				move.w	map_y_pos_save,map_y_pos
				move.w	map_y_cnt_save,map_y_cnt
				move.w	#64,map_x_pos
				move.w	map_y_dir_save,map_y_dir
				
				move.l	#playership_bmp,ship_anim_shadow
				move.l	#playership_bmp,ship_anim
				move.w	#64,map_x_pos
				clr.l	player_hit_flag
				
				clr.l	boss_active
				move.l	#1,resume_scrolling
				move.l	wave_event_save,wave_event
				
				move.l	#-1,y060_100
				move.l	#-1,y101_140
				move.l	#-1,y141_180
				move.l	#-1,y181_220
				move.l	#-1,y221_256
				
				rts
