;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Create the initial object list.
;;

bitmapobject    equ 0            ; object types
scaledobject    equ 1
gpuobject       equ 2
braobject       equ 3             
stopobject      equ 4

y_less          equ 0            ; branch object types
y_more          equ 1
always          equ 2

; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN


map_branches:	movem.l	d0-d7/a1-a6,-(a7)		; dont save a0 (OL pointer)
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	mapbr_top,d2
				move.l	a0,a1
				add.l	all_branches,a1
				jsr		CreateObject

				move.l	#braobject,d0
				move.l	#y_more,d1
				move.l	mapbr_top,d2
				add.l	#64,d2
				move.l	a0,a1
				add.l	#32+(32*(maptile_x)),a1
				jsr		CreateObject
								
				add.l	#32,mapbr_top
				sub.l	#(32*(maptile_x+2)),all_branches
				
				movem.l	(a7)+,d0-d7/a1-a6
				rts
				
mapbr_top:		dc.l	32
all_branches:	dc.l	(32*(maptile_x+2))*(maptile_y)

MakeObjectList: lea     ob_list1,a0             			; start of OL
                jsr     build_header            			; build BRA header

				move.l	a0,underlay_obj						; store object address in table
				move.l	#underlay_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #256-64,d1                  		; height
                move.l  #240,d2             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#(320+128)/2,d5
                jsr     CreateObject
				move.l	#underlay_bmp,py_start
				add.l	#240*256,py_start

				lea		mapob_ptrs,a6
				move.l	#maptile_y,d6
.vert:
				bsr		map_branches
				move.l	#maptile_x,d7 						; number of objects to make
.loop:			move.l	a0,(a6)+							; store object address in table
				move.l	#maptiles,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #32,d1                  			; height
                move.l  #320,d2              				; bytes to next line
                move.l  #3,d3                   			; 8-Bit
                move.l  #1,d4                   			; transparent
                move.l  #32,d5              				; bytes/pixels*width / line
				movem.l	d6-d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d6-d7/a6
				subq.w	#1,d7
				bne		.loop
				subq.w	#1,d6
				bne		.vert

				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#32,d2
				move.l	a0,a1
				add.l	#64+(32*(max_enemies1+max_enemies2+max_enemies3+max_enemies5+max_enemies6+5)),a1			; <60 (skip all enemies)
				jsr		CreateObject
			
				move.l	#braobject,d0
				move.l	#y_more,d1
				move.l	#256,d2
				move.l	a0,a1
				add.l	#32+(32*(max_enemies1+max_enemies2+max_enemies3+max_enemies5+max_enemies6+5)),a1			; >255 (skip all enemies)
				jsr		CreateObject

				move.l	a0,w2_branch_add
				move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     32(a0),a1               ; a BRA+16 object
				move.l	a1,w2_branch_no
                bsr     branchobject            ;
                lea     24(a0),a0               ;

				lea		e_thread2,a6				; 32x32 Thread MUST be made 1st in list
				move.l	#max_enemies2-1,d7			; so AIR WAVES fly OVER the GROUND waves.
.make_enemies2:	move.l	a0,enemy_obj(a6)
				move.l	E_02,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #32,d1                  			; height
                move.l  #16,d2              				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #16,d5              				; bytes/pixels*width / line;
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
				move.l	enemy_obj(a6),a1		; pointer to object
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001110000000000,10(a1)	; or in next index (Pal 15)
				lea		64(a6),a6
				dbra	d7,.make_enemies2

				move.l	a0,w5_branch_add
				move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     32(a0),a1               ; a BRA+16 object
				move.l	a1,w5_branch_no
                bsr     branchobject            ;
                lea     24(a0),a0               ;
				
				lea		e_thread5,a6				; 32x32 Thread MUST be made 1st in list
				move.l	#max_enemies5-1,d7			; so AIR WAVES fly OVER the GROUND waves.
.make_enemies5:	move.l	a0,enemy_obj(a6)
				move.l	E_02,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #32,d1                  			; height
                move.l  #16,d2              				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #16,d5              				; bytes/pixels*width / line;
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
				move.l	enemy_obj(a6),a1		; pointer to object
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001110000000000,10(a1)	; or in next index (Pal 15)
				lea		64(a6),a6
				dbra	d7,.make_enemies5

				move.l	a0,w1_branch_add
				move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     32(a0),a1               ; a BRA+16 object
				move.l	a1,w1_branch_no
                bsr     branchobject            ;
                lea     24(a0),a0               ;

				lea		e_thread1,a6
				move.l	#max_enemies1-1,d7
.make_enemies:	move.l	a0,enemy_obj(a6)
				move.l	E_00,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #32,d1                  			; height
                move.l  #32,d2              				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #32,d5              				; bytes/pixels*width / line;
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
; now patch up pallette index pointer
				move.l	enemy_obj(a6),a1		; pointer to object
				
; 0(a1)		bits 48-63 phrase 1
; 2(a1)		bits 32-47
; 4(a1)		bits 16-31
; 6(a1)		bits 00-15
; 8(a1)		bits 48-64 phrase 2
;10(a1)		bits 32-47
;12(a1)		bits 16-31
;14(a1)		bits 00-15
;
;							 4bitindex	 32/phrase 2
;							 ||||  	 	 |
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001111000000000,10(a1)	; or in next index (pal 16)
				
				lea		64(a6),a6
				dbra	d7,.make_enemies				

				move.l	a0,w3_branch_add
				move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     32(a0),a1               ; a BRA+16 object
				move.l	a1,w3_branch_no
                bsr     branchobject            ;
                lea     24(a0),a0               ;

				lea		e_thread3,a6
				move.l	#max_enemies3-1,d7
.make_enemies3:	move.l	a0,enemy_obj(a6)
				move.l	E_02,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #16,d1                  			; height
                move.l  #8,d2              					; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #8,d5              					; bytes/pixels*width / line;
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
				move.l	enemy_obj(a6),a1		; pointer to object
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001101000000000,10(a1)	; or in next index (Pal 13)
				lea		64(a6),a6
				dbra	d7,.make_enemies3

				move.l	a0,w6_branch_add
				move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     32(a0),a1               ; a BRA+16 object
				move.l	a1,w6_branch_no
                bsr     branchobject            ;
                lea     24(a0),a0               ;
				
				lea		e_thread6,a6
				move.l	#max_enemies6-1,d7
.make_enemies6:	move.l	a0,enemy_obj(a6)
				move.l	E_02,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #16,d1                  			; height
                move.l  #8,d2              					; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #8,d5              					; bytes/pixels*width / line;
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
				move.l	enemy_obj(a6),a1		; pointer to object
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001101000000000,10(a1)	; or in next index (Pal 13)
				lea		64(a6),a6
				dbra	d7,.make_enemies6
				
				lea		e_thread4,a6
.make_enemies4:	move.l	a0,enemy_obj(a6)
				move.l	BN00,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #16,d1                  			; height
                move.l  #16*2,d2              					; bytes to next line
                move.l  #4,d3                   			; 16-Bit (256c pallette independant)
                move.l  #1,d4                   			; Transparent
                move.l  #16*2,d5              					; bytes/pixels*width / line;
                jsr     CreateObject

;; drop to here from previous branches
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#60,d2
				move.l	a0,a1
				add.l	#(7*32)+(max_bullets*32),a1			; <60 (skip all)
				jsr		CreateObject

				move.l	#braobject,d0
				move.l	#y_more,d1
				move.l	#256,d2
				move.l	a0,a1
				add.l	#(6*32)+(max_bullets*32),a1			; >255 (skip all)
				jsr		CreateObject

				move.l	a0,branch60							; 60-99
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#100,d2
				move.l	a0,a1
				add.l	#32,a1								
				jsr		CreateObject
				
				move.l	a0,branch100						; 100-139
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#140,d2
				move.l	a0,a1
				add.l	#32,a1								
				jsr		CreateObject
				
				move.l	a0,branch140						; 140-179
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#180,d2
				move.l	a0,a1
				add.l	#32,a1								
				jsr		CreateObject

				move.l	a0,branch180						; 180-219
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#220,d2
				move.l	a0,a1
				add.l	#32,a1								
				jsr		CreateObject

				move.l	a0,branch220						; 220-256
				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#255,d2
				move.l	a0,a1
				add.l	#32,a1								
				jsr		CreateObject
				
				lea		bullets,a6
				move.l	#max_bullets-1,d7
.make_bullets:	move.l	a0,bullet_obj(a6)
				move.l	P_00,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #4,d1                  				; height
				move.l	#8,d2								; bytes to next line (phrase align)
				move.w	#4,d3								; 16 bt
				move.w	#1,d4								; transparent
				move.w	#8,d5								; bytes to next line (phrase)
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
				lea		32(a6),a6
				dbra	d7,.make_bullets
				move.l	a0,branchend

				move.l	a0,ship_obj							; create a mask object for top clipping
				move.l	#playership_bmp,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #24,d1                  			; height (32)
                move.l  #(24*2)*3,d2             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #24*2,d5              				; bytes/pixels*width / line;
                jsr     CreateObject

				move.l	a0,fujishld_obj							; create a mask object for top clipping
				move.l	#fujishld_bmp,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #48,d1                  			; height
                move.l  #48*2,d2   	         				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; Transparent
                move.l  #48*2,d5              				; bytes/pixels*width / line;
                jsr     CreateObject

				move.l	#braobject,d0
				move.l	#y_less,d1
				move.l	#32,d2
				move.l	a0,a1
				add.l	#64+(64+128+32+128),a1
				jsr		CreateObject
				
				move.l	#braobject,d0
				move.l	#y_more,d1
				move.l	#64,d2
				move.l	a0,a1
				add.l	#32+(64+128+32+128),a1
				jsr		CreateObject
				
				move.l	a0,topmask_obj						; create a mask object for top clipping
				move.l	#toppanel_bmp,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #32,d1                  			; height
                move.l  #356*2,d2              				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
                move.l  #356*2,d5              				; bytes/pixels*width / line;
                jsr     CreateObject

				move.l	a0,lifebar_obj						; create a mask object for top clipping
				move.l	#lifebar_bmp,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #6,d1	                  			; height
                move.l  #600,d2              				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; transparent
                move.l  #300,d5              				; bytes/pixels*width / line;
                jsr     CreateObject

				lea		lives_obj,a6
				move.l	#3,d7
.make_shippies:	move.l	a0,(a6)
				move.l	#playership_bmp,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #24,d1                  			; height
				move.l	#(24*2)*3,d2						; bytes to next line (phrase align)
				move.w	#4,d3								; 16 bt
				move.w	#1,d4								; transparent
				move.w	#24*2,d5							; bytes to next line (phrase)
				movem.l	d7/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d7/a6
				lea		4(a6),a6
				dbra	d7,.make_shippies

				move.l	a0,display_obj						; store object address in table
				move.l	#display_bmp0,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #18,d1 	                 			; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
                jsr     CreateObject
				
				move.l	a0,sideobj
				move.l	#bonus_bmp+((16*2*16)*19),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #16*2,d2             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#16*2,d5
                jsr     CreateObject
				
				move.l	a0,lasrobj
				move.l	#bonus_bmp+((16*2*16)*2),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #16*2,d2	           				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#16*2,d5
                jsr     CreateObject
				
				move.l	a0,bombobj
				move.l	#bonus_bmp+((16*2*16)*16),a1
				move.l  #bitmapobject,d0   					; type
                move.l  #16,d1 	                 			; height
                move.l  #16*2,d2	             			; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#16*2,d5
                jsr     CreateObject
				
				move.l	a0,shldobj
				move.l	#bonus_bmp+((16*2*16)*10),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #16*2,d2             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#16*2,d5
                jsr     CreateObject
									
				move.w	CONFIG,d6
				andi.w	#VIDTYPE,d6
				bne		.ntsc

				move.l	a0,botmask_obj						; create a mask object for top clipping
				move.l	#botpanel_bmp,a1
				move.l  #bitmapobject,d0        			; type
				move.l  #32,d1                  			; height
                move.l  #340*2,d2              				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
                move.l  #340*2,d5              				; bytes/pixels*width / line;
                jsr     CreateObject

				movem.l	d0-d7/a0-a6,-(a7)
				move.l	botmask_obj,a0
				move.l	#10,d0
				move.l	#255,d1
				bsr		setup_object_xy
				movem.l	(a7)+,d0-d7/a0-a6
				
.ntsc:          moveq.l #stopobject,d0          			; STOP Object
                jsr     CreateObject
				
;;
;; Fix up wave branch pointers
;;

				lea		w1_branch_add,a6
				moveq	#4,d7
.fixup:			move.l	4(a6),d0
				move.l	d0,d1
				add.l	#32*max_enemies1,d1
				sub.l	#ob_list1,d0
				sub.l	#ob_list1,d1
				add.l	#ob_list,d0
				add.l	#ob_list,d1
				and.l	#$fffffff8,d0
				and.l	#$fffffff8,d1
				lsl.l	#5,d0
				lsl.l	#5,d1
				move.l	d0,4(a6)					; branch not taken
				move.l	d1,8(a6)					; branch taken
				lea		12(a6),a6
				dbra	d7,.fixup
				
                rts
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy Object List Routine
;;

copy_olist:
				move.l	#ob_list,A1_BASE
				move.l	#$0,A1_PIXEL
				move.l	#PIXEL16|XADDPHR|PITCH1,A1_FLAGS
				move.l	#ob_list1,A2_BASE
				move.l	#$0,A2_PIXEL
				move.l	#PIXEL16|XADDPHR|PITCH1,A2_FLAGS
				move.w	#1,d0
				swap	d0
				move.w	#$2000/2,d0
				move.l	d0,B_COUNT
				move.l	#LFU_REPLACE|SRCEN,B_CMD
				rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Build a header that'll STOP if VPOS not on screen.
;;

build_header:   move.l  a0,d0               ; address if bra not taken
                sub.l   #ob_list1,d0        ;
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ; next BRA object
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00008003,4(a0)    ; bra if yp<0
                or.l    d0,2(a0)            ; link to next BRA
                lea     8(a0),a0            ;
                bsr     stopob              ; write stop object (before top)
                lea     16(a0),a0           ; next object here

                move.l  a0,d0               ; calc address of 1st actual
                sub.l   #ob_list1,d0        ; object (after the next STOP)
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ;
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00004003,4(a0)    ; bra is yp>value
                or.l    d0,2(a0)            ; link to first object!

				move.w	CONFIG,d6
				andi.w	#VIDTYPE,d6
				beq		.pal
				move.l	#492,d0				; 492 lines = full NTSC frame
				bra		.ntsc
.pal:			move.l	#580,d0				; 580 lines = full PAL frame
;				move.l	#492,d0
.ntsc:          lsl.l   #3,d0               ;
                or.l    d0,4(a0)            ;
                lea     8(a0),a0            ; next object
                bsr     stopob              ; is a STOP
				lea     16(a0),a0           ; address for next REAL object

                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Simple Object List Routines for a simple life.
;;
;; call with *d0=object type
;;           *d1=height
;;           *d2=data width
;;           *d3=colour depth
;;           *d4=transparent
;;           *d5=image width
;;           *a0=address of object (phrase alligned)
;;           *a1=address for GFX   (phrase alligned)
;;
;; exit with object built
;;           link=object address+32
;;           scaled objects will *NOT* be 1:1 in x/y
;;           x/y positions will be -500,2 (off screen)
;;

CreateObject:   lsl.w   #2,d0                   ; object type
                move.l  jmp_tab(pc,d0),a6       ; get routine address
                jmp (a6)                        ; call it!

jmp_tab:        .dc.l bitmp                     ; jump table
                .dc.l scaled
                .dc.l gpuob
                .dc.l braob
                .dc.l stopob

bitmp:          clr.l   (a0)                    ; template
                clr.l   4(a0)                   ;
                clr.l   8(a0)                   ;
                move.l  #$00008000,12(a0)       ;
                move.l  a0,d0                   ; link address
                sub.l   #ob_list1,d0            ;
                add.l   #ob_list,d0             ;
                add.l   #32,d0                  ;
                and.b   #%11111000,d0           ;
                lsl.l   #5,d0                   ;
                or.l    d0,2(a0)                ;
                move.l  a1,d0                   ; gfx address
                lsl.l   #8,d0                   ;
                or.l    d0,(a0)                 ;
                move.l  d1,d0                   ; height
                swap    d0                      ;
                lsr.l   #2,d0                   ;
                or.l    d0,4(a0)                ;
                ror.w   #1,d4                   ; transparency
                or.w    d4,10(a0)               ;
                lsl.w   #8,d3                   ; depth (colour depth)
                lsl.w   #4,d3                   ;
                or.w    d3,14(a0)               ;
                lsr.w   #3,d2                   ; data width
                swap    d2                      ;
                lsl.l   #2,d2                   ;
                or.l    d2,12(a0)               ;
                lsr.w   #3,d5                   ; image width
                swap    d5                      ;
                lsr.l   #4,d5                   ;
                or.l    d5,10(a0)               ;
                move.w  #-500,d0                ; x-pos
                and.w   #$fff,d0
                or.w    d0,14(a0)
                or.w    #2*8,6(a0)              ; y-pos
                lea     32(a0),a0               ; BITMAP object!
                rts

scaled:         bsr     bitmp                   ; same as bitmap
                move.l  #$0,-16(a0)             ; clear it out
                move.l  #%00000000000000000100000001000000,-12(a0)
                or.l    #$1,-28(a0)             ; SCALED object!
                rts

gpuob:          move.l  #0,(a0)+
                move.l  #$3ffa,(a0)+            ; GPU object!
                rts

				
; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN
				
braob:          add     d2,d2                   ; mult y-pos
                bsr     branchobject            ; make the object
make8into32:    move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     24(a0),a1               ; a BRA+16 object
                bsr     branchobject            ;
                lea     16(a0),a0               ;
                rts

branchobject:   clr.l   (a0)
                move.l  #3,4(a0)
                add.w   d1,d1
                move.w  branchtypes(pc,d1.w),d1
                or.w    d1,6(a0)                ; branch TYPE!
                move.l  a1,d0
                sub.l   #ob_list1,d0
                add.l   #ob_list,d0
                and.l   #$fffffff8,d0
                lsl.l   #5,d0                   ; Link if branch **TAKEN!**
                move.l  d0,2(a0)                ; (< & > swapped!)
                lsl.w   #3,d2                   ; scanline to branch on
                or.w    d2,6(a0)                ; is VC/2
                lea     8(a0),a0                ; next object
                rts

branchtypes:    .dc.w    $4000,$8000,$0000       ; 

stopob:         move.l  #0,(a0)+
                move.l  #4,(a0)+                ; STOP object!
                rts
				
				
				