;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; pause mode
;;

pause_mode:
				jsr		musicplayer+$20		; kill music
				jsr		wait_frame
				
				move.l	$1008,a0
				add.l	#dubmood1_off,a0
				jsr     musicplayer+4
				
				move.l	$1008,a0
				add.l	#badmood_off,a0
				lea		$0,a1
				move.l	#badmood_len,d0	; sample length
				moveq	#0,d1			; looplength (unlooped)
				moveq	#40,d2			; priority (high)
				move.l	$1104,d3		; volume
				moveq	#0,d4			; freq
				jsr		musicplayer+$c	
				
				jsr		wait_frame
				
				lea		ol_buffer,a1
				move.l	underlay_obj,a0			; 1st object
				move.l	#((32*15)/4)-1,d7
.saveit:		move.l	(a0)+,(a1)+
				dbra	d7,.saveit
				
				lea		$f00400,a0
				move.l	#127,d7
.savepal:		move.l	(a0)+,(a1)+
				dbra	d7,.savepal
							
				lea		$f00400,a0							; install pallette
				move.w	#0,(a0)+							; C000=black
				move.w	#254,d7								; C001-255=white
.pal:			move.w	#$ffff,(a0)+
				dbra	d7,.pal
				lea		woodstop_pal,a1
				movem.l	(a1),d0-d7
				movem.l	d0-d7,$f00400+32
				move.w	d1,BG
				
				move.l	underlay_obj,a0
				move.l	#woodstop_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #33,d1 	                 			; height
                move.l  #208/2,d2             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#208/2,d5
                jsr     CreateObject	
				move.l	underlay_obj,a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0000001000000000,10(a1)	; or in next index (Pal 1)
				
				move.l	a0,quote_obj
				move.l	#quote_bmp,a1
                move.l  #bitmapobject,d0        			; type
                move.l  #8,d1 	                 			; height
                move.l  #40,d2           					; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5								; 40 bytes wide
                jsr     CreateObject
				move.l	quote_obj,a1
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	#%0001111000000000,10(a1)	; or in next index (Pal 15)
				
				move.w	#$ffff,$f00400+(15*32)+2
				
				bsr		badmood_init
				
				moveq.l #stopobject,d0          			; STOP Object
                jsr     CreateObject

				move.l	underlay_obj,a0
				move.l	#20+58,d0
				move.l	#32+90,d1
				jsr		setup_object_xy

				move.l	quote_obj,a0
				move.l	#20,d0
				move.l	#219,d1
				jsr		setup_object_xy
				
				bsr		.long_delay

				move.l	#1,do_pause_scroller
				
				move.w	#50*30,pause_ticker
				
.pause_mode_loop:
				bsr		wait_frame

				jsr		readpad								; read jagpad
				jsr		handle_input
				
				bsr		moodies_loop
								
				tst.w	pause_ticker
				bpl.s	.pause_hold
				
				move.w	#50*30,pause_ticker
				
				tst.l	life_energy
				beq.s	.skip
				bmi.s	.skip
				sub.l	#1,life_energy
.skip:
				move.l	$1008,a0
				add.l	#shield_reduction_off,a0
				lea		$0,a1
				move.l	#shield_reduction_len,d0	; sample length
				moveq	#0,d1			; looplength (unlooped)
				moveq	#40,d2			; priority (high)
				move.l	$1104,d3		; volume
				moveq	#0,d4			; freq
				jsr		musicplayer+$c					
								
.pause_hold:	tst.w	PAUSE_ON
				bne		.pause_mode_loop

				bsr		.long_delay
				
				move.l	#-1,do_pause_scroller
				
				jsr		wait_frame
				lea		ol_buffer,a1
				move.l	underlay_obj,a0			; 1st object
				move.l	#((32*15)/4)-1,d7
.loadit:		move.l	(a1)+,(a0)+
				dbra	d7,.loadit
				
				lea		$f00400,a0
				move.l	#127,d7
.loadpal:		move.l	(a1)+,(a0)+
				dbra	d7,.loadpal

				move.w	#0,BG
				
				moveq	#1,d0
				moveq	#8,d1
				jsr		musicplayer+$10

				move.l	$1008,a0
				add.l	#alerted_mod_off,a0
				jsr     musicplayer+4
				
				rts
				
.long_delay:	move.l	#20000,d7
.delay:			eor.l	d0,d1
				subq	#1,d7
				bne.s	.delay
				rts

pause_scroller:
				move.w #0,d4
.faster:		subq.w #1,.scrl
				bne.s .go_scrl

.get2:			move.w 	#7,.scrl
				moveq.l #0,d1
				move.l 	scrolltxt_ptr,a0

.back:			move.b 	(a0)+,d1
				bpl.s	.next

.wrap:			
;				bsr		random_quote
				lea 	intro_text(pc),a0
				move.b	(a0)+,d1

.next:			move.l	a0,scrolltxt_ptr
				sub.b	#' ',d1

.next_ch:		asl 	#2,d1
				lea 	ascii,a1
				move.l 	(a1,d1),a0	

				lea .chbuff,a1
				moveq.l #7,d5

.fillbuf:		move.b (a0),(a1)
				lea		2(a1),a1
				lea 	40(a0),a0
				dbra 	d5,.fillbuf

.go_scrl:		lea 	.chbuff,a0
				lea		quote_bmp,a1
				moveq	#7,d2
.rows:			lsl.w (a0)+
				roxl.w 38(a1)
				roxl.w 36(a1)
				roxl.w 34(a1)
				roxl.w 32(a1)
				roxl.w 30(a1)
				roxl.w 28(a1)
				roxl.w 26(a1)
				roxl.w 24(a1)
				roxl.w 22(a1)
				roxl.w 20(a1)
				roxl.w 18(a1)
				roxl.w 16(a1)
				roxl.w 14(a1)
				roxl.w 12(a1)
				roxl.w 10(a1)
				roxl.w 8(a1)
				roxl.w 6(a1)
				roxl.w 4(a1)
				roxl.w 2(A1)
				roxl.w (A1)
				lea		40(a1),a1
				dbra d2,.rows
				dbra d4,.faster
.outg:			rts

.scrl:			dc.w 1
.chbuff:		dc.w 0,0,0,0,0,0,0,0,0,0,0,0

;random_quote:	move.l	d0,-(a7)
;
;.another:		move.w	ticks,d0
;				add.w	$f00006,d0
;				add.w	$f00004,d0
;
;				divu	#29,d0
;				swap.w	d0
;				cmp.w	last_quote,d0
;				beq.s	.another
;				and.l	#%11111,d0
;				move.w	d0,last_quote
;				
;				add.w	d0,d0
;				add.w	d0,d0
;				lea		quotes_list,a0
;				move.l	(a0,d0.w),a0			
;
;				move.l	(a7)+,d0
;				rts

pause_ticker:	dc.w	0
last_quote:		dc.w	0
do_pause_scroller:	dc.l	-1
scrolltxt_ptr:	dc.l	intro_text

intro_text:		dc.b 	"   Hello and welcome to bAd M0oD1e5! - a mad, crazy pause mode where we "
				dc.b	"explore the possibilities of merging three different games into one. Yes, yes "
				dc.b	"its a really stupid idea that's recently been tried, but we promise you that our "
				dc.b	"version is fun!     "
				dc.b	"So, what is this crazy game?  Ok here's how it works (see guys? instructions HELP "
				dc.b	"people... unless you were hiding logic bugs?)   "
				dc.b	"Shoot the Invader_ to generate food for the snake, and clear the cycle maze. After the snake grows to 25 long a bonus will appear "
				dc.b	"in the Cycles game, collect this and that bonus is granted back in Project One, crash and "
				dc.b	"you have to get more feeds of the snake for another one.  Oh and each time you shoot "
				dc.b	"the invader, the screen swaps direction. Easy eh?     "
				dc.b	"Oh, and we forgot to mention... even though this is PAUSE MODE... we were in a Bad Moodie(tm) "
				dc.b	"when we created it, so for every 30 seconds without pad input, you lose one point of shield. "
				dc.b	"So - RUN to the toilet!! RUN! Faster! Faster!       And now some words from our sponsors....                  "
				dc.b	"BUY BUY BUY!!!!!     WHILE STOCKS LAST!!!!!      NEW GAMES!!!!!!!!!!!!"
				DC.B "             OUR CAPSLOCK KEY JUST BROKE!!!!!!           SERIOUSLY NOW, "
				DC.B "THE JAGUAR SCENE IS IN FOR A REAL TREAT, ONCE WE GET RID OF THE PIRATES AND ROMZ "
				DC.B "SITES AND THOSE IMMORAL PEOPLE. WHAT, DO YOU THINK WE'RE GOING TO RELEASE ANYTHING "
				DC.B " WHILE ALL THOSE BAD PEOPLE ARE AROUND? NOOOOO! WE'RE GOING TO WAIT. EVEN IF IT "
				DC.B "MEANS THAT OUR GRANDCHILDEN WILL RELEASE THESE. THE POINT IS THAT YOU *ARE* "
				DC.B "GOING TO EXPERIENCE ONLY THE BEST IN YOUR JAGUAR. FAST PACED GAMES, FULL OF"
				DC.B "EXPLODING GPU IN MAIN ACTION, MORE THAN 5 SPRITES MOVING ON-SCREEN AT THE SAME "
				DC.B " TIME (AMAZING, RIGHT?), AND LAST BUT NOT LEAST, BLATANT USE OF THE EXCLAMATION "
				DC.B "MARK!!!!!!!!!!!!  WE ARE A LEGITIMATE COMPANY, WITH YEARS OF JAGUAR EXPERIENCE "
				DC.B "(WE PLAYED MORE THAN 5 DAYS OF TEMPEST 2000, TRY TO TOP THAT!!!!), WE AND "
				DC.B "ONLY WE HOLD THE KEYS TO THE INNER MOST SECRETS OF THE JAGUAR. FOR EXAMPLE, "
				DC.B "DID YOU KNOW THAT THE JAGUAR HAS A FOURTH PROCESSOR INSIDE THAT NO ONE EVEN "
				DC.B "KNOWS IT EXISTS, AND BY TAPPING ON ITS POWER, WE CAN HAVE BETTER PERFORMANCE THAN "
				DC.B "EVEN THE PLAYSTATION???? YES, WE GOT STUFF IN STORE THAT WILL TURN YOUR HAIR "
				DC.B "WHITE. LISTED BELOW ARE ONLY SOME OF THE GAMES WE'LL BE RELEASING (EVENTUALLY) "
				DC.B "WHICH WE SWEAR ARE NOT RIPPED OR PORTED (SCOUTS HONOR!): MAD CUBERT, "
				DC.B "MAD POLE POSITION, MAD DONKEY, MAD KONG, MAD RALLY, MAD X, MAD MAXIMILLIAN, "
				DC.B "MAD WORLD, MAD PIES.... YES, WE'RE MAD, MAAAAAD I TELL YOU!!!!!!! SO, WATCH "
				DC.B "OUT ON YOUR FAVORITE JAG FORUM AND DON'T FORGET TO SIGN UP WITH A LEGITIMATE "
				DC.B "E-MAIL ADDRESS, MAKE 100 POSTS AND PAY $49.9999 TO GET ACCESS TO EXCLUSIVE STUFF "
				DC.B "AS WELL AS BEING ABLE TO BUY OUR HOT GAMES!!!!! SIGNED, YOUR FAVORITE JAG"
				DC.B "DEVELOPERS.........  Right, caps mode off :) Your head must be either spinning "
				DC.B "right now, or maybe no one will reach this point of the scroller ever, so we might "
				DC.B "just as well end this scroller here.... Reboot WILL be back soon!!!               "
				DC.B -1
				even


				dc.b "Right, this is past the end of the scroller bit. Since we still have lots of bytes to burn till the ROM file is full, I suppose we can spare a few wasted ones. It's the 3rd of September 2009 and Reboot is absolutely fucked off right now! All the pressure from the community and our personal lives is starting to be too much... So I guess we'll release it today before we shelve the fucking thing :). I must say, it's been 3 very intense months which built up to a very dramatic last week. Reboot started just for producing fun stuff that we first of all enjoy. For various reasons a huge dose of politics was added and to be honest, we're all fucking sick of it! We'll take a break from the Jaguar for some time to gather our strengths back. But we'll definitely return. Till then, don't bother us, our ears have gone deaf. Promethea signing off........"
;quotes_list:	dc.l	q0,q1,q2,q3,q4,q5,q6,q7
;				dc.l	q8,q9,q10,q11,q12,q13,q14,q15
;				dc.l	q16,q17,q18,q19,q20,q21,q22,q23
;				dc.l	q24,q25,q26,q27,q28,q29,q30
;				dc.l	q30									; need 32 entries
;															; can be more not a problem
;				
;q0:				dc.b    "        Morden: "
;				dc.b 	" Not having Gorf involved speeded up"
;				dc.b 	" development by 700% ",-1
;				even
;				
;q1:				dc.b	"        Gorf: "
;				dc.b	" I still find this hard after 13 years",-1
;				even
;				
;q2:				dc.b	"        Thou Shalt Not:"
;				dc.b	" Use the GPU out of local",-1
;				even
;				
;q3:				dc.b	"        Thou Shalt Not:"
;				dc.b	" Take seven years to code a shitty game",-1
;				even
;				
;q4:				dc.b 	"        Thou Shalt Not:"
;				dc.b	" Use your anti-piracy mudflaps for evil",-1
;				even
;				
;q5:				dc.b	"        Thou Shalt Not:"
;				dc.b	" Ban links to AA and claim free speech",-1
;				even
;				
;q6:				dc.b	"        Thou Shalt Not:"
;				dc.b	" Use unlubed Jaguar gamepads analy",-1
;				even
;				
;q7:				dc.b	"        Thou Shalt Not:"
;				dc.b	" Forget to feed your high horse",-1
;				even
;				
;q8:				dc.b	"        Jaguar Sector II:"
;				dc.b	" Because the mental wards are full",-1
;				even
;
;q9:				dc.b  	"        Thunderbird: (by Gerry Anderson)"
;				dc.b	" You're not supposed to take someone"
;				dc.b	" else's name in your products",-1
;				even
;				
;q10:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Say the Jaguar is hard to code on",-1
;				even
;				
;q11:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Pretend BSG is the 2nd coming of Jesus",-1
;				even
;				
;q12:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Demand everyone stop using the 68000"
;				dc.b	" & not provide a workable solution",-1
;				even
;				
;q13:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Port STOS to the Jaguar",-1
;				even
;				
;q14:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Complain about (c) infringement whilst"
;				dc.b	" cheering on stealing Nintendo IPs",-1 
;				even
;				
;q15:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Pay for Public Domain quality games",-1
;				even
;				
;q16:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" YouTube shitty quality videos",-1
;				even
;				
;q17:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Defend Supercross 3FPS in any way",-1
;				even
;				
;q18:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Be insulting or degrading to clouds"
;				dc.b	" or sunsets",-1
;				even
;				
;q19:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Pay more than $80 for BadModies",-1
;				even
;				
;q20:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Ship a game with no manual to hide"
;				dc.b	" logic bugs in the game",-1
;				even
;				
;q21:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Stick Ultra Vortek posters to a wall"
;				dc.b	" (Without glue....)",-1
;				even
;				
;q22:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Use the groinal attachments of the"
;				dc.b	" Jaguar kiosks",-1
;				even
;				
;q23:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Use anything other than General MIDI"
;				dc.b	" for in game music",-1
;				even
;				
;q24:			dc.b  	"        Thou Shalt Not:"
;				dc.b	" Use more than one frame of animation"
;				dc.b	" for a planet",-1
;				even
;				
;q25:			dc.b  	"        Gorf: (about Ethernet Flash)"
;				dc.b	" That cart of yours rocks dude...."
;				dc.b	" I am very interested in one...",-1
;				even
;
;q26:			dc.b  	"        Gorf: (about JagCF)"
;				dc.b	" You are a bunch of scummy pirates",-1
;				even
;				
;q27:			dc.b	"        Thou Shalt Not:"
;				dc.b	" Sell other people's copyrights"
;				dc.b	" indirectly via subscriptions",-1
;				even
;				
;q28:			dc.b	"        Thou Shalt Not:"
;				dc.b    " Consider modifying your MAC address"
;				dc.b	" or the internet may break",-1
;				even
;
;q29:			dc.b	"        Now you've downloaded this from FJP"
;				dc.b    " your free of The Gorfian Empire's"
;				dc.b	" CrapWare via a blacklist!",-1
;				even
;				
;q30:			dc.b	"        Thou Shalt Not:"
;				dc.b    " Steal scene music to sell in your"
;				dc.b	" game and then lie about it.",-1
;				even
				
quote_obj:		dc.l	0

				.phrase
quote_bmp:		
				.rept	(40*9)
				dc.b	0
				.endr

ol_buffer:		
				rept 	(32*16)+512
				dc.b 	0
				endr
				